/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>BWC Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getBWCType()
 * @model extendedMetaData="name='BWC_._type'"
 * @generated
 */
public enum BWCType implements Enumerator {
	/**
	 * The '<em><b>No Dma Engine Stalls</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_DMA_ENGINE_STALLS_VALUE
	 * @generated
	 * @ordered
	 */
	NO_DMA_ENGINE_STALLS(0, "NoDmaEngineStalls", "NoDmaEngineStalls"),

	/**
	 * The '<em><b>Stalls4 Cycles</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STALLS4_CYCLES_VALUE
	 * @generated
	 * @ordered
	 */
	STALLS4_CYCLES(1, "Stalls4Cycles", "Stalls4Cycles"),

	/**
	 * The '<em><b>Stalls8 Cycles</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STALLS8_CYCLES_VALUE
	 * @generated
	 * @ordered
	 */
	STALLS8_CYCLES(2, "Stalls8Cycles", "Stalls8Cycles");

	/**
	 * The '<em><b>No Dma Engine Stalls</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Dma Engine Stalls</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_DMA_ENGINE_STALLS
	 * @model name="NoDmaEngineStalls"
	 * @generated
	 * @ordered
	 */
	public static final int NO_DMA_ENGINE_STALLS_VALUE = 0;

	/**
	 * The '<em><b>Stalls4 Cycles</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Stalls4 Cycles</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STALLS4_CYCLES
	 * @model name="Stalls4Cycles"
	 * @generated
	 * @ordered
	 */
	public static final int STALLS4_CYCLES_VALUE = 1;

	/**
	 * The '<em><b>Stalls8 Cycles</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Stalls8 Cycles</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STALLS8_CYCLES
	 * @model name="Stalls8Cycles"
	 * @generated
	 * @ordered
	 */
	public static final int STALLS8_CYCLES_VALUE = 2;

	/**
	 * An array of all the '<em><b>BWC Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final BWCType[] VALUES_ARRAY =
		new BWCType[] {
			NO_DMA_ENGINE_STALLS,
			STALLS4_CYCLES,
			STALLS8_CYCLES,
		};

	/**
	 * A public read-only list of all the '<em><b>BWC Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<BWCType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>BWC Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static BWCType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BWCType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>BWC Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static BWCType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			BWCType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>BWC Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static BWCType get(int value) {
		switch (value) {
			case NO_DMA_ENGINE_STALLS_VALUE: return NO_DMA_ENGINE_STALLS;
			case STALLS4_CYCLES_VALUE: return STALLS4_CYCLES;
			case STALLS8_CYCLES_VALUE: return STALLS8_CYCLES;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private BWCType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //BWCType
