/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CHANNEL Type1</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.CHANNELType1#getChannelMode <em>Channel Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType1#getHWChannel <em>HW Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType1#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType1#getNotification <em>Notification</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType1#getWakeupRef <em>Wakeup Ref</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1()
 * @model extendedMetaData="name='CHANNEL_._1_._type' kind='empty'"
 * @generated
 */
public interface CHANNELType1 extends EObject {
	/**
	 * Returns the value of the '<em><b>Channel Mode</b></em>' attribute.
	 * The default value is <code>"GPT_MODE_ONESHOT"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.GptChannelModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the behaviour of the timerchannel after the timeout has expired.Select desired channel mode.
	 * 
	 * GptModeOneshot : Timer channel stops after reaching its timeout period value.
	 * 
	 * GptModeContinuous: Timer channel is restarted automatically after reaching timeout period value.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Channel Mode</em>' attribute.
	 * @see SystemSparcClockMcu.GptChannelModeType
	 * @see #isSetChannelMode()
	 * @see #unsetChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1_ChannelMode()
	 * @model default="GPT_MODE_ONESHOT" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='ChannelMode' namespace='##targetNamespace'"
	 * @generated
	 */
	GptChannelModeType getChannelMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getChannelMode <em>Channel Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Channel Mode</em>' attribute.
	 * @see SystemSparcClockMcu.GptChannelModeType
	 * @see #isSetChannelMode()
	 * @see #unsetChannelMode()
	 * @see #getChannelMode()
	 * @generated
	 */
	void setChannelMode(GptChannelModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getChannelMode <em>Channel Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetChannelMode()
	 * @see #getChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @generated
	 */
	void unsetChannelMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType1#getChannelMode <em>Channel Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Channel Mode</em>' attribute is set.
	 * @see #unsetChannelMode()
	 * @see #getChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @generated
	 */
	boolean isSetChannelMode();

	/**
	 * Returns the value of the '<em><b>HW Channel</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.PitHWChannelType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Selects the physical GPT Channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>HW Channel</em>' attribute.
	 * @see SystemSparcClockMcu.PitHWChannelType
	 * @see #isSetHWChannel()
	 * @see #unsetHWChannel()
	 * @see #setHWChannel(PitHWChannelType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1_HWChannel()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='HWChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	PitHWChannelType getHWChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getHWChannel <em>HW Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>HW Channel</em>' attribute.
	 * @see SystemSparcClockMcu.PitHWChannelType
	 * @see #isSetHWChannel()
	 * @see #unsetHWChannel()
	 * @see #getHWChannel()
	 * @generated
	 */
	void setHWChannel(PitHWChannelType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getHWChannel <em>HW Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetHWChannel()
	 * @see #getHWChannel()
	 * @see #setHWChannel(PitHWChannelType)
	 * @generated
	 */
	void unsetHWChannel();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType1#getHWChannel <em>HW Channel</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>HW Channel</em>' attribute is set.
	 * @see #unsetHWChannel()
	 * @see #getHWChannel()
	 * @see #setHWChannel(PitHWChannelType)
	 * @generated
	 */
	boolean isSetHWChannel();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * GPT channel identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1_Name()
	 * @model dataType="SystemSparcClockMcu.NameType34" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Notification</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Function pointer to callback function.
	 * Use NULL_PTR if no callback is needed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Notification</em>' attribute.
	 * @see #setNotification(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1_Notification()
	 * @model dataType="SystemSparcClockMcu.NotificationType3" required="true"
	 *        extendedMetaData="kind='attribute' name='Notification' namespace='##targetNamespace'"
	 * @generated
	 */
	String getNotification();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getNotification <em>Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Notification</em>' attribute.
	 * @see #getNotification()
	 * @generated
	 */
	void setNotification(String value);

	/**
	 * Returns the value of the '<em><b>Wakeup Ref</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enables wakeup capability of CPU for a channel when timeout period expires.
	 * 
	 * If any value is set GptEnableWakeup is set to TRUE. If the wakeup capability is not needed for the respective channel leave the attribute empty.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Wakeup Ref</em>' attribute.
	 * @see #isSetWakeupRef()
	 * @see #unsetWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType1_WakeupRef()
	 * @model default="0" unsettable="true" dataType="SystemSparcClockMcu.WakeupRefType2"
	 *        extendedMetaData="kind='attribute' name='WakeupRef' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getWakeupRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getWakeupRef <em>Wakeup Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Wakeup Ref</em>' attribute.
	 * @see #isSetWakeupRef()
	 * @see #unsetWakeupRef()
	 * @see #getWakeupRef()
	 * @generated
	 */
	void setWakeupRef(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType1#getWakeupRef <em>Wakeup Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetWakeupRef()
	 * @see #getWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @generated
	 */
	void unsetWakeupRef();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType1#getWakeupRef <em>Wakeup Ref</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Wakeup Ref</em>' attribute is set.
	 * @see #unsetWakeupRef()
	 * @see #getWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @generated
	 */
	boolean isSetWakeupRef();

} // CHANNELType1
