/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CHANNEL Type2</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getChannelType <em>Channel Type</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getDataWidth <em>Data Width</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getDefaultData <em>Default Data</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getEbMaxLength <em>Eb Max Length</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getIbNBuffers <em>Ib NBuffers</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CHANNELType2#getTransferStart <em>Transfer Start</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2()
 * @model extendedMetaData="name='CHANNEL_._2_._type' kind='empty'"
 * @generated
 */
public interface CHANNELType2 extends EObject {
	/**
	 * Returns the value of the '<em><b>Channel Type</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.ChannelTypeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Buffer usage with:
	 * EB - external buffer
	 * IB - internal buffer.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Channel Type</em>' attribute.
	 * @see SystemSparcClockMcu.ChannelTypeType
	 * @see #isSetChannelType()
	 * @see #unsetChannelType()
	 * @see #setChannelType(ChannelTypeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_ChannelType()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='ChannelType' namespace='##targetNamespace'"
	 * @generated
	 */
	ChannelTypeType getChannelType();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getChannelType <em>Channel Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Channel Type</em>' attribute.
	 * @see SystemSparcClockMcu.ChannelTypeType
	 * @see #isSetChannelType()
	 * @see #unsetChannelType()
	 * @see #getChannelType()
	 * @generated
	 */
	void setChannelType(ChannelTypeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getChannelType <em>Channel Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetChannelType()
	 * @see #getChannelType()
	 * @see #setChannelType(ChannelTypeType)
	 * @generated
	 */
	void unsetChannelType();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getChannelType <em>Channel Type</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Channel Type</em>' attribute is set.
	 * @see #unsetChannelType()
	 * @see #getChannelType()
	 * @see #setChannelType(ChannelTypeType)
	 * @generated
	 */
	boolean isSetChannelType();

	/**
	 * Returns the value of the '<em><b>Data Width</b></em>' attribute.
	 * The default value is <code>"8"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is the width of a transmitted data unit.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Data Width</em>' attribute.
	 * @see #isSetDataWidth()
	 * @see #unsetDataWidth()
	 * @see #setDataWidth(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_DataWidth()
	 * @model default="8" unsettable="true" dataType="SystemSparcClockMcu.DataWidthType"
	 *        extendedMetaData="kind='attribute' name='DataWidth' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDataWidth();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDataWidth <em>Data Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Width</em>' attribute.
	 * @see #isSetDataWidth()
	 * @see #unsetDataWidth()
	 * @see #getDataWidth()
	 * @generated
	 */
	void setDataWidth(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDataWidth <em>Data Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDataWidth()
	 * @see #getDataWidth()
	 * @see #setDataWidth(BigInteger)
	 * @generated
	 */
	void unsetDataWidth();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDataWidth <em>Data Width</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Data Width</em>' attribute is set.
	 * @see #unsetDataWidth()
	 * @see #getDataWidth()
	 * @see #setDataWidth(BigInteger)
	 * @generated
	 */
	boolean isSetDataWidth();

	/**
	 * Returns the value of the '<em><b>Default Data</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is the default value to transmit.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Default Data</em>' attribute.
	 * @see #isSetDefaultData()
	 * @see #unsetDefaultData()
	 * @see #setDefaultData(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_DefaultData()
	 * @model default="1" unsettable="true" dataType="SystemSparcClockMcu.DefaultDataType"
	 *        extendedMetaData="kind='attribute' name='DefaultData' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDefaultData();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDefaultData <em>Default Data</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Data</em>' attribute.
	 * @see #isSetDefaultData()
	 * @see #unsetDefaultData()
	 * @see #getDefaultData()
	 * @generated
	 */
	void setDefaultData(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDefaultData <em>Default Data</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDefaultData()
	 * @see #getDefaultData()
	 * @see #setDefaultData(BigInteger)
	 * @generated
	 */
	void unsetDefaultData();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getDefaultData <em>Default Data</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Default Data</em>' attribute is set.
	 * @see #unsetDefaultData()
	 * @see #getDefaultData()
	 * @see #setDefaultData(BigInteger)
	 * @generated
	 */
	boolean isSetDefaultData();

	/**
	 * Returns the value of the '<em><b>Eb Max Length</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the maximum size of data buffers in case of EB Channels and only.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Eb Max Length</em>' attribute.
	 * @see #isSetEbMaxLength()
	 * @see #unsetEbMaxLength()
	 * @see #setEbMaxLength(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_EbMaxLength()
	 * @model default="1" unsettable="true" dataType="SystemSparcClockMcu.EbMaxLengthType"
	 *        extendedMetaData="kind='attribute' name='EbMaxLength' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getEbMaxLength();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getEbMaxLength <em>Eb Max Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Eb Max Length</em>' attribute.
	 * @see #isSetEbMaxLength()
	 * @see #unsetEbMaxLength()
	 * @see #getEbMaxLength()
	 * @generated
	 */
	void setEbMaxLength(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getEbMaxLength <em>Eb Max Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetEbMaxLength()
	 * @see #getEbMaxLength()
	 * @see #setEbMaxLength(BigInteger)
	 * @generated
	 */
	void unsetEbMaxLength();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getEbMaxLength <em>Eb Max Length</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Eb Max Length</em>' attribute is set.
	 * @see #unsetEbMaxLength()
	 * @see #getEbMaxLength()
	 * @see #setEbMaxLength(BigInteger)
	 * @generated
	 */
	boolean isSetEbMaxLength();

	/**
	 * Returns the value of the '<em><b>Ib NBuffers</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the maximum number of data buffers in case of IB Channels and only.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Ib NBuffers</em>' attribute.
	 * @see #isSetIbNBuffers()
	 * @see #unsetIbNBuffers()
	 * @see #setIbNBuffers(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_IbNBuffers()
	 * @model default="1" unsettable="true" dataType="SystemSparcClockMcu.IbNBuffersType"
	 *        extendedMetaData="kind='attribute' name='IbNBuffers' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getIbNBuffers();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getIbNBuffers <em>Ib NBuffers</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ib NBuffers</em>' attribute.
	 * @see #isSetIbNBuffers()
	 * @see #unsetIbNBuffers()
	 * @see #getIbNBuffers()
	 * @generated
	 */
	void setIbNBuffers(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getIbNBuffers <em>Ib NBuffers</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIbNBuffers()
	 * @see #getIbNBuffers()
	 * @see #setIbNBuffers(BigInteger)
	 * @generated
	 */
	void unsetIbNBuffers();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getIbNBuffers <em>Ib NBuffers</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Ib NBuffers</em>' attribute is set.
	 * @see #unsetIbNBuffers()
	 * @see #getIbNBuffers()
	 * @see #setIbNBuffers(BigInteger)
	 * @generated
	 */
	boolean isSetIbNBuffers();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI Channel identification name.
	 * 
	 * Note. This does not refer to SPI HW channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_Name()
	 * @model dataType="SystemSparcClockMcu.NameType24" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Transfer Start</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TransferStartType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines the first starting bit for transmission.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Transfer Start</em>' attribute.
	 * @see SystemSparcClockMcu.TransferStartType
	 * @see #isSetTransferStart()
	 * @see #unsetTransferStart()
	 * @see #setTransferStart(TransferStartType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCHANNELType2_TransferStart()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='TransferStart' namespace='##targetNamespace'"
	 * @generated
	 */
	TransferStartType getTransferStart();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getTransferStart <em>Transfer Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Transfer Start</em>' attribute.
	 * @see SystemSparcClockMcu.TransferStartType
	 * @see #isSetTransferStart()
	 * @see #unsetTransferStart()
	 * @see #getTransferStart()
	 * @generated
	 */
	void setTransferStart(TransferStartType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CHANNELType2#getTransferStart <em>Transfer Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTransferStart()
	 * @see #getTransferStart()
	 * @see #setTransferStart(TransferStartType)
	 * @generated
	 */
	void unsetTransferStart();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CHANNELType2#getTransferStart <em>Transfer Start</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Transfer Start</em>' attribute is set.
	 * @see #unsetTransferStart()
	 * @see #getTransferStart()
	 * @see #setTransferStart(TransferStartType)
	 * @generated
	 */
	boolean isSetTransferStart();

} // CHANNELType2
