/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CLOCK Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getClkDivisor <em>Clk Divisor</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getClkOutput <em>Clk Output</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getClkSource <em>Clk Source</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getClockChangeTimeout <em>Clock Change Timeout</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getClockSrcFailureNotification <em>Clock Src Failure Notification</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getCpuClockFrequency <em>Cpu Clock Frequency</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getFmPllMonitor <em>Fm Pll Monitor</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getHighFrequencyRef <em>High Frequency Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getLowFrequencyRef <em>Low Frequency Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getQuartz <em>Quartz</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getRCDivisorFactor <em>RC Divisor Factor</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getRCOSCSelection <em>RCOSC Selection</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getXTalACounterOscillator <em>XTal ACounter Oscillator</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CLOCKType#getXTalB32KHzCounterOscillator <em>XTal B32K Hz Counter Oscillator</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType()
 * @model extendedMetaData="name='CLOCK_._type' kind='empty'"
 * @generated
 */
public interface CLOCKType extends EObject {
	/**
	 * Returns the value of the '<em><b>Clk Divisor</b></em>' attribute.
	 * The default value is <code>"DIV_1"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuClkDivisorType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter configures the factor by which the output clock is divided before being delivered.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clk Divisor</em>' attribute.
	 * @see SystemSparcClockMcu.McuClkDivisorType
	 * @see #isSetClkDivisor()
	 * @see #unsetClkDivisor()
	 * @see #setClkDivisor(McuClkDivisorType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_ClkDivisor()
	 * @model default="DIV_1" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Clk_Divisor' namespace='##targetNamespace'"
	 * @generated
	 */
	McuClkDivisorType getClkDivisor();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkDivisor <em>Clk Divisor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clk Divisor</em>' attribute.
	 * @see SystemSparcClockMcu.McuClkDivisorType
	 * @see #isSetClkDivisor()
	 * @see #unsetClkDivisor()
	 * @see #getClkDivisor()
	 * @generated
	 */
	void setClkDivisor(McuClkDivisorType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkDivisor <em>Clk Divisor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClkDivisor()
	 * @see #getClkDivisor()
	 * @see #setClkDivisor(McuClkDivisorType)
	 * @generated
	 */
	void unsetClkDivisor();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkDivisor <em>Clk Divisor</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clk Divisor</em>' attribute is set.
	 * @see #unsetClkDivisor()
	 * @see #getClkDivisor()
	 * @see #setClkDivisor(McuClkDivisorType)
	 * @generated
	 */
	boolean isSetClkDivisor();

	/**
	 * Returns the value of the '<em><b>Clk Output</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter enables/disables the output clock.
	 * 
	 * Note. The configured value of the McuClkDivisor and McuClkSource parameters will be written into the Output Clock Division Select Register only if McuClkOutput is enabled.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clk Output</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetClkOutput()
	 * @see #unsetClkOutput()
	 * @see #setClkOutput(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_ClkOutput()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Clk_Output' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getClkOutput();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkOutput <em>Clk Output</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clk Output</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetClkOutput()
	 * @see #unsetClkOutput()
	 * @see #getClkOutput()
	 * @generated
	 */
	void setClkOutput(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkOutput <em>Clk Output</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClkOutput()
	 * @see #getClkOutput()
	 * @see #setClkOutput(TypeBoolean)
	 * @generated
	 */
	void unsetClkOutput();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkOutput <em>Clk Output</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clk Output</em>' attribute is set.
	 * @see #unsetClkOutput()
	 * @see #getClkOutput()
	 * @see #setClkOutput(TypeBoolean)
	 * @generated
	 */
	boolean isSetClkOutput();

	/**
	 * Returns the value of the '<em><b>Clk Source</b></em>' attribute.
	 * The default value is <code>"Crystal"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuClkSourceType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter configures  the clock source for the output clock.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clk Source</em>' attribute.
	 * @see SystemSparcClockMcu.McuClkSourceType
	 * @see #isSetClkSource()
	 * @see #unsetClkSource()
	 * @see #setClkSource(McuClkSourceType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_ClkSource()
	 * @model default="Crystal" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Clk_Source' namespace='##targetNamespace'"
	 * @generated
	 */
	McuClkSourceType getClkSource();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkSource <em>Clk Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clk Source</em>' attribute.
	 * @see SystemSparcClockMcu.McuClkSourceType
	 * @see #isSetClkSource()
	 * @see #unsetClkSource()
	 * @see #getClkSource()
	 * @generated
	 */
	void setClkSource(McuClkSourceType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkSource <em>Clk Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClkSource()
	 * @see #getClkSource()
	 * @see #setClkSource(McuClkSourceType)
	 * @generated
	 */
	void unsetClkSource();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getClkSource <em>Clk Source</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clk Source</em>' attribute is set.
	 * @see #unsetClkSource()
	 * @see #getClkSource()
	 * @see #setClkSource(McuClkSourceType)
	 * @generated
	 */
	boolean isSetClkSource();

	/**
	 * Returns the value of the '<em><b>Clock Change Timeout</b></em>' attribute.
	 * The default value is <code>"100"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is used as timeout for internal loop while the clock / mode is changed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clock Change Timeout</em>' attribute.
	 * @see #isSetClockChangeTimeout()
	 * @see #unsetClockChangeTimeout()
	 * @see #setClockChangeTimeout(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_ClockChangeTimeout()
	 * @model default="100" unsettable="true" dataType="SystemSparcClockMcu.ClockChangeTimeoutType"
	 *        extendedMetaData="kind='attribute' name='Clock_Change_Timeout' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getClockChangeTimeout();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockChangeTimeout <em>Clock Change Timeout</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clock Change Timeout</em>' attribute.
	 * @see #isSetClockChangeTimeout()
	 * @see #unsetClockChangeTimeout()
	 * @see #getClockChangeTimeout()
	 * @generated
	 */
	void setClockChangeTimeout(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockChangeTimeout <em>Clock Change Timeout</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClockChangeTimeout()
	 * @see #getClockChangeTimeout()
	 * @see #setClockChangeTimeout(BigInteger)
	 * @generated
	 */
	void unsetClockChangeTimeout();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockChangeTimeout <em>Clock Change Timeout</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clock Change Timeout</em>' attribute is set.
	 * @see #unsetClockChangeTimeout()
	 * @see #getClockChangeTimeout()
	 * @see #setClockChangeTimeout(BigInteger)
	 * @generated
	 */
	boolean isSetClockChangeTimeout();

	/**
	 * Returns the value of the '<em><b>Clock Src Failure Notification</b></em>' attribute.
	 * The default value is <code>"ENABLE"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuClockSrcFailureNotificationType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enables/Disables clock failure notification.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clock Src Failure Notification</em>' attribute.
	 * @see SystemSparcClockMcu.McuClockSrcFailureNotificationType
	 * @see #isSetClockSrcFailureNotification()
	 * @see #unsetClockSrcFailureNotification()
	 * @see #setClockSrcFailureNotification(McuClockSrcFailureNotificationType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_ClockSrcFailureNotification()
	 * @model default="ENABLE" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Clock_Src_Failure_Notification' namespace='##targetNamespace'"
	 * @generated
	 */
	McuClockSrcFailureNotificationType getClockSrcFailureNotification();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockSrcFailureNotification <em>Clock Src Failure Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clock Src Failure Notification</em>' attribute.
	 * @see SystemSparcClockMcu.McuClockSrcFailureNotificationType
	 * @see #isSetClockSrcFailureNotification()
	 * @see #unsetClockSrcFailureNotification()
	 * @see #getClockSrcFailureNotification()
	 * @generated
	 */
	void setClockSrcFailureNotification(McuClockSrcFailureNotificationType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockSrcFailureNotification <em>Clock Src Failure Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClockSrcFailureNotification()
	 * @see #getClockSrcFailureNotification()
	 * @see #setClockSrcFailureNotification(McuClockSrcFailureNotificationType)
	 * @generated
	 */
	void unsetClockSrcFailureNotification();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getClockSrcFailureNotification <em>Clock Src Failure Notification</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clock Src Failure Notification</em>' attribute is set.
	 * @see #unsetClockSrcFailureNotification()
	 * @see #getClockSrcFailureNotification()
	 * @see #setClockSrcFailureNotification(McuClockSrcFailureNotificationType)
	 * @generated
	 */
	boolean isSetClockSrcFailureNotification();

	/**
	 * Returns the value of the '<em><b>Cpu Clock Frequency</b></em>' attribute.
	 * The default value is <code>"4.8E7"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is the frequency for the High Power RUN of the project. It shall be given in Hz.
	 * 			McuClockReferencePointFrequency has to be less than or equal to 64 MHz.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cpu Clock Frequency</em>' attribute.
	 * @see #isSetCpuClockFrequency()
	 * @see #unsetCpuClockFrequency()
	 * @see #setCpuClockFrequency(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_CpuClockFrequency()
	 * @model default="4.8E7" unsettable="true" dataType="SystemSparcClockMcu.McuClockReferencePointFrequencyType1"
	 *        extendedMetaData="kind='attribute' name='Cpu_Clock_Frequency' namespace='##targetNamespace'"
	 * @generated
	 */
	float getCpuClockFrequency();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getCpuClockFrequency <em>Cpu Clock Frequency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu Clock Frequency</em>' attribute.
	 * @see #isSetCpuClockFrequency()
	 * @see #unsetCpuClockFrequency()
	 * @see #getCpuClockFrequency()
	 * @generated
	 */
	void setCpuClockFrequency(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getCpuClockFrequency <em>Cpu Clock Frequency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCpuClockFrequency()
	 * @see #getCpuClockFrequency()
	 * @see #setCpuClockFrequency(float)
	 * @generated
	 */
	void unsetCpuClockFrequency();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getCpuClockFrequency <em>Cpu Clock Frequency</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Cpu Clock Frequency</em>' attribute is set.
	 * @see #unsetCpuClockFrequency()
	 * @see #getCpuClockFrequency()
	 * @see #setCpuClockFrequency(float)
	 * @generated
	 */
	boolean isSetCpuClockFrequency();

	/**
	 * Returns the value of the '<em><b>Fm Pll Monitor</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter Enables/Disables the FM PLL clock monitor.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Fm Pll Monitor</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetFmPllMonitor()
	 * @see #unsetFmPllMonitor()
	 * @see #setFmPllMonitor(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_FmPllMonitor()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='FmPllMonitor' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getFmPllMonitor();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getFmPllMonitor <em>Fm Pll Monitor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Fm Pll Monitor</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetFmPllMonitor()
	 * @see #unsetFmPllMonitor()
	 * @see #getFmPllMonitor()
	 * @generated
	 */
	void setFmPllMonitor(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getFmPllMonitor <em>Fm Pll Monitor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetFmPllMonitor()
	 * @see #getFmPllMonitor()
	 * @see #setFmPllMonitor(TypeBoolean)
	 * @generated
	 */
	void unsetFmPllMonitor();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getFmPllMonitor <em>Fm Pll Monitor</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Fm Pll Monitor</em>' attribute is set.
	 * @see #unsetFmPllMonitor()
	 * @see #getFmPllMonitor()
	 * @see #setFmPllMonitor(TypeBoolean)
	 * @generated
	 */
	boolean isSetFmPllMonitor();

	/**
	 * Returns the value of the '<em><b>High Frequency Ref</b></em>' attribute.
	 * The default value is <code>"65000000"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The value of the Max Frequency[in Hz]. So, the monitor detect if the System Clock is greater than Max Frequency value. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>High Frequency Ref</em>' attribute.
	 * @see #isSetHighFrequencyRef()
	 * @see #unsetHighFrequencyRef()
	 * @see #setHighFrequencyRef(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_HighFrequencyRef()
	 * @model default="65000000" unsettable="true" dataType="SystemSparcClockMcu.HighFrequencyRefType"
	 *        extendedMetaData="kind='attribute' name='HighFrequencyRef' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getHighFrequencyRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getHighFrequencyRef <em>High Frequency Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>High Frequency Ref</em>' attribute.
	 * @see #isSetHighFrequencyRef()
	 * @see #unsetHighFrequencyRef()
	 * @see #getHighFrequencyRef()
	 * @generated
	 */
	void setHighFrequencyRef(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getHighFrequencyRef <em>High Frequency Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetHighFrequencyRef()
	 * @see #getHighFrequencyRef()
	 * @see #setHighFrequencyRef(BigInteger)
	 * @generated
	 */
	void unsetHighFrequencyRef();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getHighFrequencyRef <em>High Frequency Ref</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>High Frequency Ref</em>' attribute is set.
	 * @see #unsetHighFrequencyRef()
	 * @see #getHighFrequencyRef()
	 * @see #setHighFrequencyRef(BigInteger)
	 * @generated
	 */
	boolean isSetHighFrequencyRef();

	/**
	 * Returns the value of the '<em><b>Low Frequency Ref</b></em>' attribute.
	 * The default value is <code>"63000000"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The value of the Min Frequency[in Hz]. So, the monitor detect if the System Clock is smaller than Min Frequency value.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Low Frequency Ref</em>' attribute.
	 * @see #isSetLowFrequencyRef()
	 * @see #unsetLowFrequencyRef()
	 * @see #setLowFrequencyRef(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_LowFrequencyRef()
	 * @model default="63000000" unsettable="true" dataType="SystemSparcClockMcu.LowFrequencyRefType"
	 *        extendedMetaData="kind='attribute' name='LowFrequencyRef' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getLowFrequencyRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getLowFrequencyRef <em>Low Frequency Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Low Frequency Ref</em>' attribute.
	 * @see #isSetLowFrequencyRef()
	 * @see #unsetLowFrequencyRef()
	 * @see #getLowFrequencyRef()
	 * @generated
	 */
	void setLowFrequencyRef(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getLowFrequencyRef <em>Low Frequency Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLowFrequencyRef()
	 * @see #getLowFrequencyRef()
	 * @see #setLowFrequencyRef(BigInteger)
	 * @generated
	 */
	void unsetLowFrequencyRef();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getLowFrequencyRef <em>Low Frequency Ref</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Low Frequency Ref</em>' attribute is set.
	 * @see #unsetLowFrequencyRef()
	 * @see #getLowFrequencyRef()
	 * @see #setLowFrequencyRef(BigInteger)
	 * @generated
	 */
	boolean isSetLowFrequencyRef();

	/**
	 * Returns the value of the '<em><b>Quartz</b></em>' attribute.
	 * The default value is <code>"8000000.0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Crystal Frequency or External Reference Frequency [Hz]. CrystalFrequencyHz has to be in range 4 MHz up to 16 MHz.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Quartz</em>' attribute.
	 * @see #isSetQuartz()
	 * @see #unsetQuartz()
	 * @see #setQuartz(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_Quartz()
	 * @model default="8000000.0" unsettable="true" dataType="SystemSparcClockMcu.QuartzType"
	 *        extendedMetaData="kind='attribute' name='Quartz' namespace='##targetNamespace'"
	 * @generated
	 */
	float getQuartz();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getQuartz <em>Quartz</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quartz</em>' attribute.
	 * @see #isSetQuartz()
	 * @see #unsetQuartz()
	 * @see #getQuartz()
	 * @generated
	 */
	void setQuartz(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getQuartz <em>Quartz</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetQuartz()
	 * @see #getQuartz()
	 * @see #setQuartz(float)
	 * @generated
	 */
	void unsetQuartz();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getQuartz <em>Quartz</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Quartz</em>' attribute is set.
	 * @see #unsetQuartz()
	 * @see #getQuartz()
	 * @see #setQuartz(float)
	 * @generated
	 */
	boolean isSetQuartz();

	/**
	 * Returns the value of the '<em><b>RC Divisor Factor</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This value should compose the following value x=16000000/(2^RC). So, the monitor detect if the freq of external quartz is smaller than x.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>RC Divisor Factor</em>' attribute.
	 * @see #isSetRCDivisorFactor()
	 * @see #unsetRCDivisorFactor()
	 * @see #setRCDivisorFactor(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_RCDivisorFactor()
	 * @model default="0" unsettable="true" dataType="SystemSparcClockMcu.RCDivisorFactorType1"
	 *        extendedMetaData="kind='attribute' name='RCDivisorFactor' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getRCDivisorFactor();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCDivisorFactor <em>RC Divisor Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>RC Divisor Factor</em>' attribute.
	 * @see #isSetRCDivisorFactor()
	 * @see #unsetRCDivisorFactor()
	 * @see #getRCDivisorFactor()
	 * @generated
	 */
	void setRCDivisorFactor(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCDivisorFactor <em>RC Divisor Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRCDivisorFactor()
	 * @see #getRCDivisorFactor()
	 * @see #setRCDivisorFactor(BigInteger)
	 * @generated
	 */
	void unsetRCDivisorFactor();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCDivisorFactor <em>RC Divisor Factor</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>RC Divisor Factor</em>' attribute is set.
	 * @see #unsetRCDivisorFactor()
	 * @see #getRCDivisorFactor()
	 * @see #setRCDivisorFactor(BigInteger)
	 * @generated
	 */
	boolean isSetRCDivisorFactor();

	/**
	 * Returns the value of the '<em><b>RCOSC Selection</b></em>' attribute.
	 * The default value is <code>"CK_IRCfast"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuRCOSCSelectionType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the RC oscillator selection.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>RCOSC Selection</em>' attribute.
	 * @see SystemSparcClockMcu.McuRCOSCSelectionType
	 * @see #isSetRCOSCSelection()
	 * @see #unsetRCOSCSelection()
	 * @see #setRCOSCSelection(McuRCOSCSelectionType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_RCOSCSelection()
	 * @model default="CK_IRCfast" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RCOSCSelection' namespace='##targetNamespace'"
	 * @generated
	 */
	McuRCOSCSelectionType getRCOSCSelection();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCOSCSelection <em>RCOSC Selection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>RCOSC Selection</em>' attribute.
	 * @see SystemSparcClockMcu.McuRCOSCSelectionType
	 * @see #isSetRCOSCSelection()
	 * @see #unsetRCOSCSelection()
	 * @see #getRCOSCSelection()
	 * @generated
	 */
	void setRCOSCSelection(McuRCOSCSelectionType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCOSCSelection <em>RCOSC Selection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRCOSCSelection()
	 * @see #getRCOSCSelection()
	 * @see #setRCOSCSelection(McuRCOSCSelectionType)
	 * @generated
	 */
	void unsetRCOSCSelection();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getRCOSCSelection <em>RCOSC Selection</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>RCOSC Selection</em>' attribute is set.
	 * @see #unsetRCOSCSelection()
	 * @see #getRCOSCSelection()
	 * @see #setRCOSCSelection(McuRCOSCSelectionType)
	 * @generated
	 */
	boolean isSetRCOSCSelection();

	/**
	 * Returns the value of the '<em><b>XTal ACounter Oscillator</b></em>' attribute.
	 * The default value is <code>"128"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the end of count value to be used for the oscillator stabilization for XTAL_A. This counting period ensures that external oscillator clock signal is stable before it can be selected by the system.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>XTal ACounter Oscillator</em>' attribute.
	 * @see #isSetXTalACounterOscillator()
	 * @see #unsetXTalACounterOscillator()
	 * @see #setXTalACounterOscillator(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_XTalACounterOscillator()
	 * @model default="128" unsettable="true" dataType="SystemSparcClockMcu.XTalACounterOscillatorType"
	 *        extendedMetaData="kind='attribute' name='XTal_A_CounterOscillator' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getXTalACounterOscillator();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalACounterOscillator <em>XTal ACounter Oscillator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>XTal ACounter Oscillator</em>' attribute.
	 * @see #isSetXTalACounterOscillator()
	 * @see #unsetXTalACounterOscillator()
	 * @see #getXTalACounterOscillator()
	 * @generated
	 */
	void setXTalACounterOscillator(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalACounterOscillator <em>XTal ACounter Oscillator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetXTalACounterOscillator()
	 * @see #getXTalACounterOscillator()
	 * @see #setXTalACounterOscillator(BigInteger)
	 * @generated
	 */
	void unsetXTalACounterOscillator();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalACounterOscillator <em>XTal ACounter Oscillator</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>XTal ACounter Oscillator</em>' attribute is set.
	 * @see #unsetXTalACounterOscillator()
	 * @see #getXTalACounterOscillator()
	 * @see #setXTalACounterOscillator(BigInteger)
	 * @generated
	 */
	boolean isSetXTalACounterOscillator();

	/**
	 * Returns the value of the '<em><b>XTal B32K Hz Counter Oscillator</b></em>' attribute.
	 * The default value is <code>"128"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the end of count value to be used for the oscillator stabilization for XTAL_B_32Khz. This counting period ensures that external oscillator clock signal is stable before it can be selected by the system.Note: Implementation specific Parameter .
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>XTal B32K Hz Counter Oscillator</em>' attribute.
	 * @see #isSetXTalB32KHzCounterOscillator()
	 * @see #unsetXTalB32KHzCounterOscillator()
	 * @see #setXTalB32KHzCounterOscillator(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCLOCKType_XTalB32KHzCounterOscillator()
	 * @model default="128" unsettable="true" dataType="SystemSparcClockMcu.XTalB32KHzCounterOscillatorType"
	 *        extendedMetaData="kind='attribute' name='XTal_B_32KHz_CounterOscillator' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getXTalB32KHzCounterOscillator();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalB32KHzCounterOscillator <em>XTal B32K Hz Counter Oscillator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>XTal B32K Hz Counter Oscillator</em>' attribute.
	 * @see #isSetXTalB32KHzCounterOscillator()
	 * @see #unsetXTalB32KHzCounterOscillator()
	 * @see #getXTalB32KHzCounterOscillator()
	 * @generated
	 */
	void setXTalB32KHzCounterOscillator(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalB32KHzCounterOscillator <em>XTal B32K Hz Counter Oscillator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetXTalB32KHzCounterOscillator()
	 * @see #getXTalB32KHzCounterOscillator()
	 * @see #setXTalB32KHzCounterOscillator(BigInteger)
	 * @generated
	 */
	void unsetXTalB32KHzCounterOscillator();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CLOCKType#getXTalB32KHzCounterOscillator <em>XTal B32K Hz Counter Oscillator</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>XTal B32K Hz Counter Oscillator</em>' attribute is set.
	 * @see #unsetXTalB32KHzCounterOscillator()
	 * @see #getXTalB32KHzCounterOscillator()
	 * @see #setXTalB32KHzCounterOscillator(BigInteger)
	 * @generated
	 */
	boolean isSetXTalB32KHzCounterOscillator();

} // CLOCKType
