/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CPULOADMEASUREMENT Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getCpuLoadSlidingTimeWindowSize <em>Cpu Load Sliding Time Window Size</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getCpuLoadUpdateCycle <em>Cpu Load Update Cycle</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getIdleTaskReference <em>Idle Task Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCPULOADMEASUREMENTType()
 * @model extendedMetaData="name='CPU_LOAD_MEASUREMENT_._type' kind='empty'"
 * @generated
 */
public interface CPULOADMEASUREMENTType extends EObject {
	/**
	 * Returns the value of the '<em><b>Cpu Load Sliding Time Window Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the sliding time window size for CPU load measurement.
	 * Inside this time window, the CPU load value is evaluated each CpuLoadUpdateCycle and the total of values calculated within this time window
	 * will be averaged in order to determine the CPU  load value provided to user.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cpu Load Sliding Time Window Size</em>' attribute.
	 * @see #setCpuLoadSlidingTimeWindowSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCPULOADMEASUREMENTType_CpuLoadSlidingTimeWindowSize()
	 * @model dataType="SystemSparcClockMcu.CpuLoadSlidingTimeWindowSizeType"
	 *        extendedMetaData="kind='attribute' name='CpuLoadSlidingTimeWindowSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getCpuLoadSlidingTimeWindowSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getCpuLoadSlidingTimeWindowSize <em>Cpu Load Sliding Time Window Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu Load Sliding Time Window Size</em>' attribute.
	 * @see #getCpuLoadSlidingTimeWindowSize()
	 * @generated
	 */
	void setCpuLoadSlidingTimeWindowSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Cpu Load Update Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the reccurence of CPU load calculation within the sliding time window specified for average CPU load evaluation.
	 * This reccurence must have a smaller value that the sliding time window value.
	 * (e.g. if the sliding time window has 1000ms size and the calculation reccurence is 100ms,
	 * then 1000/100=10 values will be considered for average CPU load evaluation).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cpu Load Update Cycle</em>' attribute.
	 * @see #setCpuLoadUpdateCycle(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCPULOADMEASUREMENTType_CpuLoadUpdateCycle()
	 * @model dataType="SystemSparcClockMcu.CpuLoadUpdateCycleType"
	 *        extendedMetaData="kind='attribute' name='CpuLoadUpdateCycle' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getCpuLoadUpdateCycle();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getCpuLoadUpdateCycle <em>Cpu Load Update Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu Load Update Cycle</em>' attribute.
	 * @see #getCpuLoadUpdateCycle()
	 * @generated
	 */
	void setCpuLoadUpdateCycle(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Idle Task Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Idle Task Reference</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Idle Task Reference</em>' attribute.
	 * @see #setIdleTaskReference(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCPULOADMEASUREMENTType_IdleTaskReference()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType"
	 *        extendedMetaData="kind='attribute' name='IdleTaskReference' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getIdleTaskReference();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CPULOADMEASUREMENTType#getIdleTaskReference <em>Idle Task Reference</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Idle Task Reference</em>' attribute.
	 * @see #getIdleTaskReference()
	 * @generated
	 */
	void setIdleTaskReference(Object value);

} // CPULOADMEASUREMENTType
