/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CRC Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.CRCType#getCrc16Mode <em>Crc16 Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CRCType#getCrc32Mode <em>Crc32 Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.CRCType#getCrc8Mode <em>Crc8 Mode</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCRCType()
 * @model extendedMetaData="name='CRC_._type' kind='empty'"
 * @generated
 */
public interface CRCType extends EObject {
	/**
	 * Returns the value of the '<em><b>Crc16 Mode</b></em>' attribute.
	 * The default value is <code>"CRC_16_TABLE"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.Crc16ModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Switch to select one of the available CRC16 calculation methods.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Crc16 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc16ModeType
	 * @see #isSetCrc16Mode()
	 * @see #unsetCrc16Mode()
	 * @see #setCrc16Mode(Crc16ModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCRCType_Crc16Mode()
	 * @model default="CRC_16_TABLE" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Crc16Mode' namespace='##targetNamespace'"
	 * @generated
	 */
	Crc16ModeType getCrc16Mode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc16Mode <em>Crc16 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Crc16 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc16ModeType
	 * @see #isSetCrc16Mode()
	 * @see #unsetCrc16Mode()
	 * @see #getCrc16Mode()
	 * @generated
	 */
	void setCrc16Mode(Crc16ModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc16Mode <em>Crc16 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCrc16Mode()
	 * @see #getCrc16Mode()
	 * @see #setCrc16Mode(Crc16ModeType)
	 * @generated
	 */
	void unsetCrc16Mode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CRCType#getCrc16Mode <em>Crc16 Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Crc16 Mode</em>' attribute is set.
	 * @see #unsetCrc16Mode()
	 * @see #getCrc16Mode()
	 * @see #setCrc16Mode(Crc16ModeType)
	 * @generated
	 */
	boolean isSetCrc16Mode();

	/**
	 * Returns the value of the '<em><b>Crc32 Mode</b></em>' attribute.
	 * The default value is <code>"CRC_32_TABLE"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.Crc32ModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Switch to select one of the available CRC32 calculation methods.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Crc32 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc32ModeType
	 * @see #isSetCrc32Mode()
	 * @see #unsetCrc32Mode()
	 * @see #setCrc32Mode(Crc32ModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCRCType_Crc32Mode()
	 * @model default="CRC_32_TABLE" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Crc32Mode' namespace='##targetNamespace'"
	 * @generated
	 */
	Crc32ModeType getCrc32Mode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc32Mode <em>Crc32 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Crc32 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc32ModeType
	 * @see #isSetCrc32Mode()
	 * @see #unsetCrc32Mode()
	 * @see #getCrc32Mode()
	 * @generated
	 */
	void setCrc32Mode(Crc32ModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc32Mode <em>Crc32 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCrc32Mode()
	 * @see #getCrc32Mode()
	 * @see #setCrc32Mode(Crc32ModeType)
	 * @generated
	 */
	void unsetCrc32Mode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CRCType#getCrc32Mode <em>Crc32 Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Crc32 Mode</em>' attribute is set.
	 * @see #unsetCrc32Mode()
	 * @see #getCrc32Mode()
	 * @see #setCrc32Mode(Crc32ModeType)
	 * @generated
	 */
	boolean isSetCrc32Mode();

	/**
	 * Returns the value of the '<em><b>Crc8 Mode</b></em>' attribute.
	 * The default value is <code>"CRC_8_TABLE"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.Crc8ModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Switch to select one of the available CRC8 calculation methods.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Crc8 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc8ModeType
	 * @see #isSetCrc8Mode()
	 * @see #unsetCrc8Mode()
	 * @see #setCrc8Mode(Crc8ModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCRCType_Crc8Mode()
	 * @model default="CRC_8_TABLE" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Crc8Mode' namespace='##targetNamespace'"
	 * @generated
	 */
	Crc8ModeType getCrc8Mode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc8Mode <em>Crc8 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Crc8 Mode</em>' attribute.
	 * @see SystemSparcClockMcu.Crc8ModeType
	 * @see #isSetCrc8Mode()
	 * @see #unsetCrc8Mode()
	 * @see #getCrc8Mode()
	 * @generated
	 */
	void setCrc8Mode(Crc8ModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.CRCType#getCrc8Mode <em>Crc8 Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCrc8Mode()
	 * @see #getCrc8Mode()
	 * @see #setCrc8Mode(Crc8ModeType)
	 * @generated
	 */
	void unsetCrc8Mode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.CRCType#getCrc8Mode <em>Crc8 Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Crc8 Mode</em>' attribute is set.
	 * @see #unsetCrc8Mode()
	 * @see #getCrc8Mode()
	 * @see #setCrc8Mode(Crc8ModeType)
	 * @generated
	 */
	boolean isSetCrc8Mode();

} // CRCType
