/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Crc32 Mode Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getCrc32ModeType()
 * @model extendedMetaData="name='Crc32Mode_._type'"
 * @generated
 */
public enum Crc32ModeType implements Enumerator {
	/**
	 * The '<em><b>CRC32HARDWARE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CRC32HARDWARE_VALUE
	 * @generated
	 * @ordered
	 */
	CRC32HARDWARE(0, "CRC32HARDWARE", "CRC_32_HARDWARE"),

	/**
	 * The '<em><b>CRC32RUNTIME</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CRC32RUNTIME_VALUE
	 * @generated
	 * @ordered
	 */
	CRC32RUNTIME(1, "CRC32RUNTIME", "CRC_32_RUNTIME"),

	/**
	 * The '<em><b>CRC32TABLE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CRC32TABLE_VALUE
	 * @generated
	 * @ordered
	 */
	CRC32TABLE(2, "CRC32TABLE", "CRC_32_TABLE");

	/**
	 * The '<em><b>CRC32HARDWARE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CRC32HARDWARE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CRC32HARDWARE
	 * @model literal="CRC_32_HARDWARE"
	 * @generated
	 * @ordered
	 */
	public static final int CRC32HARDWARE_VALUE = 0;

	/**
	 * The '<em><b>CRC32RUNTIME</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CRC32RUNTIME</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CRC32RUNTIME
	 * @model literal="CRC_32_RUNTIME"
	 * @generated
	 * @ordered
	 */
	public static final int CRC32RUNTIME_VALUE = 1;

	/**
	 * The '<em><b>CRC32TABLE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CRC32TABLE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CRC32TABLE
	 * @model literal="CRC_32_TABLE"
	 * @generated
	 * @ordered
	 */
	public static final int CRC32TABLE_VALUE = 2;

	/**
	 * An array of all the '<em><b>Crc32 Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final Crc32ModeType[] VALUES_ARRAY =
		new Crc32ModeType[] {
			CRC32HARDWARE,
			CRC32RUNTIME,
			CRC32TABLE,
		};

	/**
	 * A public read-only list of all the '<em><b>Crc32 Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<Crc32ModeType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Crc32 Mode Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Crc32ModeType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Crc32ModeType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Crc32 Mode Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Crc32ModeType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Crc32ModeType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Crc32 Mode Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Crc32ModeType get(int value) {
		switch (value) {
			case CRC32HARDWARE_VALUE: return CRC32HARDWARE;
			case CRC32RUNTIME_VALUE: return CRC32RUNTIME;
			case CRC32TABLE_VALUE: return CRC32TABLE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private Crc32ModeType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //Crc32ModeType
