/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DEVICE Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getBaudRate <em>Baud Rate</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getChipSelect <em>Chip Select</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getClk2Cs <em>Clk2 Cs</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getCs2Clk <em>Cs2 Clk</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getCs2Cs <em>Cs2 Cs</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getCsContinous <em>Cs Continous</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getCsPolarity <em>Cs Polarity</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getDataShiftEdge <em>Data Shift Edge</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DEVICEType#getShiftClockIdleLevel <em>Shift Clock Idle Level</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType()
 * @model extendedMetaData="name='DEVICE_._type' kind='empty'"
 * @generated
 */
public interface DEVICEType extends EObject {
	/**
	 * Returns the value of the '<em><b>Baud Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Desired SPI communication speed in kbaud.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Baud Rate</em>' attribute.
	 * @see #setBaudRate(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_BaudRate()
	 * @model dataType="SystemSparcClockMcu.BaudRateType" required="true"
	 *        extendedMetaData="kind='attribute' name='BaudRate' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getBaudRate();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getBaudRate <em>Baud Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Baud Rate</em>' attribute.
	 * @see #getBaudRate()
	 * @generated
	 */
	void setBaudRate(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Chip Select</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.ChipSelectType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI chip select used by the SPI device.
	 * If CS_DISABLED is selected, the SPI driver is not handling the CS functionality.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Chip Select</em>' attribute.
	 * @see SystemSparcClockMcu.ChipSelectType
	 * @see #isSetChipSelect()
	 * @see #unsetChipSelect()
	 * @see #setChipSelect(ChipSelectType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_ChipSelect()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='ChipSelect' namespace='##targetNamespace'"
	 * @generated
	 */
	ChipSelectType getChipSelect();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getChipSelect <em>Chip Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chip Select</em>' attribute.
	 * @see SystemSparcClockMcu.ChipSelectType
	 * @see #isSetChipSelect()
	 * @see #unsetChipSelect()
	 * @see #getChipSelect()
	 * @generated
	 */
	void setChipSelect(ChipSelectType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getChipSelect <em>Chip Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetChipSelect()
	 * @see #getChipSelect()
	 * @see #setChipSelect(ChipSelectType)
	 * @generated
	 */
	void unsetChipSelect();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getChipSelect <em>Chip Select</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Chip Select</em>' attribute is set.
	 * @see #unsetChipSelect()
	 * @see #getChipSelect()
	 * @see #setChipSelect(ChipSelectType)
	 * @generated
	 */
	boolean isSetChipSelect();

	/**
	 * Returns the value of the '<em><b>Clk2 Cs</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Timing between clock and chip select in microseconds.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Clk2 Cs</em>' attribute.
	 * @see #isSetClk2Cs()
	 * @see #unsetClk2Cs()
	 * @see #setClk2Cs(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_Clk2Cs()
	 * @model default="1.0" unsettable="true" dataType="SystemSparcClockMcu.Clk2CsType"
	 *        extendedMetaData="kind='attribute' name='Clk2Cs' namespace='##targetNamespace'"
	 * @generated
	 */
	float getClk2Cs();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getClk2Cs <em>Clk2 Cs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Clk2 Cs</em>' attribute.
	 * @see #isSetClk2Cs()
	 * @see #unsetClk2Cs()
	 * @see #getClk2Cs()
	 * @generated
	 */
	void setClk2Cs(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getClk2Cs <em>Clk2 Cs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetClk2Cs()
	 * @see #getClk2Cs()
	 * @see #setClk2Cs(float)
	 * @generated
	 */
	void unsetClk2Cs();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getClk2Cs <em>Clk2 Cs</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Clk2 Cs</em>' attribute is set.
	 * @see #unsetClk2Cs()
	 * @see #getClk2Cs()
	 * @see #setClk2Cs(float)
	 * @generated
	 */
	boolean isSetClk2Cs();

	/**
	 * Returns the value of the '<em><b>Cs2 Clk</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Timing between chip select and clock in microseconds.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cs2 Clk</em>' attribute.
	 * @see #isSetCs2Clk()
	 * @see #unsetCs2Clk()
	 * @see #setCs2Clk(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_Cs2Clk()
	 * @model default="1.0" unsettable="true" dataType="SystemSparcClockMcu.Cs2ClkType"
	 *        extendedMetaData="kind='attribute' name='Cs2Clk' namespace='##targetNamespace'"
	 * @generated
	 */
	float getCs2Clk();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Clk <em>Cs2 Clk</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cs2 Clk</em>' attribute.
	 * @see #isSetCs2Clk()
	 * @see #unsetCs2Clk()
	 * @see #getCs2Clk()
	 * @generated
	 */
	void setCs2Clk(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Clk <em>Cs2 Clk</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCs2Clk()
	 * @see #getCs2Clk()
	 * @see #setCs2Clk(float)
	 * @generated
	 */
	void unsetCs2Clk();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Clk <em>Cs2 Clk</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Cs2 Clk</em>' attribute is set.
	 * @see #unsetCs2Clk()
	 * @see #getCs2Clk()
	 * @see #setCs2Clk(float)
	 * @generated
	 */
	boolean isSetCs2Clk();

	/**
	 * Returns the value of the '<em><b>Cs2 Cs</b></em>' attribute.
	 * The default value is <code>"6.4"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Timing between chip select assertions in microseconds.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cs2 Cs</em>' attribute.
	 * @see #isSetCs2Cs()
	 * @see #unsetCs2Cs()
	 * @see #setCs2Cs(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_Cs2Cs()
	 * @model default="6.4" unsettable="true" dataType="SystemSparcClockMcu.Cs2CsType"
	 *        extendedMetaData="kind='attribute' name='Cs2Cs' namespace='##targetNamespace'"
	 * @generated
	 */
	float getCs2Cs();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Cs <em>Cs2 Cs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cs2 Cs</em>' attribute.
	 * @see #isSetCs2Cs()
	 * @see #unsetCs2Cs()
	 * @see #getCs2Cs()
	 * @generated
	 */
	void setCs2Cs(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Cs <em>Cs2 Cs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCs2Cs()
	 * @see #getCs2Cs()
	 * @see #setCs2Cs(float)
	 * @generated
	 */
	void unsetCs2Cs();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getCs2Cs <em>Cs2 Cs</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Cs2 Cs</em>' attribute is set.
	 * @see #unsetCs2Cs()
	 * @see #getCs2Cs()
	 * @see #setCs2Cs(float)
	 * @generated
	 */
	boolean isSetCs2Cs();

	/**
	 * Returns the value of the '<em><b>Cs Continous</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This field determines to keep chip select asserted between frame transfers.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cs Continous</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCsContinous()
	 * @see #unsetCsContinous()
	 * @see #setCsContinous(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_CsContinous()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='CsContinous' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCsContinous();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsContinous <em>Cs Continous</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cs Continous</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCsContinous()
	 * @see #unsetCsContinous()
	 * @see #getCsContinous()
	 * @generated
	 */
	void setCsContinous(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsContinous <em>Cs Continous</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCsContinous()
	 * @see #getCsContinous()
	 * @see #setCsContinous(TypeBoolean)
	 * @generated
	 */
	void unsetCsContinous();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsContinous <em>Cs Continous</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Cs Continous</em>' attribute is set.
	 * @see #unsetCsContinous()
	 * @see #getCsContinous()
	 * @see #setCsContinous(TypeBoolean)
	 * @generated
	 */
	boolean isSetCsContinous();

	/**
	 * Returns the value of the '<em><b>Cs Polarity</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.CsPolarityType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines the active polarity of Chip Select.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cs Polarity</em>' attribute.
	 * @see SystemSparcClockMcu.CsPolarityType
	 * @see #isSetCsPolarity()
	 * @see #unsetCsPolarity()
	 * @see #setCsPolarity(CsPolarityType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_CsPolarity()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='CsPolarity' namespace='##targetNamespace'"
	 * @generated
	 */
	CsPolarityType getCsPolarity();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsPolarity <em>Cs Polarity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cs Polarity</em>' attribute.
	 * @see SystemSparcClockMcu.CsPolarityType
	 * @see #isSetCsPolarity()
	 * @see #unsetCsPolarity()
	 * @see #getCsPolarity()
	 * @generated
	 */
	void setCsPolarity(CsPolarityType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsPolarity <em>Cs Polarity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCsPolarity()
	 * @see #getCsPolarity()
	 * @see #setCsPolarity(CsPolarityType)
	 * @generated
	 */
	void unsetCsPolarity();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getCsPolarity <em>Cs Polarity</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Cs Polarity</em>' attribute is set.
	 * @see #unsetCsPolarity()
	 * @see #getCsPolarity()
	 * @see #setCsPolarity(CsPolarityType)
	 * @generated
	 */
	boolean isSetCsPolarity();

	/**
	 * Returns the value of the '<em><b>Data Shift Edge</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DataShiftEdgeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines the SPI data shift edge.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Data Shift Edge</em>' attribute.
	 * @see SystemSparcClockMcu.DataShiftEdgeType
	 * @see #isSetDataShiftEdge()
	 * @see #unsetDataShiftEdge()
	 * @see #setDataShiftEdge(DataShiftEdgeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_DataShiftEdge()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='DataShiftEdge' namespace='##targetNamespace'"
	 * @generated
	 */
	DataShiftEdgeType getDataShiftEdge();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getDataShiftEdge <em>Data Shift Edge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Shift Edge</em>' attribute.
	 * @see SystemSparcClockMcu.DataShiftEdgeType
	 * @see #isSetDataShiftEdge()
	 * @see #unsetDataShiftEdge()
	 * @see #getDataShiftEdge()
	 * @generated
	 */
	void setDataShiftEdge(DataShiftEdgeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getDataShiftEdge <em>Data Shift Edge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDataShiftEdge()
	 * @see #getDataShiftEdge()
	 * @see #setDataShiftEdge(DataShiftEdgeType)
	 * @generated
	 */
	void unsetDataShiftEdge();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getDataShiftEdge <em>Data Shift Edge</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Data Shift Edge</em>' attribute is set.
	 * @see #unsetDataShiftEdge()
	 * @see #getDataShiftEdge()
	 * @see #setDataShiftEdge(DataShiftEdgeType)
	 * @generated
	 */
	boolean isSetDataShiftEdge();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI device identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType10" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Shift Clock Idle Level</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.ShiftClockIdleLevelType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines the SPI shift clock idle level.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Shift Clock Idle Level</em>' attribute.
	 * @see SystemSparcClockMcu.ShiftClockIdleLevelType
	 * @see #isSetShiftClockIdleLevel()
	 * @see #unsetShiftClockIdleLevel()
	 * @see #setShiftClockIdleLevel(ShiftClockIdleLevelType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDEVICEType_ShiftClockIdleLevel()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='ShiftClockIdleLevel' namespace='##targetNamespace'"
	 * @generated
	 */
	ShiftClockIdleLevelType getShiftClockIdleLevel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DEVICEType#getShiftClockIdleLevel <em>Shift Clock Idle Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Shift Clock Idle Level</em>' attribute.
	 * @see SystemSparcClockMcu.ShiftClockIdleLevelType
	 * @see #isSetShiftClockIdleLevel()
	 * @see #unsetShiftClockIdleLevel()
	 * @see #getShiftClockIdleLevel()
	 * @generated
	 */
	void setShiftClockIdleLevel(ShiftClockIdleLevelType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DEVICEType#getShiftClockIdleLevel <em>Shift Clock Idle Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetShiftClockIdleLevel()
	 * @see #getShiftClockIdleLevel()
	 * @see #setShiftClockIdleLevel(ShiftClockIdleLevelType)
	 * @generated
	 */
	void unsetShiftClockIdleLevel();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DEVICEType#getShiftClockIdleLevel <em>Shift Clock Idle Level</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Shift Clock Idle Level</em>' attribute is set.
	 * @see #unsetShiftClockIdleLevel()
	 * @see #getShiftClockIdleLevel()
	 * @see #setShiftClockIdleLevel(ShiftClockIdleLevelType)
	 * @generated
	 */
	boolean isSetShiftClockIdleLevel();

} // DEVICEType
