/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DMAADVANCEDCONFIGURATION Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCRCLM <em>CRCLM</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCREMLM <em>CREMLM</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAADVANCEDCONFIGURATIONType()
 * @model extendedMetaData="name='DMA_ADVANCED_CONFIGURATION_._type' kind='empty'"
 * @generated
 */
public interface DMAADVANCEDCONFIGURATIONType extends EObject {
	/**
	 * Returns the value of the '<em><b>CRCLM</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Continuous Link Mode - part of Control Register(CR)
	 * 
	 * 0 - A minor loop channel link made to itself will go
	 * through channel arbitration before being activated
	 * again.
	 * 
	 * 1 - A minor loop channel link made to itself will not go
	 * through channel arbitration before being activated
	 * again. Upon minor loop completion the channel will
	 * active again if that channel has a minor loop channel
	 * link enabled and the link channel is itself. This
	 * effectively applies the minor loop offsets and restarts
	 * the next minor loop.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CRCLM</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRCLM()
	 * @see #unsetCRCLM()
	 * @see #setCRCLM(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAADVANCEDCONFIGURATIONType_CRCLM()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_CLM' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCRCLM();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCRCLM <em>CRCLM</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CRCLM</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRCLM()
	 * @see #unsetCRCLM()
	 * @see #getCRCLM()
	 * @generated
	 */
	void setCRCLM(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCRCLM <em>CRCLM</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCRCLM()
	 * @see #getCRCLM()
	 * @see #setCRCLM(TypeBoolean)
	 * @generated
	 */
	void unsetCRCLM();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCRCLM <em>CRCLM</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CRCLM</em>' attribute is set.
	 * @see #unsetCRCLM()
	 * @see #getCRCLM()
	 * @see #setCRCLM(TypeBoolean)
	 * @generated
	 */
	boolean isSetCRCLM();

	/**
	 * Returns the value of the '<em><b>CREMLM</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable Minor Loop Mapping - part of Control Register(CR)
	 * 
	 * 0  Minor loop mapping disabled. 
	 * TCDn.word2 is defined as a 32-bit nbytes field.
	 * 
	 * 1  Minor loop mapping enabled. 
	 * When set, TCDn.word2 is redefined to include individual
	 * enable fields, an offset field and the nbytes field. The
	 * individual enable fields allow the minor loop offset to
	 * be applied to the source address, the destination
	 * address, or both. The nbytes field is reduced when
	 * either offset is enabled.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CREMLM</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREMLM()
	 * @see #unsetCREMLM()
	 * @see #setCREMLM(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAADVANCEDCONFIGURATIONType_CREMLM()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_EMLM' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCREMLM();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCREMLM <em>CREMLM</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CREMLM</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREMLM()
	 * @see #unsetCREMLM()
	 * @see #getCREMLM()
	 * @generated
	 */
	void setCREMLM(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCREMLM <em>CREMLM</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCREMLM()
	 * @see #getCREMLM()
	 * @see #setCREMLM(TypeBoolean)
	 * @generated
	 */
	void unsetCREMLM();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAADVANCEDCONFIGURATIONType#getCREMLM <em>CREMLM</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CREMLM</em>' attribute is set.
	 * @see #unsetCREMLM()
	 * @see #getCREMLM()
	 * @see #setCREMLM(TypeBoolean)
	 * @generated
	 */
	boolean isSetCREMLM();

} // DMAADVANCEDCONFIGURATIONType
