/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DMACHANNELADVANCEDCONFIGURATION Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRDPA <em>CPRDPA</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRECP <em>CPRECP</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getEEIRL <em>EEIRL</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELADVANCEDCONFIGURATIONType()
 * @model extendedMetaData="name='DMA_CHANNEL_ADVANCED_CONFIGURATION_._type' kind='empty'"
 * @generated
 */
public interface DMACHANNELADVANCEDCONFIGURATIONType extends EObject {
	/**
	 * Returns the value of the '<em><b>CPRDPA</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Disable Preempt Ability - part of Channel Priority Register (CPR)
	 * 
	 * 0 Channel n can suspend a lower priority channel.
	 * 
	 * 1 Channel n cannot suspend any channel, regardless
	 * of channel priority.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CPRDPA</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCPRDPA()
	 * @see #unsetCPRDPA()
	 * @see #setCPRDPA(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELADVANCEDCONFIGURATIONType_CPRDPA()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CPR_DPA' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCPRDPA();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRDPA <em>CPRDPA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CPRDPA</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCPRDPA()
	 * @see #unsetCPRDPA()
	 * @see #getCPRDPA()
	 * @generated
	 */
	void setCPRDPA(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRDPA <em>CPRDPA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCPRDPA()
	 * @see #getCPRDPA()
	 * @see #setCPRDPA(TypeBoolean)
	 * @generated
	 */
	void unsetCPRDPA();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRDPA <em>CPRDPA</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CPRDPA</em>' attribute is set.
	 * @see #unsetCPRDPA()
	 * @see #getCPRDPA()
	 * @see #setCPRDPA(TypeBoolean)
	 * @generated
	 */
	boolean isSetCPRDPA();

	/**
	 * Returns the value of the '<em><b>CPRECP</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable Channel Preemption - part of Channel Priority Register (CPR)
	 * 
	 * 0 Channel cannot be suspended by a higher priority
	 * channel?s service request.
	 * 
	 * 1 Channel can be temporarily suspended by the
	 * service request of a higher priority channel.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CPRECP</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCPRECP()
	 * @see #unsetCPRECP()
	 * @see #setCPRECP(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELADVANCEDCONFIGURATIONType_CPRECP()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CPR_ECP' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCPRECP();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRECP <em>CPRECP</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CPRECP</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCPRECP()
	 * @see #unsetCPRECP()
	 * @see #getCPRECP()
	 * @generated
	 */
	void setCPRECP(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRECP <em>CPRECP</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCPRECP()
	 * @see #getCPRECP()
	 * @see #setCPRECP(TypeBoolean)
	 * @generated
	 */
	void unsetCPRECP();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getCPRECP <em>CPRECP</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CPRECP</em>' attribute is set.
	 * @see #unsetCPRECP()
	 * @see #getCPRECP()
	 * @see #setCPRECP(TypeBoolean)
	 * @generated
	 */
	boolean isSetCPRECP();

	/**
	 * Returns the value of the '<em><b>EEIRL</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable Error Interrupt
	 * 
	 * 0 The error signal for channel n does not generate an
	 * error interrupt.
	 * 
	 * 1 The assertion of the error signal for channel n
	 * generate an error interrupt request.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>EEIRL</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetEEIRL()
	 * @see #unsetEEIRL()
	 * @see #setEEIRL(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELADVANCEDCONFIGURATIONType_EEIRL()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='EEIRL' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getEEIRL();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getEEIRL <em>EEIRL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EEIRL</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetEEIRL()
	 * @see #unsetEEIRL()
	 * @see #getEEIRL()
	 * @generated
	 */
	void setEEIRL(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getEEIRL <em>EEIRL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetEEIRL()
	 * @see #getEEIRL()
	 * @see #setEEIRL(TypeBoolean)
	 * @generated
	 */
	void unsetEEIRL();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELADVANCEDCONFIGURATIONType#getEEIRL <em>EEIRL</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>EEIRL</em>' attribute is set.
	 * @see #unsetEEIRL()
	 * @see #getEEIRL()
	 * @see #setEEIRL(TypeBoolean)
	 * @generated
	 */
	boolean isSetEEIRL();

} // DMACHANNELADVANCEDCONFIGURATIONType
