/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DMACHANNEL Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDMACHANNELADVANCEDCONFIGURATION <em>DMACHANNELADVANCEDCONFIGURATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaTransferControlDescriptor <em>Dma Transfer Control Descriptor</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaChannelPriorityRegister <em>Dma Channel Priority Register</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaHwChannelNumber <em>Dma Hw Channel Number</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaInterruptCallback <em>Dma Interrupt Callback</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaOperationMode <em>Dma Operation Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaPitTriggerNumberOfTicks <em>Dma Pit Trigger Number Of Ticks</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getDmaRequestSource <em>Dma Request Source</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMACHANNELType#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType()
 * @model extendedMetaData="name='DMA_CHANNEL_._type' kind='elementOnly'"
 * @generated
 */
public interface DMACHANNELType extends EObject {
	/**
	 * Returns the value of the '<em><b>DMACHANNELADVANCEDCONFIGURATION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains all the advanced configuration for a channel.
	 * 
	 * All the parameters contained in this container have default values and they shall remain the same.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DMACHANNELADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #setDMACHANNELADVANCEDCONFIGURATION(DMACHANNELADVANCEDCONFIGURATIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DMACHANNELADVANCEDCONFIGURATION()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='DMA_CHANNEL_ADVANCED_CONFIGURATION' namespace='##targetNamespace'"
	 * @generated
	 */
	DMACHANNELADVANCEDCONFIGURATIONType getDMACHANNELADVANCEDCONFIGURATION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDMACHANNELADVANCEDCONFIGURATION <em>DMACHANNELADVANCEDCONFIGURATION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DMACHANNELADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #getDMACHANNELADVANCEDCONFIGURATION()
	 * @generated
	 */
	void setDMACHANNELADVANCEDCONFIGURATION(DMACHANNELADVANCEDCONFIGURATIONType value);

	/**
	 * Returns the value of the '<em><b>Dma Transfer Control Descriptor</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.DmaTransferControlDescriptorType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container holds the configurations for one Transfer Control Descriptor.
	 * At least one TCD must be defined for a DMA channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Transfer Control Descriptor</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaTransferControlDescriptor()
	 * @model containment="true" required="true" upper="8"
	 *        extendedMetaData="kind='element' name='DmaTransferControlDescriptor' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<DmaTransferControlDescriptorType> getDmaTransferControlDescriptor();

	/**
	 * Returns the value of the '<em><b>Dma Channel Priority Register</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Fixed channel priority.
	 * 
	 * If arbitration mode is selected to Round Robin, this parameter is ignored.
	 * If Fixed Priority arbitration is selected, then this parameter value sets the preemption priority.
	 * 
	 * Only values from 0 to 15 are allowed; 15 is the greatest priority and 0 is the lowest priority.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Channel Priority Register</em>' attribute.
	 * @see #setDmaChannelPriorityRegister(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaChannelPriorityRegister()
	 * @model dataType="SystemSparcClockMcu.DmaChannelPriorityRegisterType"
	 *        extendedMetaData="kind='attribute' name='DmaChannelPriorityRegister' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDmaChannelPriorityRegister();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaChannelPriorityRegister <em>Dma Channel Priority Register</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Channel Priority Register</em>' attribute.
	 * @see #getDmaChannelPriorityRegister()
	 * @generated
	 */
	void setDmaChannelPriorityRegister(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Dma Hw Channel Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Number of the DMA channel.
	 * 
	 * Only values from 0 to 15 are allowed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Hw Channel Number</em>' attribute.
	 * @see #setDmaHwChannelNumber(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaHwChannelNumber()
	 * @model dataType="SystemSparcClockMcu.DmaHwChannelNumberType" required="true"
	 *        extendedMetaData="kind='attribute' name='DmaHwChannelNumber' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDmaHwChannelNumber();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaHwChannelNumber <em>Dma Hw Channel Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Hw Channel Number</em>' attribute.
	 * @see #getDmaHwChannelNumber()
	 * @generated
	 */
	void setDmaHwChannelNumber(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Dma Interrupt Callback</b></em>' attribute.
	 * The default value is <code>"NULL_PTR"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This function will be called by DMA interrupt service routine.
	 * 
	 * If major loop interrupt or half loop interrupt is configured, this function will be called after the DMA transfer is completed.
	 * The function prototype must be of type void Callback_Name( void ) and only the name must be provided (not the parameters or the return type).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Interrupt Callback</em>' attribute.
	 * @see #isSetDmaInterruptCallback()
	 * @see #unsetDmaInterruptCallback()
	 * @see #setDmaInterruptCallback(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaInterruptCallback()
	 * @model default="NULL_PTR" unsettable="true" dataType="SystemSparcClockMcu.DmaInterruptCallbackType"
	 *        extendedMetaData="kind='attribute' name='DmaInterruptCallback' namespace='##targetNamespace'"
	 * @generated
	 */
	String getDmaInterruptCallback();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaInterruptCallback <em>Dma Interrupt Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Interrupt Callback</em>' attribute.
	 * @see #isSetDmaInterruptCallback()
	 * @see #unsetDmaInterruptCallback()
	 * @see #getDmaInterruptCallback()
	 * @generated
	 */
	void setDmaInterruptCallback(String value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaInterruptCallback <em>Dma Interrupt Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaInterruptCallback()
	 * @see #getDmaInterruptCallback()
	 * @see #setDmaInterruptCallback(String)
	 * @generated
	 */
	void unsetDmaInterruptCallback();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaInterruptCallback <em>Dma Interrupt Callback</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Interrupt Callback</em>' attribute is set.
	 * @see #unsetDmaInterruptCallback()
	 * @see #getDmaInterruptCallback()
	 * @see #setDmaInterruptCallback(String)
	 * @generated
	 */
	boolean isSetDmaInterruptCallback();

	/**
	 * Returns the value of the '<em><b>Dma Operation Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DmaOperationModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Select the DMA channel operation mode.
	 * 
	 * Normal Mode ? In this mode, a DMA source (such as DSPI_0_TX or DSPI_0_RX example) is
	 * routed directly to the specified DMA channel. The operation of the DMA_MUX in this mode is
	 * completely transparent to the system.
	 * 
	 * Periodic Trigger Mode ? In this mode, a DMA source may only request a DMA transfer (such as
	 * when a transmit buffer becomes empty or a receive buffer becomes full) periodically. The period
	 * is configured in the registers of the Periodic Interrupt Timer (PIT).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Operation Mode</em>' attribute.
	 * @see SystemSparcClockMcu.DmaOperationModeType
	 * @see #isSetDmaOperationMode()
	 * @see #unsetDmaOperationMode()
	 * @see #setDmaOperationMode(DmaOperationModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaOperationMode()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='DmaOperationMode' namespace='##targetNamespace'"
	 * @generated
	 */
	DmaOperationModeType getDmaOperationMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaOperationMode <em>Dma Operation Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Operation Mode</em>' attribute.
	 * @see SystemSparcClockMcu.DmaOperationModeType
	 * @see #isSetDmaOperationMode()
	 * @see #unsetDmaOperationMode()
	 * @see #getDmaOperationMode()
	 * @generated
	 */
	void setDmaOperationMode(DmaOperationModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaOperationMode <em>Dma Operation Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaOperationMode()
	 * @see #getDmaOperationMode()
	 * @see #setDmaOperationMode(DmaOperationModeType)
	 * @generated
	 */
	void unsetDmaOperationMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaOperationMode <em>Dma Operation Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Operation Mode</em>' attribute is set.
	 * @see #unsetDmaOperationMode()
	 * @see #getDmaOperationMode()
	 * @see #setDmaOperationMode(DmaOperationModeType)
	 * @generated
	 */
	boolean isSetDmaOperationMode();

	/**
	 * Returns the value of the '<em><b>Dma Pit Trigger Number Of Ticks</b></em>' attribute.
	 * The default value is <code>"2500"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is the value to be loaded into the PIT timer when used to trigger the DMA channel.
	 * The timer value must be provided in CPU clocks.
	 * No prescaler values can be configured.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Pit Trigger Number Of Ticks</em>' attribute.
	 * @see #isSetDmaPitTriggerNumberOfTicks()
	 * @see #unsetDmaPitTriggerNumberOfTicks()
	 * @see #setDmaPitTriggerNumberOfTicks(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaPitTriggerNumberOfTicks()
	 * @model default="2500" unsettable="true" dataType="SystemSparcClockMcu.DmaPitTriggerNumberOfTicksType"
	 *        extendedMetaData="kind='attribute' name='DmaPitTriggerNumberOfTicks' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDmaPitTriggerNumberOfTicks();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaPitTriggerNumberOfTicks <em>Dma Pit Trigger Number Of Ticks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Pit Trigger Number Of Ticks</em>' attribute.
	 * @see #isSetDmaPitTriggerNumberOfTicks()
	 * @see #unsetDmaPitTriggerNumberOfTicks()
	 * @see #getDmaPitTriggerNumberOfTicks()
	 * @generated
	 */
	void setDmaPitTriggerNumberOfTicks(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaPitTriggerNumberOfTicks <em>Dma Pit Trigger Number Of Ticks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaPitTriggerNumberOfTicks()
	 * @see #getDmaPitTriggerNumberOfTicks()
	 * @see #setDmaPitTriggerNumberOfTicks(BigInteger)
	 * @generated
	 */
	void unsetDmaPitTriggerNumberOfTicks();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaPitTriggerNumberOfTicks <em>Dma Pit Trigger Number Of Ticks</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Pit Trigger Number Of Ticks</em>' attribute is set.
	 * @see #unsetDmaPitTriggerNumberOfTicks()
	 * @see #getDmaPitTriggerNumberOfTicks()
	 * @see #setDmaPitTriggerNumberOfTicks(BigInteger)
	 * @generated
	 */
	boolean isSetDmaPitTriggerNumberOfTicks();

	/**
	 * Returns the value of the '<em><b>Dma Request Source</b></em>' attribute.
	 * The default value is <code>"Channel_Disabled"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DmaRequestSourceType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Select the source that can request the service of this DMA channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Request Source</em>' attribute.
	 * @see SystemSparcClockMcu.DmaRequestSourceType
	 * @see #isSetDmaRequestSource()
	 * @see #unsetDmaRequestSource()
	 * @see #setDmaRequestSource(DmaRequestSourceType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_DmaRequestSource()
	 * @model default="Channel_Disabled" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='DmaRequestSource' namespace='##targetNamespace'"
	 * @generated
	 */
	DmaRequestSourceType getDmaRequestSource();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaRequestSource <em>Dma Request Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Request Source</em>' attribute.
	 * @see SystemSparcClockMcu.DmaRequestSourceType
	 * @see #isSetDmaRequestSource()
	 * @see #unsetDmaRequestSource()
	 * @see #getDmaRequestSource()
	 * @generated
	 */
	void setDmaRequestSource(DmaRequestSourceType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaRequestSource <em>Dma Request Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaRequestSource()
	 * @see #getDmaRequestSource()
	 * @see #setDmaRequestSource(DmaRequestSourceType)
	 * @generated
	 */
	void unsetDmaRequestSource();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getDmaRequestSource <em>Dma Request Source</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Request Source</em>' attribute is set.
	 * @see #unsetDmaRequestSource()
	 * @see #getDmaRequestSource()
	 * @see #setDmaRequestSource(DmaRequestSourceType)
	 * @generated
	 */
	boolean isSetDmaRequestSource();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * DMA channel identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMACHANNELType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType33" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMACHANNELType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

} // DMACHANNELType
