/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DMA Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DMAType#getDMAADVANCEDCONFIGURATION <em>DMAADVANCEDCONFIGURATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getDMACHANNEL <em>DMACHANNEL</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getCREBW <em>CREBW</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getCREDBG <em>CREDBG</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getCRHALT <em>CRHALT</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getCRHOE <em>CRHOE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DMAType#getDmaChannelArbitration <em>Dma Channel Arbitration</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType()
 * @model extendedMetaData="name='DMA_._type' kind='elementOnly'"
 * @generated
 */
public interface DMAType extends EObject {
	/**
	 * Returns the value of the '<em><b>DMAADVANCEDCONFIGURATION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains all the advanced configuration for the DMA.
	 * 
	 * All the parameters contained in this container have default values and they shall remain the same.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DMAADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #setDMAADVANCEDCONFIGURATION(DMAADVANCEDCONFIGURATIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_DMAADVANCEDCONFIGURATION()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='DMA_ADVANCED_CONFIGURATION' namespace='##targetNamespace'"
	 * @generated
	 */
	DMAADVANCEDCONFIGURATIONType getDMAADVANCEDCONFIGURATION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getDMAADVANCEDCONFIGURATION <em>DMAADVANCEDCONFIGURATION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DMAADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #getDMAADVANCEDCONFIGURATION()
	 * @generated
	 */
	void setDMAADVANCEDCONFIGURATION(DMAADVANCEDCONFIGURATIONType value);

	/**
	 * Returns the value of the '<em><b>DMACHANNEL</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.DMACHANNELType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container holds the configurations for one single DMA channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DMACHANNEL</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_DMACHANNEL()
	 * @model containment="true" required="true" upper="16"
	 *        extendedMetaData="kind='element' name='DMA_CHANNEL' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<DMACHANNELType> getDMACHANNEL();

	/**
	 * Returns the value of the '<em><b>CREBW</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable Buffered Writes - part of Control Register (CR)
	 * 
	 * 0 The bufferable write signal (hprot[2]) is not asserted
	 * during AMBA AHB writes.
	 * 
	 * 1 The bufferable write signal (hprot[2]) is asserted on
	 * all AMBA AHB writes except for the last write
	 * sequence.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CREBW</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREBW()
	 * @see #unsetCREBW()
	 * @see #setCREBW(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_CREBW()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_EBW' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCREBW();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getCREBW <em>CREBW</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CREBW</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREBW()
	 * @see #unsetCREBW()
	 * @see #getCREBW()
	 * @generated
	 */
	void setCREBW(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAType#getCREBW <em>CREBW</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCREBW()
	 * @see #getCREBW()
	 * @see #setCREBW(TypeBoolean)
	 * @generated
	 */
	void unsetCREBW();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAType#getCREBW <em>CREBW</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CREBW</em>' attribute is set.
	 * @see #unsetCREBW()
	 * @see #getCREBW()
	 * @see #setCREBW(TypeBoolean)
	 * @generated
	 */
	boolean isSetCREBW();

	/**
	 * Returns the value of the '<em><b>CREDBG</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable Debug - part of Control Register (CR)
	 * 
	 * 0 The assertion of the device debug mode is ignored.
	 * 
	 * 1 The assertion of the device debug mode causes the
	 * eDMA to stall the start of a new channel. Executing
	 * channels are allowed to complete. Channel
	 * execution will resume when either the device comes
	 * out of debug mode or the EDBG bit is cleared.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CREDBG</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREDBG()
	 * @see #unsetCREDBG()
	 * @see #setCREDBG(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_CREDBG()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_EDBG' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCREDBG();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getCREDBG <em>CREDBG</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CREDBG</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCREDBG()
	 * @see #unsetCREDBG()
	 * @see #getCREDBG()
	 * @generated
	 */
	void setCREDBG(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAType#getCREDBG <em>CREDBG</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCREDBG()
	 * @see #getCREDBG()
	 * @see #setCREDBG(TypeBoolean)
	 * @generated
	 */
	void unsetCREDBG();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAType#getCREDBG <em>CREDBG</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CREDBG</em>' attribute is set.
	 * @see #unsetCREDBG()
	 * @see #getCREDBG()
	 * @see #setCREDBG(TypeBoolean)
	 * @generated
	 */
	boolean isSetCREDBG();

	/**
	 * Returns the value of the '<em><b>CRHALT</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Halt DMA Operations - part of Control Register (CR)
	 * 
	 * 0 Normal operation.
	 * 
	 * 1 Stall the start of any new channels. 
	 * Executing channels are allowed to complete. Channel
	 * execution will resume when the HALT bit is cleared.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CRHALT</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRHALT()
	 * @see #unsetCRHALT()
	 * @see #setCRHALT(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_CRHALT()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_HALT' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCRHALT();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getCRHALT <em>CRHALT</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CRHALT</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRHALT()
	 * @see #unsetCRHALT()
	 * @see #getCRHALT()
	 * @generated
	 */
	void setCRHALT(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAType#getCRHALT <em>CRHALT</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCRHALT()
	 * @see #getCRHALT()
	 * @see #setCRHALT(TypeBoolean)
	 * @generated
	 */
	void unsetCRHALT();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAType#getCRHALT <em>CRHALT</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CRHALT</em>' attribute is set.
	 * @see #unsetCRHALT()
	 * @see #getCRHALT()
	 * @see #setCRHALT(TypeBoolean)
	 * @generated
	 */
	boolean isSetCRHALT();

	/**
	 * Returns the value of the '<em><b>CRHOE</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Halt On Error - part of Control Register (CR)
	 * 
	 * 0 Normal operation.
	 * 
	 * 1 Any error will cause the HALT bit to be set.
	 * Subsequently, all service requests will be ignored
	 * until the HALT bit is cleared.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CRHOE</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRHOE()
	 * @see #unsetCRHOE()
	 * @see #setCRHOE(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_CRHOE()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CR_HOE' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCRHOE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getCRHOE <em>CRHOE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CRHOE</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCRHOE()
	 * @see #unsetCRHOE()
	 * @see #getCRHOE()
	 * @generated
	 */
	void setCRHOE(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAType#getCRHOE <em>CRHOE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCRHOE()
	 * @see #getCRHOE()
	 * @see #setCRHOE(TypeBoolean)
	 * @generated
	 */
	void unsetCRHOE();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAType#getCRHOE <em>CRHOE</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CRHOE</em>' attribute is set.
	 * @see #unsetCRHOE()
	 * @see #getCRHOE()
	 * @see #setCRHOE(TypeBoolean)
	 * @generated
	 */
	boolean isSetCRHOE();

	/**
	 * Returns the value of the '<em><b>Dma Channel Arbitration</b></em>' attribute.
	 * The default value is <code>"RoundRobin"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DmaChannelArbitrationType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Select arbitration method for DMA channel concurent access of DMA engine.
	 * 
	 * In fixed-priority arbitration, the highest priority channel requesting service is
	 * selected to execute. The priorities are assigned by the channel priority registers.
	 * 
	 * In round-robin arbitration mode, the channel priorities are ignored and the channels are
	 * cycled through, from channel 15 down to channel 0, without regard to priority.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dma Channel Arbitration</em>' attribute.
	 * @see SystemSparcClockMcu.DmaChannelArbitrationType
	 * @see #isSetDmaChannelArbitration()
	 * @see #unsetDmaChannelArbitration()
	 * @see #setDmaChannelArbitration(DmaChannelArbitrationType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDMAType_DmaChannelArbitration()
	 * @model default="RoundRobin" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='DmaChannelArbitration' namespace='##targetNamespace'"
	 * @generated
	 */
	DmaChannelArbitrationType getDmaChannelArbitration();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DMAType#getDmaChannelArbitration <em>Dma Channel Arbitration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Channel Arbitration</em>' attribute.
	 * @see SystemSparcClockMcu.DmaChannelArbitrationType
	 * @see #isSetDmaChannelArbitration()
	 * @see #unsetDmaChannelArbitration()
	 * @see #getDmaChannelArbitration()
	 * @generated
	 */
	void setDmaChannelArbitration(DmaChannelArbitrationType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DMAType#getDmaChannelArbitration <em>Dma Channel Arbitration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaChannelArbitration()
	 * @see #getDmaChannelArbitration()
	 * @see #setDmaChannelArbitration(DmaChannelArbitrationType)
	 * @generated
	 */
	void unsetDmaChannelArbitration();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DMAType#getDmaChannelArbitration <em>Dma Channel Arbitration</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Channel Arbitration</em>' attribute is set.
	 * @see #unsetDmaChannelArbitration()
	 * @see #getDmaChannelArbitration()
	 * @see #setDmaChannelArbitration(DmaChannelArbitrationType)
	 * @generated
	 */
	boolean isSetDmaChannelArbitration();

} // DMAType
