/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Data Flash Operating Mode Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDataFlashOperatingModeType()
 * @model extendedMetaData="name='DataFlash_Operating_Mode_._type'"
 * @generated
 */
public enum DataFlashOperatingModeType implements Enumerator {
	/**
	 * The '<em><b>Power Down</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #POWER_DOWN_VALUE
	 * @generated
	 * @ordered
	 */
	POWER_DOWN(0, "PowerDown", "PowerDown"),

	/**
	 * The '<em><b>Low Power</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOW_POWER_VALUE
	 * @generated
	 * @ordered
	 */
	LOW_POWER(1, "LowPower", "LowPower"),

	/**
	 * The '<em><b>Normal Mode</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NORMAL_MODE_VALUE
	 * @generated
	 * @ordered
	 */
	NORMAL_MODE(2, "NormalMode", "NormalMode");

	/**
	 * The '<em><b>Power Down</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Power Down</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #POWER_DOWN
	 * @model name="PowerDown"
	 * @generated
	 * @ordered
	 */
	public static final int POWER_DOWN_VALUE = 0;

	/**
	 * The '<em><b>Low Power</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Low Power</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOW_POWER
	 * @model name="LowPower"
	 * @generated
	 * @ordered
	 */
	public static final int LOW_POWER_VALUE = 1;

	/**
	 * The '<em><b>Normal Mode</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Normal Mode</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NORMAL_MODE
	 * @model name="NormalMode"
	 * @generated
	 * @ordered
	 */
	public static final int NORMAL_MODE_VALUE = 2;

	/**
	 * An array of all the '<em><b>Data Flash Operating Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DataFlashOperatingModeType[] VALUES_ARRAY =
		new DataFlashOperatingModeType[] {
			POWER_DOWN,
			LOW_POWER,
			NORMAL_MODE,
		};

	/**
	 * A public read-only list of all the '<em><b>Data Flash Operating Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<DataFlashOperatingModeType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Data Flash Operating Mode Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataFlashOperatingModeType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataFlashOperatingModeType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Flash Operating Mode Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataFlashOperatingModeType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataFlashOperatingModeType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Flash Operating Mode Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataFlashOperatingModeType get(int value) {
		switch (value) {
			case POWER_DOWN_VALUE: return POWER_DOWN;
			case LOW_POWER_VALUE: return LOW_POWER;
			case NORMAL_MODE_VALUE: return NORMAL_MODE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DataFlashOperatingModeType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //DataFlashOperatingModeType
