/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Dma Transfer Control Descriptor Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getTCDADVANCEDCONFIGURATION <em>TCDADVANCEDCONFIGURATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDLASTSGA <em>DLASTSGA</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDmaTransferType <em>Dma Transfer Type</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDMOD <em>DMOD</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDOFF <em>DOFF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDSIZE <em>DSIZE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTHALF <em>INTHALF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTMAJ <em>INTMAJ</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSLAST <em>SLAST</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSMOD <em>SMOD</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSOFF <em>SOFF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSSIZE <em>SSIZE</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType()
 * @model extendedMetaData="name='DmaTransferControlDescriptor_._type' kind='elementOnly'"
 * @generated
 */
public interface DmaTransferControlDescriptorType extends EObject {
	/**
	 * Returns the value of the '<em><b>TCDADVANCEDCONFIGURATION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains all TCD Advanced configuration.
	 * 
	 * All the parameters contained in this container have default values and they shall remain the same.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>TCDADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #setTCDADVANCEDCONFIGURATION(TCDADVANCEDCONFIGURATIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_TCDADVANCEDCONFIGURATION()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='TCD_ADVANCED_CONFIGURATION' namespace='##targetNamespace'"
	 * @generated
	 */
	TCDADVANCEDCONFIGURATIONType getTCDADVANCEDCONFIGURATION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getTCDADVANCEDCONFIGURATION <em>TCDADVANCEDCONFIGURATION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>TCDADVANCEDCONFIGURATION</em>' containment reference.
	 * @see #getTCDADVANCEDCONFIGURATION()
	 * @generated
	 */
	void setTCDADVANCEDCONFIGURATION(TCDADVANCEDCONFIGURATIONType value);

	/**
	 * Returns the value of the '<em><b>DLASTSGA</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Last destination address adjustment. 
	 * 
	 * Adjustment value added to the destination address at the completion of the outer major iteration count.
	 * This value can be applied to restore the destination address to the initial value, 
	 * or adjust the address to reference the next data structure.
	 * The adjustment is given in bytes.
	 * 
	 * Note: 
	 * When the E_SG is set, this field should be 0. To adjust the destination to reference the next data structure, 
	 * the DestinationOffset_SG from TCDAdvanced Configuration is used. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DLASTSGA</em>' attribute.
	 * @see #setDLASTSGA(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_DLASTSGA()
	 * @model dataType="SystemSparcClockMcu.DLASTSGAType" required="true"
	 *        extendedMetaData="kind='attribute' name='DLAST_SGA' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDLASTSGA();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDLASTSGA <em>DLASTSGA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DLASTSGA</em>' attribute.
	 * @see #getDLASTSGA()
	 * @generated
	 */
	void setDLASTSGA(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Dma Transfer Type</b></em>' attribute.
	 * The default value is <code>"Single"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DmaTransferTypeType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dma Transfer Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dma Transfer Type</em>' attribute.
	 * @see SystemSparcClockMcu.DmaTransferTypeType
	 * @see #isSetDmaTransferType()
	 * @see #unsetDmaTransferType()
	 * @see #setDmaTransferType(DmaTransferTypeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_DmaTransferType()
	 * @model default="Single" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='DmaTransferType' namespace='##targetNamespace'"
	 * @generated
	 */
	DmaTransferTypeType getDmaTransferType();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDmaTransferType <em>Dma Transfer Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dma Transfer Type</em>' attribute.
	 * @see SystemSparcClockMcu.DmaTransferTypeType
	 * @see #isSetDmaTransferType()
	 * @see #unsetDmaTransferType()
	 * @see #getDmaTransferType()
	 * @generated
	 */
	void setDmaTransferType(DmaTransferTypeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDmaTransferType <em>Dma Transfer Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDmaTransferType()
	 * @see #getDmaTransferType()
	 * @see #setDmaTransferType(DmaTransferTypeType)
	 * @generated
	 */
	void unsetDmaTransferType();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDmaTransferType <em>Dma Transfer Type</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dma Transfer Type</em>' attribute is set.
	 * @see #unsetDmaTransferType()
	 * @see #getDmaTransferType()
	 * @see #setDmaTransferType(DmaTransferTypeType)
	 * @generated
	 */
	boolean isSetDmaTransferType();

	/**
	 * Returns the value of the '<em><b>DMOD</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Destination address modulo.
	 * 
	 * 0 Destination address modulo feature is disabled.
	 * non-0 This value defines a specific address range that is specified to be the
	 * value after DADDR + DOFF calculation is performed or the original
	 * register value. The setting of this field provides the ability to easily
	 * implement a circular data queue. For data queues requiring
	 * power-of-2 size bytes, the queue should start at a 0-modulo-size
	 * address and the DMOD field should be set to the appropriate value
	 * for the queue, freezing the desired number of upper address bits.
	 * The value programmed into this field specifies the number of lower
	 * address bits that are allowed to change. For this circular queue
	 * application, the DOFF is typically set to the transfer size to implement
	 * post-increment addressing with the DMOD function constraining the
	 * addresses to a 0-modulo-size range.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DMOD</em>' attribute.
	 * @see #setDMOD(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_DMOD()
	 * @model dataType="SystemSparcClockMcu.DMODType" required="true"
	 *        extendedMetaData="kind='attribute' name='DMOD' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDMOD();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDMOD <em>DMOD</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DMOD</em>' attribute.
	 * @see #getDMOD()
	 * @generated
	 */
	void setDMOD(BigInteger value);

	/**
	 * Returns the value of the '<em><b>DOFF</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Destination address signed Offset. 
	 * 
	 * Sign-extended offset applied to the
	 * current destination address to form the 
	 * next-state value as each destination
	 * write is completed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DOFF</em>' attribute.
	 * @see #setDOFF(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_DOFF()
	 * @model dataType="SystemSparcClockMcu.DOFFType" required="true"
	 *        extendedMetaData="kind='attribute' name='DOFF' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDOFF();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDOFF <em>DOFF</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DOFF</em>' attribute.
	 * @see #getDOFF()
	 * @generated
	 */
	void setDOFF(BigInteger value);

	/**
	 * Returns the value of the '<em><b>DSIZE</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DSIZEType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Source data transfer size.
	 *  8-bit
	 * 16-bit
	 * 32-bit
	 * 16-byte (32-bit, 4-beat, WRAP4 burst)
	 * 32-byte (32-bit, 8 beat, WRAP8 burst)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DSIZE</em>' attribute.
	 * @see SystemSparcClockMcu.DSIZEType
	 * @see #isSetDSIZE()
	 * @see #unsetDSIZE()
	 * @see #setDSIZE(DSIZEType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_DSIZE()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='DSIZE' namespace='##targetNamespace'"
	 * @generated
	 */
	DSIZEType getDSIZE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDSIZE <em>DSIZE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DSIZE</em>' attribute.
	 * @see SystemSparcClockMcu.DSIZEType
	 * @see #isSetDSIZE()
	 * @see #unsetDSIZE()
	 * @see #getDSIZE()
	 * @generated
	 */
	void setDSIZE(DSIZEType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDSIZE <em>DSIZE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDSIZE()
	 * @see #getDSIZE()
	 * @see #setDSIZE(DSIZEType)
	 * @generated
	 */
	void unsetDSIZE();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getDSIZE <em>DSIZE</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>DSIZE</em>' attribute is set.
	 * @see #unsetDSIZE()
	 * @see #getDSIZE()
	 * @see #setDSIZE(DSIZEType)
	 * @generated
	 */
	boolean isSetDSIZE();

	/**
	 * Returns the value of the '<em><b>INTHALF</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable an interrupt when major counter is half complete.
	 * 
	 * If this flag is set, the channel generates an interrupt request by setting 
	 * the appropriate bit in the EDMA_ERQRL when the current major iteration
	 * count reaches the halfway point. 
	 * 
	 * 0 The half-point interrupt is disabled.
	 * 1 The half-point interrupt is enabled.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>INTHALF</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetINTHALF()
	 * @see #unsetINTHALF()
	 * @see #setINTHALF(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_INTHALF()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='INT_HALF' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getINTHALF();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTHALF <em>INTHALF</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>INTHALF</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetINTHALF()
	 * @see #unsetINTHALF()
	 * @see #getINTHALF()
	 * @generated
	 */
	void setINTHALF(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTHALF <em>INTHALF</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetINTHALF()
	 * @see #getINTHALF()
	 * @see #setINTHALF(TypeBoolean)
	 * @generated
	 */
	void unsetINTHALF();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTHALF <em>INTHALF</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>INTHALF</em>' attribute is set.
	 * @see #unsetINTHALF()
	 * @see #getINTHALF()
	 * @see #setINTHALF(TypeBoolean)
	 * @generated
	 */
	boolean isSetINTHALF();

	/**
	 * Returns the value of the '<em><b>INTMAJ</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enable an interrupt when major iteration count completes. 
	 * 
	 * If this flag is set, the channel generates an interrupt request by setting the appropriate bit in
	 * the EDMA_ERQRL when the current major iteration count reaches zero.
	 * 
	 * 0 The end-of-major loop interrupt is disabled.
	 * 1 The end-of-major loop interrupt is enabled.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>INTMAJ</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetINTMAJ()
	 * @see #unsetINTMAJ()
	 * @see #setINTMAJ(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_INTMAJ()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='INT_MAJ' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getINTMAJ();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTMAJ <em>INTMAJ</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>INTMAJ</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetINTMAJ()
	 * @see #unsetINTMAJ()
	 * @see #getINTMAJ()
	 * @generated
	 */
	void setINTMAJ(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTMAJ <em>INTMAJ</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetINTMAJ()
	 * @see #getINTMAJ()
	 * @see #setINTMAJ(TypeBoolean)
	 * @generated
	 */
	void unsetINTMAJ();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getINTMAJ <em>INTMAJ</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>INTMAJ</em>' attribute is set.
	 * @see #unsetINTMAJ()
	 * @see #getINTMAJ()
	 * @see #setINTMAJ(TypeBoolean)
	 * @generated
	 */
	boolean isSetINTMAJ();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * DMA channel identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType35" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>SLAST</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Last source address adjustment. 
	 * 
	 * Adjustment value added to the source address at the completion of the outer major iteration count. 
	 * This value can be applied to ?restore? the source address to the initial value, 
	 * or adjust the address to reference the next data structure.
	 * The adjustment is given in bytes.
	 *  
	 * Note: 
	 * When the E_SG is set, this field should be 0. To adjust the address to reference the next data structure, 
	 * the SourceOffset_SG from TCDAdvanced Configuration is used. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SLAST</em>' attribute.
	 * @see #setSLAST(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_SLAST()
	 * @model dataType="SystemSparcClockMcu.SLASTType" required="true"
	 *        extendedMetaData="kind='attribute' name='SLAST' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSLAST();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSLAST <em>SLAST</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SLAST</em>' attribute.
	 * @see #getSLAST()
	 * @generated
	 */
	void setSLAST(BigInteger value);

	/**
	 * Returns the value of the '<em><b>SMOD</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Source address modulo.
	 * 
	 * 0 Source address modulo feature is disabled.
	 * 
	 * non-0 This value defines a specific address range that is specified to be the
	 * value after SADDR + SOFF calculation is performed or the original
	 * register value. 
	 * 
	 * The setting of this field provides the ability to easily
	 * implement a circular data queue. For data queues requiring
	 * power-of-2 size bytes, the queue should start at a 0-modulo-size
	 * address and the SMOD field should be set to the appropriate value
	 * for the queue, freezing the desired number of upper address bits.
	 * The value programmed into this field specifies the number of lower
	 * address bits that are allowed to change. For this circular queue
	 * application, the SOFF is typically set to the transfer size to implement
	 * post-increment addressing with the SMOD function constraining the
	 * addresses to a 0-modulo-size range.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SMOD</em>' attribute.
	 * @see #setSMOD(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_SMOD()
	 * @model dataType="SystemSparcClockMcu.SMODType" required="true"
	 *        extendedMetaData="kind='attribute' name='SMOD' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSMOD();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSMOD <em>SMOD</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SMOD</em>' attribute.
	 * @see #getSMOD()
	 * @generated
	 */
	void setSMOD(BigInteger value);

	/**
	 * Returns the value of the '<em><b>SOFF</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Source address signed offset.
	 * 
	 * Sign-extended offset applied to the current
	 * source address to form the next-state value 
	 * as each source read is completed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SOFF</em>' attribute.
	 * @see #setSOFF(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_SOFF()
	 * @model dataType="SystemSparcClockMcu.SOFFType" required="true"
	 *        extendedMetaData="kind='attribute' name='SOFF' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSOFF();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSOFF <em>SOFF</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SOFF</em>' attribute.
	 * @see #getSOFF()
	 * @generated
	 */
	void setSOFF(BigInteger value);

	/**
	 * Returns the value of the '<em><b>SSIZE</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SSIZEType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Source data transfer size.
	 *  8-bit
	 * 16-bit
	 * 32-bit
	 * 16-byte (32-bit, 4-beat, WRAP4 burst)
	 * 32-byte (32-bit, 8 beat, WRAP8 burst)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SSIZE</em>' attribute.
	 * @see SystemSparcClockMcu.SSIZEType
	 * @see #isSetSSIZE()
	 * @see #unsetSSIZE()
	 * @see #setSSIZE(SSIZEType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getDmaTransferControlDescriptorType_SSIZE()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='SSIZE' namespace='##targetNamespace'"
	 * @generated
	 */
	SSIZEType getSSIZE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSSIZE <em>SSIZE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SSIZE</em>' attribute.
	 * @see SystemSparcClockMcu.SSIZEType
	 * @see #isSetSSIZE()
	 * @see #unsetSSIZE()
	 * @see #getSSIZE()
	 * @generated
	 */
	void setSSIZE(SSIZEType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSSIZE <em>SSIZE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSSIZE()
	 * @see #getSSIZE()
	 * @see #setSSIZE(SSIZEType)
	 * @generated
	 */
	void unsetSSIZE();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.DmaTransferControlDescriptorType#getSSIZE <em>SSIZE</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>SSIZE</em>' attribute is set.
	 * @see #unsetSSIZE()
	 * @see #getSSIZE()
	 * @see #setSSIZE(SSIZEType)
	 * @generated
	 */
	boolean isSetSSIZE();

} // DmaTransferControlDescriptorType
