/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ECUM Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getDRIVERINITZERO <em>DRIVERINITZERO</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getDRIVERINITONE <em>DRIVERINITONE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getDRIVERINITTWO <em>DRIVERINITTWO</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getDRIVERINITTHREE <em>DRIVERINITTHREE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getDRIVERRESTARTLIST <em>DRIVERRESTARTLIST</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getECUMSLEEPMODE <em>ECUMSLEEPMODE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getUSERCONFIG <em>USERCONFIG</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getWAKEUPSOURCE <em>WAKEUPSOURCE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getECUMCALLOUTCONFIGURATION <em>ECUMCALLOUTCONFIGURATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getComMRunReqChannels <em>Com MRun Req Channels</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getConfigurationPBAddress <em>Configuration PB Address</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getIncludeDem <em>Include Dem</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getIncludeRte <em>Include Rte</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getOsLockSchedResourceRef <em>Os Lock Sched Resource Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ECUMType#getSupervisedEntityRef <em>Supervised Entity Ref</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType()
 * @model extendedMetaData="name='ECUM_._type' kind='elementOnly'"
 * @generated
 */
public interface ECUMType extends EObject {
	/**
	 * Returns the value of the '<em><b>DRIVERINITZERO</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Container for Init Block 0.
	 * 
	 * This container holds a list of module IDs that will be initialised. Each module in the list will be called for initialisation in the list order.
	 * 
	 * All modules in this list are initilialised before the post-build configuration has been loaded and the OS is initialized. Therefore, these modules may not use post-build configuration.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DRIVERINITZERO</em>' containment reference.
	 * @see #setDRIVERINITZERO(EcuMDriverInitItemAttr)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_DRIVERINITZERO()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DRIVER_INIT_ZERO' namespace='##targetNamespace'"
	 * @generated
	 */
	EcuMDriverInitItemAttr getDRIVERINITZERO();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getDRIVERINITZERO <em>DRIVERINITZERO</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DRIVERINITZERO</em>' containment reference.
	 * @see #getDRIVERINITZERO()
	 * @generated
	 */
	void setDRIVERINITZERO(EcuMDriverInitItemAttr value);

	/**
	 * Returns the value of the '<em><b>DRIVERINITONE</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Container for Init Block I.
	 * 
	 * This container holds a list of module IDs that will be initialised. Each module in the list will be called for initialisation in the list order.
	 * 
	 * All modules in this list are initilialised before the OS is started and so these modules require no OS support.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DRIVERINITONE</em>' containment reference.
	 * @see #setDRIVERINITONE(EcuMDriverInitItemAttr)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_DRIVERINITONE()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DRIVER_INIT_ONE' namespace='##targetNamespace'"
	 * @generated
	 */
	EcuMDriverInitItemAttr getDRIVERINITONE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getDRIVERINITONE <em>DRIVERINITONE</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DRIVERINITONE</em>' containment reference.
	 * @see #getDRIVERINITONE()
	 * @generated
	 */
	void setDRIVERINITONE(EcuMDriverInitItemAttr value);

	/**
	 * Returns the value of the '<em><b>DRIVERINITTWO</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Container for Init Block II.
	 * 
	 * This container holds a list of module IDs that will be initialised. Each module in the list will be called for initialisation in the list order.
	 * 
	 * All modules in this list are initilialised after the OS is started and so these modules may use OS support. These modules may not rely on the Nvram ReadAll job to have provided all data.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DRIVERINITTWO</em>' containment reference.
	 * @see #setDRIVERINITTWO(EcuMDriverInitItemAttr)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_DRIVERINITTWO()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DRIVER_INIT_TWO' namespace='##targetNamespace'"
	 * @generated
	 */
	EcuMDriverInitItemAttr getDRIVERINITTWO();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getDRIVERINITTWO <em>DRIVERINITTWO</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DRIVERINITTWO</em>' containment reference.
	 * @see #getDRIVERINITTWO()
	 * @generated
	 */
	void setDRIVERINITTWO(EcuMDriverInitItemAttr value);

	/**
	 * Returns the value of the '<em><b>DRIVERINITTHREE</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Container for Init Block III.
	 * 
	 * This container holds a list of module IDs that will be initialised. Each module in the list will be called for initialisation in the list order.
	 * 
	 * All modules in this list are initilialised after the OS is started and so these modules may use OS support. These modules may also rely on the Nvram ReadAll job to have provided all data.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DRIVERINITTHREE</em>' containment reference.
	 * @see #setDRIVERINITTHREE(EcuMDriverInitItemAttr)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_DRIVERINITTHREE()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DRIVER_INIT_THREE' namespace='##targetNamespace'"
	 * @generated
	 */
	EcuMDriverInitItemAttr getDRIVERINITTHREE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getDRIVERINITTHREE <em>DRIVERINITTHREE</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DRIVERINITTHREE</em>' containment reference.
	 * @see #getDRIVERINITTHREE()
	 * @generated
	 */
	void setDRIVERINITTHREE(EcuMDriverInitItemAttr value);

	/**
	 * Returns the value of the '<em><b>DRIVERRESTARTLIST</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * List of module IDs.
	 * 
	 * A configuration tool shall fill the callout EcuM_AL_DriverRestart with initialization calls to the listed drivers in the order in which they occur in the list.
	 * 
	 * Entries in this list must appear in the same order as in the combined list of EcuM_DriverInitListOne and EcuM_DriverInitListTwo. This list may be a real subset though. In all other cases, the generation tool shall report an error.
	 * 
	 * The included container has the same structure as EcuM_DriverInitItem.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DRIVERRESTARTLIST</em>' containment reference.
	 * @see #setDRIVERRESTARTLIST(EcuMDriverInitItemAttr)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_DRIVERRESTARTLIST()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DRIVER_RESTART_LIST' namespace='##targetNamespace'"
	 * @generated
	 */
	EcuMDriverInitItemAttr getDRIVERRESTARTLIST();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getDRIVERRESTARTLIST <em>DRIVERRESTARTLIST</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DRIVERRESTARTLIST</em>' containment reference.
	 * @see #getDRIVERRESTARTLIST()
	 * @generated
	 */
	void setDRIVERRESTARTLIST(EcuMDriverInitItemAttr value);

	/**
	 * Returns the value of the '<em><b>ECUMSLEEPMODE</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Configuration of the SLEEP mode.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>ECUMSLEEPMODE</em>' containment reference.
	 * @see #setECUMSLEEPMODE(ECUMSLEEPMODEType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_ECUMSLEEPMODE()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='ECUM_SLEEP_MODE' namespace='##targetNamespace'"
	 * @generated
	 */
	ECUMSLEEPMODEType getECUMSLEEPMODE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getECUMSLEEPMODE <em>ECUMSLEEPMODE</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>ECUMSLEEPMODE</em>' containment reference.
	 * @see #getECUMSLEEPMODE()
	 * @generated
	 */
	void setECUMSLEEPMODE(ECUMSLEEPMODEType value);

	/**
	 * Returns the value of the '<em><b>USERCONFIG</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.USERCONFIGType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A list of identifiers that are needed to refer to a software component or another appropriate entity in the system which is designated to request the RUN state. Application requestors refer to entities above RTE, system requestors to entities below RTE (e.g. Communication Manager).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>USERCONFIG</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_USERCONFIG()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='USER_CONFIG' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<USERCONFIGType> getUSERCONFIG();

	/**
	 * Returns the value of the '<em><b>WAKEUPSOURCE</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.WAKEUPSOURCEType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * List of configuration items for the wakeup sources.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>WAKEUPSOURCE</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_WAKEUPSOURCE()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='WAKEUP_SOURCE' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<WAKEUPSOURCEType> getWAKEUPSOURCE();

	/**
	 * Returns the value of the '<em><b>ECUMCALLOUTCONFIGURATION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>ECUMCALLOUTCONFIGURATION</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>ECUMCALLOUTCONFIGURATION</em>' containment reference.
	 * @see #setECUMCALLOUTCONFIGURATION(ECUMCALLOUTCONFIGURATIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_ECUMCALLOUTCONFIGURATION()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='ECUM_CALLOUT_CONFIGURATION' namespace='##targetNamespace'"
	 * @generated
	 */
	ECUMCALLOUTCONFIGURATIONType getECUMCALLOUTCONFIGURATION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getECUMCALLOUTCONFIGURATION <em>ECUMCALLOUTCONFIGURATION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>ECUMCALLOUTCONFIGURATION</em>' containment reference.
	 * @see #getECUMCALLOUTCONFIGURATION()
	 * @generated
	 */
	void setECUMCALLOUTCONFIGURATION(ECUMCALLOUTCONFIGURATIONType value);

	/**
	 * Returns the value of the '<em><b>Com MRun Req Channels</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * ComM channels that are alowed to request RUN mode.
	 * 
	 * Enter the list of channels like:
	 * Ch0, Ch1, Ch3
	 * 
	 * Where Chx is the short name of the ComM channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Com MRun Req Channels</em>' attribute.
	 * @see #setComMRunReqChannels(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_ComMRunReqChannels()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String"
	 *        extendedMetaData="kind='attribute' name='ComMRunReqChannels' namespace='##targetNamespace'"
	 * @generated
	 */
	String getComMRunReqChannels();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getComMRunReqChannels <em>Com MRun Req Channels</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Com MRun Req Channels</em>' attribute.
	 * @see #getComMRunReqChannels()
	 * @generated
	 */
	void setComMRunReqChannels(String value);

	/**
	 * Returns the value of the '<em><b>Configuration PB Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The start address of the EcuM configuration located in the Post Build memory area.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Configuration PB Address</em>' attribute.
	 * @see #setConfigurationPBAddress(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_ConfigurationPBAddress()
	 * @model dataType="SystemSparcClockMcu.ConfigurationPBAddressType" required="true"
	 *        extendedMetaData="kind='attribute' name='ConfigurationPBAddress' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getConfigurationPBAddress();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getConfigurationPBAddress <em>Configuration PB Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Configuration PB Address</em>' attribute.
	 * @see #getConfigurationPBAddress()
	 * @generated
	 */
	void setConfigurationPBAddress(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Include Dem</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Include Dem</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Include Dem</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIncludeDem()
	 * @see #unsetIncludeDem()
	 * @see #setIncludeDem(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_IncludeDem()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='IncludeDem' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getIncludeDem();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeDem <em>Include Dem</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Include Dem</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIncludeDem()
	 * @see #unsetIncludeDem()
	 * @see #getIncludeDem()
	 * @generated
	 */
	void setIncludeDem(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeDem <em>Include Dem</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIncludeDem()
	 * @see #getIncludeDem()
	 * @see #setIncludeDem(TypeBoolean)
	 * @generated
	 */
	void unsetIncludeDem();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeDem <em>Include Dem</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Include Dem</em>' attribute is set.
	 * @see #unsetIncludeDem()
	 * @see #getIncludeDem()
	 * @see #setIncludeDem(TypeBoolean)
	 * @generated
	 */
	boolean isSetIncludeDem();

	/**
	 * Returns the value of the '<em><b>Include Rte</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Include Rte</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Include Rte</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIncludeRte()
	 * @see #unsetIncludeRte()
	 * @see #setIncludeRte(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_IncludeRte()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='IncludeRte' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getIncludeRte();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeRte <em>Include Rte</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Include Rte</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIncludeRte()
	 * @see #unsetIncludeRte()
	 * @see #getIncludeRte()
	 * @generated
	 */
	void setIncludeRte(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeRte <em>Include Rte</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIncludeRte()
	 * @see #getIncludeRte()
	 * @see #setIncludeRte(TypeBoolean)
	 * @generated
	 */
	void unsetIncludeRte();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.ECUMType#getIncludeRte <em>Include Rte</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Include Rte</em>' attribute is set.
	 * @see #unsetIncludeRte()
	 * @see #getIncludeRte()
	 * @see #setIncludeRte(TypeBoolean)
	 * @generated
	 */
	boolean isSetIncludeRte();

	/**
	 * Returns the value of the '<em><b>Os Lock Sched Resource Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter references the OSEK resource used to "lock" and "unlock" the Scheduler (mentioned as RES_SCHEDULER).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Lock Sched Resource Ref</em>' attribute.
	 * @see #setOsLockSchedResourceRef(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_OsLockSchedResourceRef()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='OsLockSchedResourceRef' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getOsLockSchedResourceRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getOsLockSchedResourceRef <em>Os Lock Sched Resource Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Lock Sched Resource Ref</em>' attribute.
	 * @see #getOsLockSchedResourceRef()
	 * @generated
	 */
	void setOsLockSchedResourceRef(Object value);

	/**
	 * Returns the value of the '<em><b>Supervised Entity Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter references the Supervised Entity ID that way configured for EcuM in the Watchdog Manager.
	 * 
	 * If defined, WdgM is used.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Supervised Entity Ref</em>' attribute.
	 * @see #setSupervisedEntityRef(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getECUMType_SupervisedEntityRef()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType"
	 *        extendedMetaData="kind='attribute' name='SupervisedEntityRef' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getSupervisedEntityRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ECUMType#getSupervisedEntityRef <em>Supervised Entity Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supervised Entity Ref</em>' attribute.
	 * @see #getSupervisedEntityRef()
	 * @generated
	 */
	void setSupervisedEntityRef(Object value);

} // ECUMType
