/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EMIOS Conf Attr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.EMIOSConfAttr#getEmiosChannel <em>Emios Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.EMIOSConfAttr#getOsFreeze <em>Os Freeze</em>}</li>
 *   <li>{@link SystemSparcClockMcu.EMIOSConfAttr#getOsGlobalMIOSPrescaler <em>Os Global MIOS Prescaler</em>}</li>
 *   <li>{@link SystemSparcClockMcu.EMIOSConfAttr#getOsPeripheralClockDivider <em>Os Peripheral Clock Divider</em>}</li>
 *   <li>{@link SystemSparcClockMcu.EMIOSConfAttr#getOsPrescaler <em>Os Prescaler</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr()
 * @model extendedMetaData="name='eMIOSConf_Attr' kind='empty'"
 * @generated
 */
public interface EMIOSConfAttr extends EObject {
	/**
	 * Returns the value of the '<em><b>Emios Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies which compare channel is used (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/eMIOSn/Channel).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Emios Channel</em>' attribute.
	 * @see #setEmiosChannel(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr_EmiosChannel()
	 * @model dataType="SystemSparcClockMcu.EmiosChannelType" required="true"
	 *        extendedMetaData="kind='attribute' name='EmiosChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getEmiosChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getEmiosChannel <em>Emios Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Emios Channel</em>' attribute.
	 * @see #getEmiosChannel()
	 * @generated
	 */
	void setEmiosChannel(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Freeze</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies timer freeze bit value (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/eMIOSn/Freeze).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Freeze</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsFreeze()
	 * @see #unsetOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr_OsFreeze()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsFreeze' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsFreeze();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsFreeze <em>Os Freeze</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Freeze</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsFreeze()
	 * @see #unsetOsFreeze()
	 * @see #getOsFreeze()
	 * @generated
	 */
	void setOsFreeze(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsFreeze <em>Os Freeze</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsFreeze()
	 * @see #getOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @generated
	 */
	void unsetOsFreeze();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsFreeze <em>Os Freeze</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Freeze</em>' attribute is set.
	 * @see #unsetOsFreeze()
	 * @see #getOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsFreeze();

	/**
	 * Returns the value of the '<em><b>Os Global MIOS Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies either USER or OS Global prescaler shall be initialized during OS startup (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/eMIOSn/GlobalMIOSPrescaler).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Global MIOS Prescaler</em>' attribute.
	 * @see #setOsGlobalMIOSPrescaler(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr_OsGlobalMIOSPrescaler()
	 * @model dataType="SystemSparcClockMcu.OsGlobalMIOSPrescalerType" required="true"
	 *        extendedMetaData="kind='attribute' name='OsGlobalMIOSPrescaler' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsGlobalMIOSPrescaler();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsGlobalMIOSPrescaler <em>Os Global MIOS Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Global MIOS Prescaler</em>' attribute.
	 * @see #getOsGlobalMIOSPrescaler()
	 * @generated
	 */
	void setOsGlobalMIOSPrescaler(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Peripheral Clock Divider</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies which compare channel is used (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/eMIOSn/Channel).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Peripheral Clock Divider</em>' attribute.
	 * @see #setOsPeripheralClockDivider(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr_OsPeripheralClockDivider()
	 * @model dataType="SystemSparcClockMcu.OsPeripheralClockDividerType" required="true"
	 *        extendedMetaData="kind='attribute' name='OsPeripheralClockDivider' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsPeripheralClockDivider();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsPeripheralClockDivider <em>Os Peripheral Clock Divider</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Peripheral Clock Divider</em>' attribute.
	 * @see #getOsPeripheralClockDivider()
	 * @generated
	 */
	void setOsPeripheralClockDivider(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies either USER or OS prescaler shall be initialized during OS startup (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/eMIOSn/Prescaler).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Prescaler</em>' attribute.
	 * @see #setOsPrescaler(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getEMIOSConfAttr_OsPrescaler()
	 * @model dataType="SystemSparcClockMcu.OsPrescalerType1" required="true"
	 *        extendedMetaData="kind='attribute' name='OsPrescaler' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsPrescaler();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.EMIOSConfAttr#getOsPrescaler <em>Os Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Prescaler</em>' attribute.
	 * @see #getOsPrescaler()
	 * @generated
	 */
	void setOsPrescaler(BigInteger value);

} // EMIOSConfAttr
