/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>GENERALCLOCKSETTINGS Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getMcuStartRunMode <em>Mcu Start Run Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getSystemClockSelect <em>System Clock Select</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getGENERALCLOCKSETTINGSType()
 * @model extendedMetaData="name='GENERAL_CLOCK_SETTINGS_._type' kind='empty'"
 * @generated
 */
public interface GENERALCLOCKSETTINGSType extends EObject {
	/**
	 * Returns the value of the '<em><b>Mcu Start Run Mode</b></em>' attribute.
	 * The default value is <code>"DRUN"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuStartRunModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies  the target device mode to be entered by MCU. Note: Implementation specific Parameter.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mcu Start Run Mode</em>' attribute.
	 * @see SystemSparcClockMcu.McuStartRunModeType
	 * @see #isSetMcuStartRunMode()
	 * @see #unsetMcuStartRunMode()
	 * @see #setMcuStartRunMode(McuStartRunModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getGENERALCLOCKSETTINGSType_McuStartRunMode()
	 * @model default="DRUN" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='McuStartRunMode' namespace='##targetNamespace'"
	 * @generated
	 */
	McuStartRunModeType getMcuStartRunMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getMcuStartRunMode <em>Mcu Start Run Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mcu Start Run Mode</em>' attribute.
	 * @see SystemSparcClockMcu.McuStartRunModeType
	 * @see #isSetMcuStartRunMode()
	 * @see #unsetMcuStartRunMode()
	 * @see #getMcuStartRunMode()
	 * @generated
	 */
	void setMcuStartRunMode(McuStartRunModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getMcuStartRunMode <em>Mcu Start Run Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetMcuStartRunMode()
	 * @see #getMcuStartRunMode()
	 * @see #setMcuStartRunMode(McuStartRunModeType)
	 * @generated
	 */
	void unsetMcuStartRunMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getMcuStartRunMode <em>Mcu Start Run Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Mcu Start Run Mode</em>' attribute is set.
	 * @see #unsetMcuStartRunMode()
	 * @see #getMcuStartRunMode()
	 * @see #setMcuStartRunMode(McuStartRunModeType)
	 * @generated
	 */
	boolean isSetMcuStartRunMode();

	/**
	 * Returns the value of the '<em><b>System Clock Select</b></em>' attribute.
	 * The default value is <code>"McuPLL"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SystemClockSelectType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * System Clock Select . The system clock is either internal 16 MHz IRC, 16 MHz IRC Div,  XOSC, XOSC Div , PLL or McuSystemClockDisabled.
	 * 
	 * Note: According to the errata e8761PS of MPC5604B and MPC5607B. The clock switching is a two step process. The availability of the target clock is first verified. Then the system clock is switched to the new target clock source within two target clock cycles. For the case when the FXOSC stops during the required two cycles, the switching process may not complete, causing the system clock to stop and prevent further clock switching. This may happen if one of the following cases occurs while the system clock source is switching to FXOSC:
	 * - FXOSC oscillator failure
	 * - SAFE mode request occurs, as this mode will immediately switch OFF the FXOSC (refer to ME_SAFE_MC register configuration).
	 * 
	 * Note: Implementation specific Parameter
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>System Clock Select</em>' attribute.
	 * @see SystemSparcClockMcu.SystemClockSelectType
	 * @see #isSetSystemClockSelect()
	 * @see #unsetSystemClockSelect()
	 * @see #setSystemClockSelect(SystemClockSelectType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getGENERALCLOCKSETTINGSType_SystemClockSelect()
	 * @model default="McuPLL" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SystemClockSelect' namespace='##targetNamespace'"
	 * @generated
	 */
	SystemClockSelectType getSystemClockSelect();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getSystemClockSelect <em>System Clock Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>System Clock Select</em>' attribute.
	 * @see SystemSparcClockMcu.SystemClockSelectType
	 * @see #isSetSystemClockSelect()
	 * @see #unsetSystemClockSelect()
	 * @see #getSystemClockSelect()
	 * @generated
	 */
	void setSystemClockSelect(SystemClockSelectType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getSystemClockSelect <em>System Clock Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSystemClockSelect()
	 * @see #getSystemClockSelect()
	 * @see #setSystemClockSelect(SystemClockSelectType)
	 * @generated
	 */
	void unsetSystemClockSelect();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.GENERALCLOCKSETTINGSType#getSystemClockSelect <em>System Clock Select</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>System Clock Select</em>' attribute is set.
	 * @see #unsetSystemClockSelect()
	 * @see #getSystemClockSelect()
	 * @see #setSystemClockSelect(SystemClockSelectType)
	 * @generated
	 */
	boolean isSetSystemClockSelect();

} // GENERALCLOCKSETTINGSType
