/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>INTERRUPTLOADMEASUREMENT Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.INTERRUPTLOADMEASUREMENTType#getIntLoadSlidingTimeWindowSize <em>Int Load Sliding Time Window Size</em>}</li>
 *   <li>{@link SystemSparcClockMcu.INTERRUPTLOADMEASUREMENTType#getIntLoadUpdateCycle <em>Int Load Update Cycle</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getINTERRUPTLOADMEASUREMENTType()
 * @model extendedMetaData="name='INTERRUPT_LOAD_MEASUREMENT_._type' kind='empty'"
 * @generated
 */
public interface INTERRUPTLOADMEASUREMENTType extends EObject {
	/**
	 * Returns the value of the '<em><b>Int Load Sliding Time Window Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the sliding time window size for Interrupt load measurement.
	 * Inside this time window, the Interrupt load value is evaluated each IntLoadUpdateCycle and the total of values calculated within this time window
	 * will be averaged in order to determine the Interrupt load value provided to user.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Int Load Sliding Time Window Size</em>' attribute.
	 * @see #setIntLoadSlidingTimeWindowSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getINTERRUPTLOADMEASUREMENTType_IntLoadSlidingTimeWindowSize()
	 * @model dataType="SystemSparcClockMcu.IntLoadSlidingTimeWindowSizeType"
	 *        extendedMetaData="kind='attribute' name='IntLoadSlidingTimeWindowSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getIntLoadSlidingTimeWindowSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.INTERRUPTLOADMEASUREMENTType#getIntLoadSlidingTimeWindowSize <em>Int Load Sliding Time Window Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Int Load Sliding Time Window Size</em>' attribute.
	 * @see #getIntLoadSlidingTimeWindowSize()
	 * @generated
	 */
	void setIntLoadSlidingTimeWindowSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Int Load Update Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies the reccurence of Interrupt load calculation within the sliding time window specified for average Interrupt load evaluation.
	 * This reccurence must have a smaller value that the corresponding sliding time window value.
	 * (e.g. if the sliding time window has 1000ms size and the calculation reccurence is 100ms,
	 * then 1000/100=10 values will be considered for average Interrupt load evaluation).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Int Load Update Cycle</em>' attribute.
	 * @see #setIntLoadUpdateCycle(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getINTERRUPTLOADMEASUREMENTType_IntLoadUpdateCycle()
	 * @model dataType="SystemSparcClockMcu.IntLoadUpdateCycleType"
	 *        extendedMetaData="kind='attribute' name='IntLoadUpdateCycle' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getIntLoadUpdateCycle();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.INTERRUPTLOADMEASUREMENTType#getIntLoadUpdateCycle <em>Int Load Update Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Int Load Update Cycle</em>' attribute.
	 * @see #getIntLoadUpdateCycle()
	 * @generated
	 */
	void setIntLoadUpdateCycle(BigInteger value);

} // INTERRUPTLOADMEASUREMENTType
