/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>JOB Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.JOBType#getCHANNELREF <em>CHANNELREF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.JOBType#getDeviceRef <em>Device Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.JOBType#getJobEndNotification <em>Job End Notification</em>}</li>
 *   <li>{@link SystemSparcClockMcu.JOBType#getJobPriority <em>Job Priority</em>}</li>
 *   <li>{@link SystemSparcClockMcu.JOBType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.JOBType#getPhysicalUnit <em>Physical Unit</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType()
 * @model extendedMetaData="name='JOB_._type' kind='elementOnly'"
 * @generated
 */
public interface JOBType extends EObject {
	/**
	 * Returns the value of the '<em><b>CHANNELREF</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.CHANNELREFType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>CHANNELREF</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>CHANNELREF</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_CHANNELREF()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='CHANNEL_REF' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<CHANNELREFType> getCHANNELREF();

	/**
	 * Returns the value of the '<em><b>Device Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is the symbolic name to identify theDevice reference.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Device Ref</em>' attribute.
	 * @see #setDeviceRef(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_DeviceRef()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='Device_Ref' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getDeviceRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.JOBType#getDeviceRef <em>Device Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Device Ref</em>' attribute.
	 * @see #getDeviceRef()
	 * @generated
	 */
	void setDeviceRef(Object value);

	/**
	 * Returns the value of the '<em><b>Job End Notification</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is a reference to a notification function.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Job End Notification</em>' attribute.
	 * @see #setJobEndNotification(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_JobEndNotification()
	 * @model dataType="SystemSparcClockMcu.JobEndNotificationType" required="true"
	 *        extendedMetaData="kind='attribute' name='JobEndNotification' namespace='##targetNamespace'"
	 * @generated
	 */
	String getJobEndNotification();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.JOBType#getJobEndNotification <em>Job End Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Job End Notification</em>' attribute.
	 * @see #getJobEndNotification()
	 * @generated
	 */
	void setJobEndNotification(String value);

	/**
	 * Returns the value of the '<em><b>Job Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Priority of the Job.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Job Priority</em>' attribute.
	 * @see #setJobPriority(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_JobPriority()
	 * @model dataType="SystemSparcClockMcu.JobPriorityType" required="true"
	 *        extendedMetaData="kind='attribute' name='JobPriority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getJobPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.JOBType#getJobPriority <em>Job Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Job Priority</em>' attribute.
	 * @see #getJobPriority()
	 * @generated
	 */
	void setJobPriority(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Job identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType22" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.JOBType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Physical Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is the symbolic name to identify the HW SPI channel of the microcontroller allocated to this Job.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Physical Unit</em>' attribute.
	 * @see #setPhysicalUnit(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getJOBType_PhysicalUnit()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='Physical_Unit' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getPhysicalUnit();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.JOBType#getPhysicalUnit <em>Physical Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Physical Unit</em>' attribute.
	 * @see #getPhysicalUnit()
	 * @generated
	 */
	void setPhysicalUnit(Object value);

} // JOBType
