/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>LIGHTSCHEDULER Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getTASK <em>TASK</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamResetAfterWakeup <em>Ram Reset After Wakeup</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamWakeup <em>Ram Wakeup</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLIGHTSCHEDULERType()
 * @model extendedMetaData="name='LIGHT_SCHEDULER_._type' kind='elementOnly'"
 * @generated
 */
public interface LIGHTSCHEDULERType extends EObject {
	/**
	 * Returns the value of the '<em><b>TASK</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.TASKType2}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains the configuration for each task defined for low power activity.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>TASK</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLIGHTSCHEDULERType_TASK()
	 * @model containment="true" upper="8"
	 *        extendedMetaData="kind='element' name='TASK' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<TASKType2> getTASK();

	/**
	 * Returns the value of the '<em><b>Ram Reset After Wakeup</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * If STANDBY support is enabled AND RAM wakeup is enabled, the user can select to avoid a reset upon a wakeup from low power.
	 * When this option is enabled, if a wakeup is detected during low power, a jump to the start address of the application is peformed instead
	 * of a reset.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Ram Reset After Wakeup</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRamResetAfterWakeup()
	 * @see #unsetRamResetAfterWakeup()
	 * @see #setRamResetAfterWakeup(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLIGHTSCHEDULERType_RamResetAfterWakeup()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RamResetAfterWakeup' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getRamResetAfterWakeup();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamResetAfterWakeup <em>Ram Reset After Wakeup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ram Reset After Wakeup</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRamResetAfterWakeup()
	 * @see #unsetRamResetAfterWakeup()
	 * @see #getRamResetAfterWakeup()
	 * @generated
	 */
	void setRamResetAfterWakeup(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamResetAfterWakeup <em>Ram Reset After Wakeup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRamResetAfterWakeup()
	 * @see #getRamResetAfterWakeup()
	 * @see #setRamResetAfterWakeup(TypeBoolean)
	 * @generated
	 */
	void unsetRamResetAfterWakeup();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamResetAfterWakeup <em>Ram Reset After Wakeup</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Ram Reset After Wakeup</em>' attribute is set.
	 * @see #unsetRamResetAfterWakeup()
	 * @see #getRamResetAfterWakeup()
	 * @see #setRamResetAfterWakeup(TypeBoolean)
	 * @generated
	 */
	boolean isSetRamResetAfterWakeup();

	/**
	 * Returns the value of the '<em><b>Ram Wakeup</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines if the code will execute from RAM after a wakeup from low power. The recovery from low
	 * power is faster, without the need to wait for the flash to stabilize. This option is supported only by the LIGHT scheduler when 
	 * the STANDBY0 low power mode is used.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Ram Wakeup</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRamWakeup()
	 * @see #unsetRamWakeup()
	 * @see #setRamWakeup(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLIGHTSCHEDULERType_RamWakeup()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RamWakeup' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getRamWakeup();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamWakeup <em>Ram Wakeup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ram Wakeup</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRamWakeup()
	 * @see #unsetRamWakeup()
	 * @see #getRamWakeup()
	 * @generated
	 */
	void setRamWakeup(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamWakeup <em>Ram Wakeup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRamWakeup()
	 * @see #getRamWakeup()
	 * @see #setRamWakeup(TypeBoolean)
	 * @generated
	 */
	void unsetRamWakeup();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.LIGHTSCHEDULERType#getRamWakeup <em>Ram Wakeup</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Ram Wakeup</em>' attribute is set.
	 * @see #unsetRamWakeup()
	 * @see #getRamWakeup()
	 * @see #setRamWakeup(TypeBoolean)
	 * @generated
	 */
	boolean isSetRamWakeup();

} // LIGHTSCHEDULERType
