/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>LP Clock Frequency Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPClockFrequencyType()
 * @model extendedMetaData="name='LP_Clock_Frequency_._type'"
 * @generated
 */
public enum LPClockFrequencyType implements Enumerator {
	/**
	 * The '<em><b>8M Hz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_8M_HZ_VALUE
	 * @generated
	 * @ordered
	 */
	_8M_HZ(0, "_8MHz", "8_MHz"),

	/**
	 * The '<em><b>16M Hz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_16M_HZ_VALUE
	 * @generated
	 * @ordered
	 */
	_16M_HZ(1, "_16MHz", "16_MHz");

	/**
	 * The '<em><b>8M Hz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>8M Hz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #_8M_HZ
	 * @model name="_8MHz" literal="8_MHz"
	 * @generated
	 * @ordered
	 */
	public static final int _8M_HZ_VALUE = 0;

	/**
	 * The '<em><b>16M Hz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>16M Hz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #_16M_HZ
	 * @model name="_16MHz" literal="16_MHz"
	 * @generated
	 * @ordered
	 */
	public static final int _16M_HZ_VALUE = 1;

	/**
	 * An array of all the '<em><b>LP Clock Frequency Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final LPClockFrequencyType[] VALUES_ARRAY =
		new LPClockFrequencyType[] {
			_8M_HZ,
			_16M_HZ,
		};

	/**
	 * A public read-only list of all the '<em><b>LP Clock Frequency Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<LPClockFrequencyType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>LP Clock Frequency Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LPClockFrequencyType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LPClockFrequencyType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>LP Clock Frequency Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LPClockFrequencyType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LPClockFrequencyType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>LP Clock Frequency Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LPClockFrequencyType get(int value) {
		switch (value) {
			case _8M_HZ_VALUE: return _8M_HZ;
			case _16M_HZ_VALUE: return _16M_HZ;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private LPClockFrequencyType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //LPClockFrequencyType
