/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>LPM Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.LPMType#getCLOCKSETTINGS <em>CLOCKSETTINGS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getTIMERCONFIGURATION <em>TIMERCONFIGURATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getUSERS <em>USERS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getLIGHTSCHEDULER <em>LIGHTSCHEDULER</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getSTANDARDSCHEDULER <em>STANDARDSCHEDULER</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getTIMEOFDAY <em>TIMEOFDAY</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getPCRRestoration <em>PCR Restoration</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getRestartOSAlarms <em>Restart OS Alarms</em>}</li>
 *   <li>{@link SystemSparcClockMcu.LPMType#getStandbySupport <em>Standby Support</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType()
 * @model extendedMetaData="name='LPM_._type' kind='elementOnly'"
 * @generated
 */
public interface LPMType extends EObject {
	/**
	 * Returns the value of the '<em><b>CLOCKSETTINGS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is the configuration for the running clock and the standby mode in LP.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CLOCKSETTINGS</em>' containment reference.
	 * @see #setCLOCKSETTINGS(CLOCKSETTINGSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_CLOCKSETTINGS()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='CLOCK_SETTINGS' namespace='##targetNamespace'"
	 * @generated
	 */
	CLOCKSETTINGSType getCLOCKSETTINGS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getCLOCKSETTINGS <em>CLOCKSETTINGS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CLOCKSETTINGS</em>' containment reference.
	 * @see #getCLOCKSETTINGS()
	 * @generated
	 */
	void setCLOCKSETTINGS(CLOCKSETTINGSType value);

	/**
	 * Returns the value of the '<em><b>TIMERCONFIGURATION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container holds the configuration options for the API functionality in low power. It 
	 * is mandatory that this container is defined if the LIGHT scheduler is used with the periodic task OR if the STANDARD scheduler is used.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>TIMERCONFIGURATION</em>' containment reference.
	 * @see #setTIMERCONFIGURATION(TIMERCONFIGURATIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_TIMERCONFIGURATION()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='TIMER_CONFIGURATION' namespace='##targetNamespace'"
	 * @generated
	 */
	TIMERCONFIGURATIONType getTIMERCONFIGURATION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getTIMERCONFIGURATION <em>TIMERCONFIGURATION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>TIMERCONFIGURATION</em>' containment reference.
	 * @see #getTIMERCONFIGURATION()
	 * @generated
	 */
	void setTIMERCONFIGURATION(TIMERCONFIGURATIONType value);

	/**
	 * Returns the value of the '<em><b>USERS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Up to 8 LPM users can be defined using this container.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>USERS</em>' containment reference.
	 * @see #setUSERS(USERSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_USERS()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='USERS' namespace='##targetNamespace'"
	 * @generated
	 */
	USERSType getUSERS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getUSERS <em>USERS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>USERS</em>' containment reference.
	 * @see #getUSERS()
	 * @generated
	 */
	void setUSERS(USERSType value);

	/**
	 * Returns the value of the '<em><b>LIGHTSCHEDULER</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container is used to select the light scheduler option.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>LIGHTSCHEDULER</em>' containment reference.
	 * @see #setLIGHTSCHEDULER(LIGHTSCHEDULERType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_LIGHTSCHEDULER()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='LIGHT_SCHEDULER' namespace='##targetNamespace'"
	 * @generated
	 */
	LIGHTSCHEDULERType getLIGHTSCHEDULER();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getLIGHTSCHEDULER <em>LIGHTSCHEDULER</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>LIGHTSCHEDULER</em>' containment reference.
	 * @see #getLIGHTSCHEDULER()
	 * @generated
	 */
	void setLIGHTSCHEDULER(LIGHTSCHEDULERType value);

	/**
	 * Returns the value of the '<em><b>STANDARDSCHEDULER</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container is used to select the standard scheduler option.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>STANDARDSCHEDULER</em>' containment reference.
	 * @see #setSTANDARDSCHEDULER(STANDARDSCHEDULERType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_STANDARDSCHEDULER()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='STANDARD_SCHEDULER' namespace='##targetNamespace'"
	 * @generated
	 */
	STANDARDSCHEDULERType getSTANDARDSCHEDULER();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getSTANDARDSCHEDULER <em>STANDARDSCHEDULER</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>STANDARDSCHEDULER</em>' containment reference.
	 * @see #getSTANDARDSCHEDULER()
	 * @generated
	 */
	void setSTANDARDSCHEDULER(STANDARDSCHEDULERType value);

	/**
	 * Returns the value of the '<em><b>TIMEOFDAY</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container holds the information necessary to configure the Lpm ToD module. The presence of this container in the configuration
	 * decides whether the Lpm ToD module is available or not.
	 * 
	 * None:
	 * If LpmStandbySupport is TRUE, this feature cannot be configured.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>TIMEOFDAY</em>' containment reference.
	 * @see #setTIMEOFDAY(TIMEOFDAYType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_TIMEOFDAY()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='TIME_OF_DAY' namespace='##targetNamespace'"
	 * @generated
	 */
	TIMEOFDAYType getTIMEOFDAY();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getTIMEOFDAY <em>TIMEOFDAY</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>TIMEOFDAY</em>' containment reference.
	 * @see #getTIMEOFDAY()
	 * @generated
	 */
	void setTIMEOFDAY(TIMEOFDAYType value);

	/**
	 * Returns the value of the '<em><b>PCR Restoration</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines whether the PCR register content will be stored/restored before/after entering/recovering /from STANDBY mode during low power.
	 * NOTE: The value of this parameter has no influence if the STANDBY mode is not used in the project.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>PCR Restoration</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetPCRRestoration()
	 * @see #unsetPCRRestoration()
	 * @see #setPCRRestoration(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_PCRRestoration()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='PCRRestoration' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getPCRRestoration();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getPCRRestoration <em>PCR Restoration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PCR Restoration</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetPCRRestoration()
	 * @see #unsetPCRRestoration()
	 * @see #getPCRRestoration()
	 * @generated
	 */
	void setPCRRestoration(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.LPMType#getPCRRestoration <em>PCR Restoration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetPCRRestoration()
	 * @see #getPCRRestoration()
	 * @see #setPCRRestoration(TypeBoolean)
	 * @generated
	 */
	void unsetPCRRestoration();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.LPMType#getPCRRestoration <em>PCR Restoration</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>PCR Restoration</em>' attribute is set.
	 * @see #unsetPCRRestoration()
	 * @see #getPCRRestoration()
	 * @see #setPCRRestoration(TypeBoolean)
	 * @generated
	 */
	boolean isSetPCRRestoration();

	/**
	 * Returns the value of the '<em><b>Restart OS Alarms</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines whether the OS alarms should be initialized upon low power exit or not. It is recommended to leave this
	 * parameter checked. The LPM will use the SchM services to re-initialize the OS alarms.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Restart OS Alarms</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRestartOSAlarms()
	 * @see #unsetRestartOSAlarms()
	 * @see #setRestartOSAlarms(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_RestartOSAlarms()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RestartOSAlarms' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getRestartOSAlarms();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getRestartOSAlarms <em>Restart OS Alarms</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Restart OS Alarms</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRestartOSAlarms()
	 * @see #unsetRestartOSAlarms()
	 * @see #getRestartOSAlarms()
	 * @generated
	 */
	void setRestartOSAlarms(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.LPMType#getRestartOSAlarms <em>Restart OS Alarms</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRestartOSAlarms()
	 * @see #getRestartOSAlarms()
	 * @see #setRestartOSAlarms(TypeBoolean)
	 * @generated
	 */
	void unsetRestartOSAlarms();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.LPMType#getRestartOSAlarms <em>Restart OS Alarms</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Restart OS Alarms</em>' attribute is set.
	 * @see #unsetRestartOSAlarms()
	 * @see #getRestartOSAlarms()
	 * @see #setRestartOSAlarms(TypeBoolean)
	 * @generated
	 */
	boolean isSetRestartOSAlarms();

	/**
	 * Returns the value of the '<em><b>Standby Support</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines whether the LPM shall support the STANDBY mode of the MPC560x. If STANDBY mode is not needed,
	 * it is mandatory that this parameter is left unchecked.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Standby Support</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetStandbySupport()
	 * @see #unsetStandbySupport()
	 * @see #setStandbySupport(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getLPMType_StandbySupport()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='StandbySupport' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getStandbySupport();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.LPMType#getStandbySupport <em>Standby Support</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Standby Support</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetStandbySupport()
	 * @see #unsetStandbySupport()
	 * @see #getStandbySupport()
	 * @generated
	 */
	void setStandbySupport(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.LPMType#getStandbySupport <em>Standby Support</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStandbySupport()
	 * @see #getStandbySupport()
	 * @see #setStandbySupport(TypeBoolean)
	 * @generated
	 */
	void unsetStandbySupport();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.LPMType#getStandbySupport <em>Standby Support</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Standby Support</em>' attribute is set.
	 * @see #unsetStandbySupport()
	 * @see #getStandbySupport()
	 * @see #setStandbySupport(TypeBoolean)
	 * @generated
	 */
	boolean isSetStandbySupport();

} // LPMType
