/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MCU Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.MCUType#getPERIPHERALS <em>PERIPHERALS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.MCUType#getEnableResetOutput <em>Enable Reset Output</em>}</li>
 *   <li>{@link SystemSparcClockMcu.MCUType#getResetCallout <em>Reset Callout</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMCUType()
 * @model extendedMetaData="name='MCU_._type' kind='elementOnly'"
 * @generated
 */
public interface MCUType extends EObject {
	/**
	 * Returns the value of the '<em><b>PERIPHERALS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This container contains the Low Power Mode cofiguration for MCU peripherals.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>PERIPHERALS</em>' containment reference.
	 * @see #setPERIPHERALS(PERIPHERALSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMCUType_PERIPHERALS()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='PERIPHERALS' namespace='##targetNamespace'"
	 * @generated
	 */
	PERIPHERALSType getPERIPHERALS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.MCUType#getPERIPHERALS <em>PERIPHERALS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PERIPHERALS</em>' containment reference.
	 * @see #getPERIPHERALS()
	 * @generated
	 */
	void setPERIPHERALS(PERIPHERALSType value);

	/**
	 * Returns the value of the '<em><b>Enable Reset Output</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Global switch to enable the reset sources to generate a reset signal aslo on the RESET pin of the microcontroller.
	 * 
	 * If configured to YES, a reset signal will be visible on the RESET pin of the microcontroller.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Enable Reset Output</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetEnableResetOutput()
	 * @see #unsetEnableResetOutput()
	 * @see #setEnableResetOutput(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMCUType_EnableResetOutput()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='EnableResetOutput' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getEnableResetOutput();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.MCUType#getEnableResetOutput <em>Enable Reset Output</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Enable Reset Output</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetEnableResetOutput()
	 * @see #unsetEnableResetOutput()
	 * @see #getEnableResetOutput()
	 * @generated
	 */
	void setEnableResetOutput(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.MCUType#getEnableResetOutput <em>Enable Reset Output</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetEnableResetOutput()
	 * @see #getEnableResetOutput()
	 * @see #setEnableResetOutput(TypeBoolean)
	 * @generated
	 */
	void unsetEnableResetOutput();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.MCUType#getEnableResetOutput <em>Enable Reset Output</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Enable Reset Output</em>' attribute is set.
	 * @see #unsetEnableResetOutput()
	 * @see #getEnableResetOutput()
	 * @see #setEnableResetOutput(TypeBoolean)
	 * @generated
	 */
	boolean isSetEnableResetOutput();

	/**
	 * Returns the value of the '<em><b>Reset Callout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Function name of callout that will be called before Mcu_PerfrormReset is executed.
	 * 
	 * The attribute is optional. If left empy, no callout is executed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Reset Callout</em>' attribute.
	 * @see #setResetCallout(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMCUType_ResetCallout()
	 * @model dataType="SystemSparcClockMcu.FunctionNameType"
	 *        extendedMetaData="kind='attribute' name='ResetCallout' namespace='##targetNamespace'"
	 * @generated
	 */
	String getResetCallout();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.MCUType#getResetCallout <em>Reset Callout</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reset Callout</em>' attribute.
	 * @see #getResetCallout()
	 * @generated
	 */
	void setResetCallout(String value);

} // MCUType
