/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MODULE Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.MODULEType#getModuleCallbackFunction <em>Module Callback Function</em>}</li>
 *   <li>{@link SystemSparcClockMcu.MODULEType#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMODULEType()
 * @model extendedMetaData="name='MODULE_._type' kind='empty'"
 * @generated
 */
public interface MODULEType extends EObject {
	/**
	 * Returns the value of the '<em><b>Module Callback Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specify a callback function that is executed when the current BSW module reports an error.
	 * The callback function should return an uint8 and should have no parameters.
	 * The return value controls the error reporting routine behavior in the following way:
	 * If the callback returns 'SYSERRMAN_EXEC_DEFAULT_ACTION', means the default action will be executed (the action that was requested by the BSW module that reported the error: assert a reset or do nothing (in this second case the error reporting routine just returns))
	 * If the callback returns 'SYSERRMAN_CANCEL_DEFAULT_ACTION', means the default action will be ignored, so if a BSW module requests a reset that reset will not be executed. 
	 * 
	 * If there was no callback defined for the current BSW module that reported the error, than execute the default action (the action that was requested by the BSW module that reported the error) .
	 * 
	 * NOTE1: Reset execution depends on the MCU PERFORM RESET API.
	 * This API should be enabled in the Mcu.ecuconfigfile, otherwise any reset request will be ignored !
	 * 
	 * NOTE2: The 'NULL_PTR' value (without quotes) means that no callback function is defined for the current BSW module (this is also the default value) . 
	 * Any other value is considered as a valid callback function name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Module Callback Function</em>' attribute.
	 * @see #setModuleCallbackFunction(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMODULEType_ModuleCallbackFunction()
	 * @model dataType="SystemSparcClockMcu.ModuleCallbackFunctionType"
	 *        extendedMetaData="kind='attribute' name='ModuleCallbackFunction' namespace='##targetNamespace'"
	 * @generated
	 */
	String getModuleCallbackFunction();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.MODULEType#getModuleCallbackFunction <em>Module Callback Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Module Callback Function</em>' attribute.
	 * @see #getModuleCallbackFunction()
	 * @generated
	 */
	void setModuleCallbackFunction(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Module identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMODULEType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType29" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.MODULEType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

} // MODULEType
