/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Mcu Clk Source Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMcuClkSourceType()
 * @model extendedMetaData="name='McuClkSource_Type'"
 * @generated
 */
public enum McuClkSourceType implements Enumerator {
	/**
	 * The '<em><b>Crystal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CRYSTAL_VALUE
	 * @generated
	 * @ordered
	 */
	CRYSTAL(0, "Crystal", "Crystal"),

	/**
	 * The '<em><b>F16M Hz RC Internal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #F16M_HZ_RC_INTERNAL_VALUE
	 * @generated
	 * @ordered
	 */
	F16M_HZ_RC_INTERNAL(1, "F16MHzRCInternal", "F16_MHz_RC_Internal"),

	/**
	 * The '<em><b>PLL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PLL_VALUE
	 * @generated
	 * @ordered
	 */
	PLL(2, "PLL", "PLL"),

	/**
	 * The '<em><b>System Clock</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SYSTEM_CLOCK_VALUE
	 * @generated
	 * @ordered
	 */
	SYSTEM_CLOCK(3, "SystemClock", "System_Clock"),

	/**
	 * The '<em><b>RTC Clock</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #RTC_CLOCK_VALUE
	 * @generated
	 * @ordered
	 */
	RTC_CLOCK(4, "RTCClock", "RTC_Clock");

	/**
	 * The '<em><b>Crystal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Crystal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CRYSTAL
	 * @model name="Crystal"
	 * @generated
	 * @ordered
	 */
	public static final int CRYSTAL_VALUE = 0;

	/**
	 * The '<em><b>F16M Hz RC Internal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>F16M Hz RC Internal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #F16M_HZ_RC_INTERNAL
	 * @model name="F16MHzRCInternal" literal="F16_MHz_RC_Internal"
	 * @generated
	 * @ordered
	 */
	public static final int F16M_HZ_RC_INTERNAL_VALUE = 1;

	/**
	 * The '<em><b>PLL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PLL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PLL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int PLL_VALUE = 2;

	/**
	 * The '<em><b>System Clock</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>System Clock</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SYSTEM_CLOCK
	 * @model name="SystemClock" literal="System_Clock"
	 * @generated
	 * @ordered
	 */
	public static final int SYSTEM_CLOCK_VALUE = 3;

	/**
	 * The '<em><b>RTC Clock</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>RTC Clock</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #RTC_CLOCK
	 * @model name="RTCClock" literal="RTC_Clock"
	 * @generated
	 * @ordered
	 */
	public static final int RTC_CLOCK_VALUE = 4;

	/**
	 * An array of all the '<em><b>Mcu Clk Source Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final McuClkSourceType[] VALUES_ARRAY =
		new McuClkSourceType[] {
			CRYSTAL,
			F16M_HZ_RC_INTERNAL,
			PLL,
			SYSTEM_CLOCK,
			RTC_CLOCK,
		};

	/**
	 * A public read-only list of all the '<em><b>Mcu Clk Source Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<McuClkSourceType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Mcu Clk Source Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuClkSourceType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuClkSourceType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu Clk Source Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuClkSourceType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuClkSourceType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu Clk Source Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuClkSourceType get(int value) {
		switch (value) {
			case CRYSTAL_VALUE: return CRYSTAL;
			case F16M_HZ_RC_INTERNAL_VALUE: return F16M_HZ_RC_INTERNAL;
			case PLL_VALUE: return PLL;
			case SYSTEM_CLOCK_VALUE: return SYSTEM_CLOCK;
			case RTC_CLOCK_VALUE: return RTC_CLOCK;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private McuClkSourceType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //McuClkSourceType
