/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Mcu Per Run Config Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMcuPerRunConfigType()
 * @model extendedMetaData="name='McuPerRunConfig_Type'"
 * @generated
 */
public enum McuPerRunConfigType implements Enumerator {
	/**
	 * The '<em><b>Mcu Run Config0</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG0_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_RUN_CONFIG0(0, "McuRunConfig0", "McuRunConfig0"),

	/**
	 * The '<em><b>Mcu Run Config1</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG1_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_RUN_CONFIG1(1, "McuRunConfig1", "McuRunConfig1"),

	/**
	 * The '<em><b>Mcu Run Config6</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG6_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_RUN_CONFIG6(2, "McuRunConfig6", "McuRunConfig6"),

	/**
	 * The '<em><b>Mcu Run Config7</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG7_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_RUN_CONFIG7(3, "McuRunConfig7", "McuRunConfig7");

	/**
	 * The '<em><b>Mcu Run Config0</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Run Config0</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG0
	 * @model name="McuRunConfig0"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_RUN_CONFIG0_VALUE = 0;

	/**
	 * The '<em><b>Mcu Run Config1</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Run Config1</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG1
	 * @model name="McuRunConfig1"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_RUN_CONFIG1_VALUE = 1;

	/**
	 * The '<em><b>Mcu Run Config6</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Run Config6</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG6
	 * @model name="McuRunConfig6"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_RUN_CONFIG6_VALUE = 2;

	/**
	 * The '<em><b>Mcu Run Config7</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Run Config7</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_RUN_CONFIG7
	 * @model name="McuRunConfig7"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_RUN_CONFIG7_VALUE = 3;

	/**
	 * An array of all the '<em><b>Mcu Per Run Config Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final McuPerRunConfigType[] VALUES_ARRAY =
		new McuPerRunConfigType[] {
			MCU_RUN_CONFIG0,
			MCU_RUN_CONFIG1,
			MCU_RUN_CONFIG6,
			MCU_RUN_CONFIG7,
		};

	/**
	 * A public read-only list of all the '<em><b>Mcu Per Run Config Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<McuPerRunConfigType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Mcu Per Run Config Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuPerRunConfigType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuPerRunConfigType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu Per Run Config Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuPerRunConfigType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuPerRunConfigType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu Per Run Config Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuPerRunConfigType get(int value) {
		switch (value) {
			case MCU_RUN_CONFIG0_VALUE: return MCU_RUN_CONFIG0;
			case MCU_RUN_CONFIG1_VALUE: return MCU_RUN_CONFIG1;
			case MCU_RUN_CONFIG6_VALUE: return MCU_RUN_CONFIG6;
			case MCU_RUN_CONFIG7_VALUE: return MCU_RUN_CONFIG7;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private McuPerRunConfigType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //McuPerRunConfigType
