/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Mcu RCOSC Selection Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getMcuRCOSCSelectionType()
 * @model extendedMetaData="name='McuRCOSCSelection_Type'"
 * @generated
 */
public enum McuRCOSCSelectionType implements Enumerator {
	/**
	 * The '<em><b>CKIR Cfast</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CKIR_CFAST_VALUE
	 * @generated
	 * @ordered
	 */
	CKIR_CFAST(0, "CKIRCfast", "CK_IRCfast"),

	/**
	 * The '<em><b>CKIR Cslow</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CKIR_CSLOW_VALUE
	 * @generated
	 * @ordered
	 */
	CKIR_CSLOW(1, "CKIRCslow", "CK_IRCslow"),

	/**
	 * The '<em><b>CK32 Kcrystal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CK32_KCRYSTAL_VALUE
	 * @generated
	 * @ordered
	 */
	CK32_KCRYSTAL(2, "CK32Kcrystal", "CK_32Kcrystal");

	/**
	 * The '<em><b>CKIR Cfast</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CKIR Cfast</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CKIR_CFAST
	 * @model name="CKIRCfast" literal="CK_IRCfast"
	 * @generated
	 * @ordered
	 */
	public static final int CKIR_CFAST_VALUE = 0;

	/**
	 * The '<em><b>CKIR Cslow</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CKIR Cslow</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CKIR_CSLOW
	 * @model name="CKIRCslow" literal="CK_IRCslow"
	 * @generated
	 * @ordered
	 */
	public static final int CKIR_CSLOW_VALUE = 1;

	/**
	 * The '<em><b>CK32 Kcrystal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CK32 Kcrystal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CK32_KCRYSTAL
	 * @model name="CK32Kcrystal" literal="CK_32Kcrystal"
	 * @generated
	 * @ordered
	 */
	public static final int CK32_KCRYSTAL_VALUE = 2;

	/**
	 * An array of all the '<em><b>Mcu RCOSC Selection Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final McuRCOSCSelectionType[] VALUES_ARRAY =
		new McuRCOSCSelectionType[] {
			CKIR_CFAST,
			CKIR_CSLOW,
			CK32_KCRYSTAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Mcu RCOSC Selection Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<McuRCOSCSelectionType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Mcu RCOSC Selection Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuRCOSCSelectionType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuRCOSCSelectionType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu RCOSC Selection Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuRCOSCSelectionType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			McuRCOSCSelectionType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Mcu RCOSC Selection Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static McuRCOSCSelectionType get(int value) {
		switch (value) {
			case CKIR_CFAST_VALUE: return CKIR_CFAST;
			case CKIR_CSLOW_VALUE: return CKIR_CSLOW;
			case CK32_KCRYSTAL_VALUE: return CK32_KCRYSTAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private McuRCOSCSelectionType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //McuRCOSCSelectionType
