/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Mode Conf Attr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.ModeConfAttr#getExpectedAliveIndications <em>Expected Alive Indications</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ModeConfAttr#getFailedSupervisionRefCycleTol <em>Failed Supervision Ref Cycle Tol</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ModeConfAttr#getMaxMargin <em>Max Margin</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ModeConfAttr#getMinMargin <em>Min Margin</em>}</li>
 *   <li>{@link SystemSparcClockMcu.ModeConfAttr#getSupervisionReferenceCycle <em>Supervision Reference Cycle</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr()
 * @model extendedMetaData="name='ModeConf_Attr' kind='empty'"
 * @generated
 */
public interface ModeConfAttr extends EObject {
	/**
	 * Returns the value of the '<em><b>Expected Alive Indications</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter contains the amount of expected alive indications within the referenced amount of defined supervision cycles according to corresponding SE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Expected Alive Indications</em>' attribute.
	 * @see #setExpectedAliveIndications(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr_ExpectedAliveIndications()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='ExpectedAliveIndications' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getExpectedAliveIndications();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ModeConfAttr#getExpectedAliveIndications <em>Expected Alive Indications</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Expected Alive Indications</em>' attribute.
	 * @see #getExpectedAliveIndications()
	 * @generated
	 */
	void setExpectedAliveIndications(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Failed Supervision Ref Cycle Tol</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter contains the acceptable amount of failed supervision reference cycles that shall be used by checkup of alive supervision according to corresponding SE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Failed Supervision Ref Cycle Tol</em>' attribute.
	 * @see #setFailedSupervisionRefCycleTol(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr_FailedSupervisionRefCycleTol()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='FailedSupervisionRefCycleTol' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getFailedSupervisionRefCycleTol();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ModeConfAttr#getFailedSupervisionRefCycleTol <em>Failed Supervision Ref Cycle Tol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Failed Supervision Ref Cycle Tol</em>' attribute.
	 * @see #getFailedSupervisionRefCycleTol()
	 * @generated
	 */
	void setFailedSupervisionRefCycleTol(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Max Margin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter contains the amount of alive indications that are acceptable to be additional on the expected alive indications within the corresponding supervision reference cycle.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Max Margin</em>' attribute.
	 * @see #setMaxMargin(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr_MaxMargin()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='MaxMargin' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getMaxMargin();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ModeConfAttr#getMaxMargin <em>Max Margin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Margin</em>' attribute.
	 * @see #getMaxMargin()
	 * @generated
	 */
	void setMaxMargin(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Min Margin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter contains the amount of alive indications that are acceptable to be missed from the expected alive indications within the corresponding supervision reference cycle.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Min Margin</em>' attribute.
	 * @see #setMinMargin(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr_MinMargin()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='MinMargin' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getMinMargin();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ModeConfAttr#getMinMargin <em>Min Margin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Margin</em>' attribute.
	 * @see #getMinMargin()
	 * @generated
	 */
	void setMinMargin(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Supervision Reference Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter contains the amount of supervision cycles to be used as reference by the alive-supervision mechanism to perform the checkup with counted alive indications according to corresponding SE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Supervision Reference Cycle</em>' attribute.
	 * @see #setSupervisionReferenceCycle(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getModeConfAttr_SupervisionReferenceCycle()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='SupervisionReferenceCycle' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSupervisionReferenceCycle();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.ModeConfAttr#getSupervisionReferenceCycle <em>Supervision Reference Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supervision Reference Cycle</em>' attribute.
	 * @see #getSupervisionReferenceCycle()
	 * @generated
	 */
	void setSupervisionReferenceCycle(BigInteger value);

} // ModeConfAttr
