/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>OSISR Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.OSISRType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSISRType#getOsIrqNumber <em>Os Irq Number</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSISRType#getOsIsrCategory <em>Os Isr Category</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSISRType#getOsPriority <em>Os Priority</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSISRType()
 * @model extendedMetaData="name='OS_ISR_._type' kind='empty'"
 * @generated
 */
public interface OSISRType extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * OsISR identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSISRType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType11" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSISRType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Os Irq Number</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.OsIsrListType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Interrupt source number (/ISR/IrqChannel/EXTERNAL/IrqNumber)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Irq Number</em>' attribute.
	 * @see SystemSparcClockMcu.OsIsrListType
	 * @see #isSetOsIrqNumber()
	 * @see #unsetOsIrqNumber()
	 * @see #setOsIrqNumber(OsIsrListType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSISRType_OsIrqNumber()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsIrqNumber' namespace='##targetNamespace'"
	 * @generated
	 */
	OsIsrListType getOsIrqNumber();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIrqNumber <em>Os Irq Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Irq Number</em>' attribute.
	 * @see SystemSparcClockMcu.OsIsrListType
	 * @see #isSetOsIrqNumber()
	 * @see #unsetOsIrqNumber()
	 * @see #getOsIrqNumber()
	 * @generated
	 */
	void setOsIrqNumber(OsIsrListType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIrqNumber <em>Os Irq Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsIrqNumber()
	 * @see #getOsIrqNumber()
	 * @see #setOsIrqNumber(OsIsrListType)
	 * @generated
	 */
	void unsetOsIrqNumber();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIrqNumber <em>Os Irq Number</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Irq Number</em>' attribute is set.
	 * @see #unsetOsIrqNumber()
	 * @see #getOsIrqNumber()
	 * @see #setOsIrqNumber(OsIsrListType)
	 * @generated
	 */
	boolean isSetOsIrqNumber();

	/**
	 * Returns the value of the '<em><b>Os Isr Category</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.OsIsrCategoryType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This attribute specifies the category of this ISR. Only values of 1 and 2 are allowed.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Isr Category</em>' attribute.
	 * @see SystemSparcClockMcu.OsIsrCategoryType
	 * @see #isSetOsIsrCategory()
	 * @see #unsetOsIsrCategory()
	 * @see #setOsIsrCategory(OsIsrCategoryType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSISRType_OsIsrCategory()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='OsIsrCategory' namespace='##targetNamespace'"
	 * @generated
	 */
	OsIsrCategoryType getOsIsrCategory();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIsrCategory <em>Os Isr Category</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Isr Category</em>' attribute.
	 * @see SystemSparcClockMcu.OsIsrCategoryType
	 * @see #isSetOsIsrCategory()
	 * @see #unsetOsIsrCategory()
	 * @see #getOsIsrCategory()
	 * @generated
	 */
	void setOsIsrCategory(OsIsrCategoryType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIsrCategory <em>Os Isr Category</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsIsrCategory()
	 * @see #getOsIsrCategory()
	 * @see #setOsIsrCategory(OsIsrCategoryType)
	 * @generated
	 */
	void unsetOsIsrCategory();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSISRType#getOsIsrCategory <em>Os Isr Category</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Isr Category</em>' attribute is set.
	 * @see #unsetOsIsrCategory()
	 * @see #getOsIsrCategory()
	 * @see #setOsIsrCategory(OsIsrCategoryType)
	 * @generated
	 */
	boolean isSetOsIsrCategory();

	/**
	 * Returns the value of the '<em><b>Os Priority</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.OsPriorityType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Defines the priority of the ISR (/ISR/PRIORITY)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Priority</em>' attribute.
	 * @see SystemSparcClockMcu.OsPriorityType
	 * @see #isSetOsPriority()
	 * @see #unsetOsPriority()
	 * @see #setOsPriority(OsPriorityType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSISRType_OsPriority()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='OsPriority' namespace='##targetNamespace'"
	 * @generated
	 */
	OsPriorityType getOsPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsPriority <em>Os Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Priority</em>' attribute.
	 * @see SystemSparcClockMcu.OsPriorityType
	 * @see #isSetOsPriority()
	 * @see #unsetOsPriority()
	 * @see #getOsPriority()
	 * @generated
	 */
	void setOsPriority(OsPriorityType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSISRType#getOsPriority <em>Os Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsPriority()
	 * @see #getOsPriority()
	 * @see #setOsPriority(OsPriorityType)
	 * @generated
	 */
	void unsetOsPriority();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSISRType#getOsPriority <em>Os Priority</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Priority</em>' attribute is set.
	 * @see #unsetOsPriority()
	 * @see #getOsPriority()
	 * @see #setOsPriority(OsPriorityType)
	 * @generated
	 */
	boolean isSetOsPriority();

} // OSISRType
