/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>OS Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.OSType#getOSALARMS <em>OSALARMS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOSAPPLICATION <em>OSAPPLICATION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOSISRS <em>OSISRS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOSRESOURCES <em>OSRESOURCES</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOSTASKS <em>OSTASKS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsDebugLevel <em>Os Debug Level</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsErrorHook <em>Os Error Hook</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsIsrHooks <em>Os Isr Hooks</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsIsrStackSize <em>Os Isr Stack Size</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsPeriod <em>Os Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsPostTaskHook <em>Os Post Task Hook</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsPreTaskHook <em>Os Pre Task Hook</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsProtectionHook <em>Os Protection Hook</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsScalabilityClass <em>Os Scalability Class</em>}</li>
 *   <li>{@link SystemSparcClockMcu.OSType#getOsStatus <em>Os Status</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType()
 * @model extendedMetaData="name='OS_._type' kind='elementOnly'"
 * @generated
 */
public interface OSType extends EObject {
	/**
	 * Returns the value of the '<em><b>OSALARMS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * An OsAlarm may be used to asynchronously inform or activate a specific task. It is possible to start alarms automatically at system start-up depending on the application mode.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>OSALARMS</em>' containment reference.
	 * @see #setOSALARMS(OSALARMSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OSALARMS()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='OS_ALARMS' namespace='##targetNamespace'"
	 * @generated
	 */
	OSALARMSType getOSALARMS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOSALARMS <em>OSALARMS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>OSALARMS</em>' containment reference.
	 * @see #getOSALARMS()
	 * @generated
	 */
	void setOSALARMS(OSALARMSType value);

	/**
	 * Returns the value of the '<em><b>OSAPPLICATION</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.OSAPPLICATIONType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * An AUTOSAR OS must be capable of supporting a collection of OS objects (tasks, interrupts, alarms, hooks etc.) that form a cohesive functional unit. This collection of objects is termed an OS-Application.
	 * 
	 * All objects which belong to the same OS-Application have access to each other. Access means to allow to use these objects within API services.
	 * 
	 * Access by other applications can be granted separately.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>OSAPPLICATION</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OSAPPLICATION()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='OS_APPLICATION' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<OSAPPLICATIONType> getOSAPPLICATION();

	/**
	 * Returns the value of the '<em><b>OSISRS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The OsISR container represents an OSEK interrupt service routine.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>OSISRS</em>' containment reference.
	 * @see #setOSISRS(OSISRSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OSISRS()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='OS_ISRS' namespace='##targetNamespace'"
	 * @generated
	 */
	OSISRSType getOSISRS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOSISRS <em>OSISRS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>OSISRS</em>' containment reference.
	 * @see #getOSISRS()
	 * @generated
	 */
	void setOSISRS(OSISRSType value);

	/**
	 * Returns the value of the '<em><b>OSRESOURCES</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * An OsResource object is used to co-ordinate the concurrent access by tasks and ISRs to a shared resource, e.g. the scheduler, any program sequence, memory or any hardware area.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>OSRESOURCES</em>' containment reference.
	 * @see #setOSRESOURCES(OSRESOURCESType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OSRESOURCES()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='OS_RESOURCES' namespace='##targetNamespace'"
	 * @generated
	 */
	OSRESOURCESType getOSRESOURCES();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOSRESOURCES <em>OSRESOURCES</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>OSRESOURCES</em>' containment reference.
	 * @see #getOSRESOURCES()
	 * @generated
	 */
	void setOSRESOURCES(OSRESOURCESType value);

	/**
	 * Returns the value of the '<em><b>OSTASKS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>OSTASKS</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>OSTASKS</em>' containment reference.
	 * @see #setOSTASKS(OSTASKSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OSTASKS()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='OS_TASKS' namespace='##targetNamespace'"
	 * @generated
	 */
	OSTASKSType getOSTASKS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOSTASKS <em>OSTASKS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>OSTASKS</em>' containment reference.
	 * @see #getOSTASKS()
	 * @generated
	 */
	void setOSTASKS(OSTASKSType value);

	/**
	 * Returns the value of the '<em><b>Os Debug Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies the ORTI support in OS (/OS/DEBUG_LEVEL)
	 * 
	 * 0 - NOORTI - no ORTI support
	 * 1 - STATIC - static ORTI support
	 * 2 - RUNTIME - runtime and static ORTI support
	 * 3 - ISR - runtime w/o service trace
	 * 4 - full ORTI support
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Debug Level</em>' attribute.
	 * @see #setOsDebugLevel(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsDebugLevel()
	 * @model dataType="SystemSparcClockMcu.OsDebugLevelType" required="true"
	 *        extendedMetaData="kind='attribute' name='OsDebugLevel' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsDebugLevel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsDebugLevel <em>Os Debug Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Debug Level</em>' attribute.
	 * @see #getOsDebugLevel()
	 * @generated
	 */
	void setOsDebugLevel(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Error Hook</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Error hook as defined by OSEK.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Error Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsErrorHook()
	 * @see #unsetOsErrorHook()
	 * @see #setOsErrorHook(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsErrorHook()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsErrorHook' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsErrorHook();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsErrorHook <em>Os Error Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Error Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsErrorHook()
	 * @see #unsetOsErrorHook()
	 * @see #getOsErrorHook()
	 * @generated
	 */
	void setOsErrorHook(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsErrorHook <em>Os Error Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsErrorHook()
	 * @see #getOsErrorHook()
	 * @see #setOsErrorHook(TypeBoolean)
	 * @generated
	 */
	void unsetOsErrorHook();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsErrorHook <em>Os Error Hook</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Error Hook</em>' attribute is set.
	 * @see #unsetOsErrorHook()
	 * @see #getOsErrorHook()
	 * @see #setOsErrorHook(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsErrorHook();

	/**
	 * Returns the value of the '<em><b>Os Isr Hooks</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Defines whether or not IsrHook is called before and after ISR (/OS/IsrHooks)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Isr Hooks</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsIsrHooks()
	 * @see #unsetOsIsrHooks()
	 * @see #setOsIsrHooks(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsIsrHooks()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsIsrHooks' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsIsrHooks();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsIsrHooks <em>Os Isr Hooks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Isr Hooks</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsIsrHooks()
	 * @see #unsetOsIsrHooks()
	 * @see #getOsIsrHooks()
	 * @generated
	 */
	void setOsIsrHooks(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsIsrHooks <em>Os Isr Hooks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsIsrHooks()
	 * @see #getOsIsrHooks()
	 * @see #setOsIsrHooks(TypeBoolean)
	 * @generated
	 */
	void unsetOsIsrHooks();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsIsrHooks <em>Os Isr Hooks</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Isr Hooks</em>' attribute is set.
	 * @see #unsetOsIsrHooks()
	 * @see #getOsIsrHooks()
	 * @see #setOsIsrHooks(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsIsrHooks();

	/**
	 * Returns the value of the '<em><b>Os Isr Stack Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies the ISR stack size in bytes (/OS/IsrStackSize)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Isr Stack Size</em>' attribute.
	 * @see #setOsIsrStackSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsIsrStackSize()
	 * @model dataType="SystemSparcClockMcu.OsIsrStackSizeType"
	 *        extendedMetaData="kind='attribute' name='OsIsrStackSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsIsrStackSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsIsrStackSize <em>Os Isr Stack Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Isr Stack Size</em>' attribute.
	 * @see #getOsIsrStackSize()
	 * @generated
	 */
	void setOsIsrStackSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies period of a tick of the counter (in nanoseconds) (/OS/TargetMCU/MPC5607B/SysTimer/SWCOUNTER/Period).
	 * The value is given in us.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Period</em>' attribute.
	 * @see #setOsPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsPeriod()
	 * @model dataType="SystemSparcClockMcu.OsPeriodType"
	 *        extendedMetaData="kind='attribute' name='OsPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsPeriod <em>Os Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Period</em>' attribute.
	 * @see #getOsPeriod()
	 * @generated
	 */
	void setOsPeriod(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Os Post Task Hook</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Post-task hook as defined by OSEK.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Post Task Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsPostTaskHook()
	 * @see #unsetOsPostTaskHook()
	 * @see #setOsPostTaskHook(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsPostTaskHook()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsPostTaskHook' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsPostTaskHook();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsPostTaskHook <em>Os Post Task Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Post Task Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsPostTaskHook()
	 * @see #unsetOsPostTaskHook()
	 * @see #getOsPostTaskHook()
	 * @generated
	 */
	void setOsPostTaskHook(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsPostTaskHook <em>Os Post Task Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsPostTaskHook()
	 * @see #getOsPostTaskHook()
	 * @see #setOsPostTaskHook(TypeBoolean)
	 * @generated
	 */
	void unsetOsPostTaskHook();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsPostTaskHook <em>Os Post Task Hook</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Post Task Hook</em>' attribute is set.
	 * @see #unsetOsPostTaskHook()
	 * @see #getOsPostTaskHook()
	 * @see #setOsPostTaskHook(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsPostTaskHook();

	/**
	 * Returns the value of the '<em><b>Os Pre Task Hook</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Pre-task hook as defined by OSEK.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Pre Task Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsPreTaskHook()
	 * @see #unsetOsPreTaskHook()
	 * @see #setOsPreTaskHook(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsPreTaskHook()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsPreTaskHook' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsPreTaskHook();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsPreTaskHook <em>Os Pre Task Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Pre Task Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsPreTaskHook()
	 * @see #unsetOsPreTaskHook()
	 * @see #getOsPreTaskHook()
	 * @generated
	 */
	void setOsPreTaskHook(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsPreTaskHook <em>Os Pre Task Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsPreTaskHook()
	 * @see #getOsPreTaskHook()
	 * @see #setOsPreTaskHook(TypeBoolean)
	 * @generated
	 */
	void unsetOsPreTaskHook();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsPreTaskHook <em>Os Pre Task Hook</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Pre Task Hook</em>' attribute is set.
	 * @see #unsetOsPreTaskHook()
	 * @see #getOsPreTaskHook()
	 * @see #setOsPreTaskHook(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsPreTaskHook();

	/**
	 * Returns the value of the '<em><b>Os Protection Hook</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Switch to enable/disable the call to the (user supplied) protection hook.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Protection Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsProtectionHook()
	 * @see #unsetOsProtectionHook()
	 * @see #setOsProtectionHook(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsProtectionHook()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsProtectionHook' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsProtectionHook();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsProtectionHook <em>Os Protection Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Protection Hook</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsProtectionHook()
	 * @see #unsetOsProtectionHook()
	 * @see #getOsProtectionHook()
	 * @generated
	 */
	void setOsProtectionHook(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsProtectionHook <em>Os Protection Hook</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsProtectionHook()
	 * @see #getOsProtectionHook()
	 * @see #setOsProtectionHook(TypeBoolean)
	 * @generated
	 */
	void unsetOsProtectionHook();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsProtectionHook <em>Os Protection Hook</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Protection Hook</em>' attribute is set.
	 * @see #unsetOsProtectionHook()
	 * @see #getOsProtectionHook()
	 * @see #setOsProtectionHook(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsProtectionHook();

	/**
	 * Returns the value of the '<em><b>Os Scalability Class</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.OsScalabilityClassType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A scalability class for each System Object "OS" has to be selected. In order to customize the operating system to the needs of the user and to take full advantage of the processor features the operating system can be scaled according to the scalability classes.
	 * 
	 * If the scalability class is omitted this translates to the OIL AUTO mechanism.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Scalability Class</em>' attribute.
	 * @see SystemSparcClockMcu.OsScalabilityClassType
	 * @see #isSetOsScalabilityClass()
	 * @see #unsetOsScalabilityClass()
	 * @see #setOsScalabilityClass(OsScalabilityClassType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsScalabilityClass()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='OsScalabilityClass' namespace='##targetNamespace'"
	 * @generated
	 */
	OsScalabilityClassType getOsScalabilityClass();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsScalabilityClass <em>Os Scalability Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Scalability Class</em>' attribute.
	 * @see SystemSparcClockMcu.OsScalabilityClassType
	 * @see #isSetOsScalabilityClass()
	 * @see #unsetOsScalabilityClass()
	 * @see #getOsScalabilityClass()
	 * @generated
	 */
	void setOsScalabilityClass(OsScalabilityClassType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsScalabilityClass <em>Os Scalability Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsScalabilityClass()
	 * @see #getOsScalabilityClass()
	 * @see #setOsScalabilityClass(OsScalabilityClassType)
	 * @generated
	 */
	void unsetOsScalabilityClass();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsScalabilityClass <em>Os Scalability Class</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Scalability Class</em>' attribute is set.
	 * @see #unsetOsScalabilityClass()
	 * @see #getOsScalabilityClass()
	 * @see #setOsScalabilityClass(OsScalabilityClassType)
	 * @generated
	 */
	boolean isSetOsScalabilityClass();

	/**
	 * Returns the value of the '<em><b>Os Status</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.OsStatusType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The Status attribute specifies whether a system with standard or extended status has to be used. Automatic assigment is not supported for this attribute.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Status</em>' attribute.
	 * @see SystemSparcClockMcu.OsStatusType
	 * @see #isSetOsStatus()
	 * @see #unsetOsStatus()
	 * @see #setOsStatus(OsStatusType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getOSType_OsStatus()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='OsStatus' namespace='##targetNamespace'"
	 * @generated
	 */
	OsStatusType getOsStatus();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.OSType#getOsStatus <em>Os Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Status</em>' attribute.
	 * @see SystemSparcClockMcu.OsStatusType
	 * @see #isSetOsStatus()
	 * @see #unsetOsStatus()
	 * @see #getOsStatus()
	 * @generated
	 */
	void setOsStatus(OsStatusType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.OSType#getOsStatus <em>Os Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsStatus()
	 * @see #getOsStatus()
	 * @see #setOsStatus(OsStatusType)
	 * @generated
	 */
	void unsetOsStatus();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.OSType#getOsStatus <em>Os Status</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Status</em>' attribute is set.
	 * @see #unsetOsStatus()
	 * @see #getOsStatus()
	 * @see #setOsStatus(OsStatusType)
	 * @generated
	 */
	boolean isSetOsStatus();

} // OSType
