/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>PHYSCALUNIT Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getRxDmaChannel <em>Rx Dma Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getTxAuxDmaChannel <em>Tx Aux Dma Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getTxDmaChannel <em>Tx Dma Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMapping <em>Unit Mapping</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMode <em>Unit Mode</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType()
 * @model extendedMetaData="name='PHYSCAL_UNIT_._type' kind='empty'"
 * @generated
 */
public interface PHYSCALUNITType extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI Physical channle identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType12" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Rx Dma Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * DSPI Receive DMA Channel, used to read the deserialized dataframes into the RX buffers.
	 * 
	 * This parameter is required only if ASYNC_DMA mode is selected.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Rx Dma Channel</em>' attribute.
	 * @see #setRxDmaChannel(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_RxDmaChannel()
	 * @model dataType="SystemSparcClockMcu.RxDmaChannelType" required="true"
	 *        extendedMetaData="kind='attribute' name='RxDmaChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getRxDmaChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getRxDmaChannel <em>Rx Dma Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rx Dma Channel</em>' attribute.
	 * @see #getRxDmaChannel()
	 * @generated
	 */
	void setRxDmaChannel(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Tx Aux Dma Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * DSPI Auxiliary Transmit DMA Channel, used to place dataframes into the DSPI registers.
	 * 
	 * This parameter is required only if ASYNC_DMA mode is selected.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Tx Aux Dma Channel</em>' attribute.
	 * @see #setTxAuxDmaChannel(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_TxAuxDmaChannel()
	 * @model dataType="SystemSparcClockMcu.TxAuxDmaChannelType" required="true"
	 *        extendedMetaData="kind='attribute' name='TxAuxDmaChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTxAuxDmaChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getTxAuxDmaChannel <em>Tx Aux Dma Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tx Aux Dma Channel</em>' attribute.
	 * @see #getTxAuxDmaChannel()
	 * @generated
	 */
	void setTxAuxDmaChannel(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Tx Dma Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * DSPI Master Transmit DMA Channel, used to prepare the DSPI transmission dataframes starting from the TX buffer content.
	 * 
	 * This parameter is required only if ASYNC_DMA mode is selected.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Tx Dma Channel</em>' attribute.
	 * @see #setTxDmaChannel(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_TxDmaChannel()
	 * @model dataType="SystemSparcClockMcu.TxDmaChannelType" required="true"
	 *        extendedMetaData="kind='attribute' name='TxDmaChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTxDmaChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getTxDmaChannel <em>Tx Dma Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tx Dma Channel</em>' attribute.
	 * @see #getTxDmaChannel()
	 * @generated
	 */
	void setTxDmaChannel(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Unit Mapping</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.UnitMappingType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter is the symbolic name to identify the HW SPI Hardware microcontroller peripheral allocated to this Job.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Unit Mapping</em>' attribute.
	 * @see SystemSparcClockMcu.UnitMappingType
	 * @see #isSetUnitMapping()
	 * @see #unsetUnitMapping()
	 * @see #setUnitMapping(UnitMappingType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_UnitMapping()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='UnitMapping' namespace='##targetNamespace'"
	 * @generated
	 */
	UnitMappingType getUnitMapping();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMapping <em>Unit Mapping</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unit Mapping</em>' attribute.
	 * @see SystemSparcClockMcu.UnitMappingType
	 * @see #isSetUnitMapping()
	 * @see #unsetUnitMapping()
	 * @see #getUnitMapping()
	 * @generated
	 */
	void setUnitMapping(UnitMappingType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMapping <em>Unit Mapping</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetUnitMapping()
	 * @see #getUnitMapping()
	 * @see #setUnitMapping(UnitMappingType)
	 * @generated
	 */
	void unsetUnitMapping();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMapping <em>Unit Mapping</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Unit Mapping</em>' attribute is set.
	 * @see #unsetUnitMapping()
	 * @see #getUnitMapping()
	 * @see #setUnitMapping(UnitMappingType)
	 * @generated
	 */
	boolean isSetUnitMapping();

	/**
	 * Returns the value of the '<em><b>Unit Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.UnitModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specific if this HwUnit can only do sync transfers or async with the following methods: DMA or PIO with FIFO. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Unit Mode</em>' attribute.
	 * @see SystemSparcClockMcu.UnitModeType
	 * @see #isSetUnitMode()
	 * @see #unsetUnitMode()
	 * @see #setUnitMode(UnitModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPHYSCALUNITType_UnitMode()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='UnitMode' namespace='##targetNamespace'"
	 * @generated
	 */
	UnitModeType getUnitMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMode <em>Unit Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unit Mode</em>' attribute.
	 * @see SystemSparcClockMcu.UnitModeType
	 * @see #isSetUnitMode()
	 * @see #unsetUnitMode()
	 * @see #getUnitMode()
	 * @generated
	 */
	void setUnitMode(UnitModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMode <em>Unit Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetUnitMode()
	 * @see #getUnitMode()
	 * @see #setUnitMode(UnitModeType)
	 * @generated
	 */
	void unsetUnitMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.PHYSCALUNITType#getUnitMode <em>Unit Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Unit Mode</em>' attribute is set.
	 * @see #unsetUnitMode()
	 * @see #getUnitMode()
	 * @see #setUnitMode(UnitModeType)
	 * @generated
	 */
	boolean isSetUnitMode();

} // PHYSCALUNITType
