/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Peripheral Clk Set Attr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralDivisorFactor <em>Peripheral Divisor Factor</em>}</li>
 *   <li>{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralEnableClk <em>Peripheral Enable Clk</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPeripheralClkSetAttr()
 * @model extendedMetaData="name='PeripheralClkSet_Attr' kind='empty'"
 * @generated
 */
public interface PeripheralClkSetAttr extends EObject {
	/**
	 * Returns the value of the '<em><b>Peripheral Divisor Factor</b></em>' attribute.
	 * The default value is <code>"DIV_1"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.McuPeripheralDivisorFactorType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter configures the clock division factor for peripheral clock set  0 if the Peripheral clock division is enabled.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Peripheral Divisor Factor</em>' attribute.
	 * @see SystemSparcClockMcu.McuPeripheralDivisorFactorType
	 * @see #isSetPeripheralDivisorFactor()
	 * @see #unsetPeripheralDivisorFactor()
	 * @see #setPeripheralDivisorFactor(McuPeripheralDivisorFactorType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPeripheralClkSetAttr_PeripheralDivisorFactor()
	 * @model default="DIV_1" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='PeripheralDivisorFactor' namespace='##targetNamespace'"
	 * @generated
	 */
	McuPeripheralDivisorFactorType getPeripheralDivisorFactor();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralDivisorFactor <em>Peripheral Divisor Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Peripheral Divisor Factor</em>' attribute.
	 * @see SystemSparcClockMcu.McuPeripheralDivisorFactorType
	 * @see #isSetPeripheralDivisorFactor()
	 * @see #unsetPeripheralDivisorFactor()
	 * @see #getPeripheralDivisorFactor()
	 * @generated
	 */
	void setPeripheralDivisorFactor(McuPeripheralDivisorFactorType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralDivisorFactor <em>Peripheral Divisor Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetPeripheralDivisorFactor()
	 * @see #getPeripheralDivisorFactor()
	 * @see #setPeripheralDivisorFactor(McuPeripheralDivisorFactorType)
	 * @generated
	 */
	void unsetPeripheralDivisorFactor();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralDivisorFactor <em>Peripheral Divisor Factor</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Peripheral Divisor Factor</em>' attribute is set.
	 * @see #unsetPeripheralDivisorFactor()
	 * @see #getPeripheralDivisorFactor()
	 * @see #setPeripheralDivisorFactor(McuPeripheralDivisorFactorType)
	 * @generated
	 */
	boolean isSetPeripheralDivisorFactor();

	/**
	 * Returns the value of the '<em><b>Peripheral Enable Clk</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter Enables/Disables the system clock divider for the peripheral set 0.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Peripheral Enable Clk</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetPeripheralEnableClk()
	 * @see #unsetPeripheralEnableClk()
	 * @see #setPeripheralEnableClk(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getPeripheralClkSetAttr_PeripheralEnableClk()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='PeripheralEnableClk' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getPeripheralEnableClk();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralEnableClk <em>Peripheral Enable Clk</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Peripheral Enable Clk</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetPeripheralEnableClk()
	 * @see #unsetPeripheralEnableClk()
	 * @see #getPeripheralEnableClk()
	 * @generated
	 */
	void setPeripheralEnableClk(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralEnableClk <em>Peripheral Enable Clk</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetPeripheralEnableClk()
	 * @see #getPeripheralEnableClk()
	 * @see #setPeripheralEnableClk(TypeBoolean)
	 * @generated
	 */
	void unsetPeripheralEnableClk();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.PeripheralClkSetAttr#getPeripheralEnableClk <em>Peripheral Enable Clk</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Peripheral Enable Clk</em>' attribute is set.
	 * @see #unsetPeripheralEnableClk()
	 * @see #getPeripheralEnableClk()
	 * @see #setPeripheralEnableClk(TypeBoolean)
	 * @generated
	 */
	boolean isSetPeripheralEnableClk();

} // PeripheralClkSetAttr
