/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>RSTMON Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.RSTMONType#getDelayBeforeWRCounterReset <em>Delay Before WR Counter Reset</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RSTMONType#getWarmResetCounter <em>Warm Reset Counter</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRSTMONType()
 * @model extendedMetaData="name='RSTMON_._type' kind='empty'"
 * @generated
 */
public interface RSTMONType extends EObject {
	/**
	 * Returns the value of the '<em><b>Delay Before WR Counter Reset</b></em>' attribute.
	 * The default value is <code>"90"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies (in seconds) the duration until the warm reset counter is reset. After this delay (with no reset in between),
	 * the warm reset counter is reset.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Delay Before WR Counter Reset</em>' attribute.
	 * @see #isSetDelayBeforeWRCounterReset()
	 * @see #unsetDelayBeforeWRCounterReset()
	 * @see #setDelayBeforeWRCounterReset(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRSTMONType_DelayBeforeWRCounterReset()
	 * @model default="90" unsettable="true" dataType="SystemSparcClockMcu.DelayBeforeWRCounterResetType"
	 *        extendedMetaData="kind='attribute' name='DelayBeforeWRCounterReset' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDelayBeforeWRCounterReset();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RSTMONType#getDelayBeforeWRCounterReset <em>Delay Before WR Counter Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay Before WR Counter Reset</em>' attribute.
	 * @see #isSetDelayBeforeWRCounterReset()
	 * @see #unsetDelayBeforeWRCounterReset()
	 * @see #getDelayBeforeWRCounterReset()
	 * @generated
	 */
	void setDelayBeforeWRCounterReset(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RSTMONType#getDelayBeforeWRCounterReset <em>Delay Before WR Counter Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDelayBeforeWRCounterReset()
	 * @see #getDelayBeforeWRCounterReset()
	 * @see #setDelayBeforeWRCounterReset(BigInteger)
	 * @generated
	 */
	void unsetDelayBeforeWRCounterReset();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RSTMONType#getDelayBeforeWRCounterReset <em>Delay Before WR Counter Reset</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Delay Before WR Counter Reset</em>' attribute is set.
	 * @see #unsetDelayBeforeWRCounterReset()
	 * @see #getDelayBeforeWRCounterReset()
	 * @see #setDelayBeforeWRCounterReset(BigInteger)
	 * @generated
	 */
	boolean isSetDelayBeforeWRCounterReset();

	/**
	 * Returns the value of the '<em><b>Warm Reset Counter</b></em>' attribute.
	 * The default value is <code>"10"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specify after how many MCU warm resets should the non-initialized ram cleared and the system restarted.
	 * Minimum value is 1, maximum is 65535.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Warm Reset Counter</em>' attribute.
	 * @see #isSetWarmResetCounter()
	 * @see #unsetWarmResetCounter()
	 * @see #setWarmResetCounter(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRSTMONType_WarmResetCounter()
	 * @model default="10" unsettable="true" dataType="SystemSparcClockMcu.WarmResetCounterType"
	 *        extendedMetaData="kind='attribute' name='WarmResetCounter' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getWarmResetCounter();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RSTMONType#getWarmResetCounter <em>Warm Reset Counter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Warm Reset Counter</em>' attribute.
	 * @see #isSetWarmResetCounter()
	 * @see #unsetWarmResetCounter()
	 * @see #getWarmResetCounter()
	 * @generated
	 */
	void setWarmResetCounter(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RSTMONType#getWarmResetCounter <em>Warm Reset Counter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetWarmResetCounter()
	 * @see #getWarmResetCounter()
	 * @see #setWarmResetCounter(BigInteger)
	 * @generated
	 */
	void unsetWarmResetCounter();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RSTMONType#getWarmResetCounter <em>Warm Reset Counter</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Warm Reset Counter</em>' attribute is set.
	 * @see #unsetWarmResetCounter()
	 * @see #getWarmResetCounter()
	 * @see #setWarmResetCounter(BigInteger)
	 * @generated
	 */
	boolean isSetWarmResetCounter();

} // RSTMONType
