/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>RTC Channel Prescale Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCChannelPrescaleType()
 * @model extendedMetaData="name='RTCChannelPrescale_._type'"
 * @generated
 */
public enum RTCChannelPrescaleType implements Enumerator {
	/**
	 * The '<em><b>No Prescaler</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_PRESCALER_VALUE
	 * @generated
	 * @ordered
	 */
	NO_PRESCALER(0, "NoPrescaler", "No_prescaler"),

	/**
	 * The '<em><b>Divide32</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIVIDE32_VALUE
	 * @generated
	 * @ordered
	 */
	DIVIDE32(1, "Divide32", "Divide_32"),

	/**
	 * The '<em><b>Divide512</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIVIDE512_VALUE
	 * @generated
	 * @ordered
	 */
	DIVIDE512(2, "Divide512", "Divide_512"),

	/**
	 * The '<em><b>Divide16384</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIVIDE16384_VALUE
	 * @generated
	 * @ordered
	 */
	DIVIDE16384(3, "Divide16384", "Divide_16384");

	/**
	 * The '<em><b>No Prescaler</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Prescaler</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_PRESCALER
	 * @model name="NoPrescaler" literal="No_prescaler"
	 * @generated
	 * @ordered
	 */
	public static final int NO_PRESCALER_VALUE = 0;

	/**
	 * The '<em><b>Divide32</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Divide32</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIVIDE32
	 * @model name="Divide32" literal="Divide_32"
	 * @generated
	 * @ordered
	 */
	public static final int DIVIDE32_VALUE = 1;

	/**
	 * The '<em><b>Divide512</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Divide512</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIVIDE512
	 * @model name="Divide512" literal="Divide_512"
	 * @generated
	 * @ordered
	 */
	public static final int DIVIDE512_VALUE = 2;

	/**
	 * The '<em><b>Divide16384</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Divide16384</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIVIDE16384
	 * @model name="Divide16384" literal="Divide_16384"
	 * @generated
	 * @ordered
	 */
	public static final int DIVIDE16384_VALUE = 3;

	/**
	 * An array of all the '<em><b>RTC Channel Prescale Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RTCChannelPrescaleType[] VALUES_ARRAY =
		new RTCChannelPrescaleType[] {
			NO_PRESCALER,
			DIVIDE32,
			DIVIDE512,
			DIVIDE16384,
		};

	/**
	 * A public read-only list of all the '<em><b>RTC Channel Prescale Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<RTCChannelPrescaleType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>RTC Channel Prescale Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCChannelPrescaleType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTCChannelPrescaleType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTC Channel Prescale Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCChannelPrescaleType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTCChannelPrescaleType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTC Channel Prescale Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCChannelPrescaleType get(int value) {
		switch (value) {
			case NO_PRESCALER_VALUE: return NO_PRESCALER;
			case DIVIDE32_VALUE: return DIVIDE32;
			case DIVIDE512_VALUE: return DIVIDE512;
			case DIVIDE16384_VALUE: return DIVIDE16384;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RTCChannelPrescaleType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //RTCChannelPrescaleType
