/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>RTC Clock Source Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCClockSourceType()
 * @model extendedMetaData="name='RTCClockSource_._type'"
 * @generated
 */
public enum RTCClockSourceType implements Enumerator {
	/**
	 * The '<em><b>Clock32 KHz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK32_KHZ_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK32_KHZ(0, "Clock32KHz", "Clock_32KHz"),

	/**
	 * The '<em><b>Clock128 KHz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK128_KHZ_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK128_KHZ(1, "Clock128KHz", "Clock_128KHz"),

	/**
	 * The '<em><b>Clock16 MHz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK16_MHZ_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK16_MHZ(2, "Clock16MHz", "Clock_16MHz");

	/**
	 * The '<em><b>Clock32 KHz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Clock32 KHz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK32_KHZ
	 * @model name="Clock32KHz" literal="Clock_32KHz"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK32_KHZ_VALUE = 0;

	/**
	 * The '<em><b>Clock128 KHz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Clock128 KHz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK128_KHZ
	 * @model name="Clock128KHz" literal="Clock_128KHz"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK128_KHZ_VALUE = 1;

	/**
	 * The '<em><b>Clock16 MHz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Clock16 MHz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK16_MHZ
	 * @model name="Clock16MHz" literal="Clock_16MHz"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK16_MHZ_VALUE = 2;

	/**
	 * An array of all the '<em><b>RTC Clock Source Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RTCClockSourceType[] VALUES_ARRAY =
		new RTCClockSourceType[] {
			CLOCK32_KHZ,
			CLOCK128_KHZ,
			CLOCK16_MHZ,
		};

	/**
	 * A public read-only list of all the '<em><b>RTC Clock Source Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<RTCClockSourceType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>RTC Clock Source Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCClockSourceType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTCClockSourceType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTC Clock Source Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCClockSourceType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RTCClockSourceType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RTC Clock Source Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RTCClockSourceType get(int value) {
		switch (value) {
			case CLOCK32_KHZ_VALUE: return CLOCK32_KHZ;
			case CLOCK128_KHZ_VALUE: return CLOCK128_KHZ;
			case CLOCK16_MHZ_VALUE: return CLOCK16_MHZ;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RTCClockSourceType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //RTCClockSourceType
