/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>RTC Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.RTCType#getChannelMode <em>Channel Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RTCType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RTCType#getNotification <em>Notification</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RTCType#getRTCChannelPrescale <em>RTC Channel Prescale</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RTCType#getRTCClockSource <em>RTC Clock Source</em>}</li>
 *   <li>{@link SystemSparcClockMcu.RTCType#getWakeupRef <em>Wakeup Ref</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType()
 * @model extendedMetaData="name='RTC_._type' kind='empty'"
 * @generated
 */
public interface RTCType extends EObject {
	/**
	 * Returns the value of the '<em><b>Channel Mode</b></em>' attribute.
	 * The default value is <code>"GPT_MODE_ONESHOT"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.GptChannelModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the behaviour of the timerchannel after the timeout has expired.Select desired channel mode.
	 * 
	 * GptModeOneshot : Timer channel stops after reaching its timeout period value.
	 * 
	 * GptModeContinuous: Timer channel is restarted automatically after reaching timeout period value.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Channel Mode</em>' attribute.
	 * @see SystemSparcClockMcu.GptChannelModeType
	 * @see #isSetChannelMode()
	 * @see #unsetChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_ChannelMode()
	 * @model default="GPT_MODE_ONESHOT" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='ChannelMode' namespace='##targetNamespace'"
	 * @generated
	 */
	GptChannelModeType getChannelMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getChannelMode <em>Channel Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Channel Mode</em>' attribute.
	 * @see SystemSparcClockMcu.GptChannelModeType
	 * @see #isSetChannelMode()
	 * @see #unsetChannelMode()
	 * @see #getChannelMode()
	 * @generated
	 */
	void setChannelMode(GptChannelModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RTCType#getChannelMode <em>Channel Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetChannelMode()
	 * @see #getChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @generated
	 */
	void unsetChannelMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RTCType#getChannelMode <em>Channel Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Channel Mode</em>' attribute is set.
	 * @see #unsetChannelMode()
	 * @see #getChannelMode()
	 * @see #setChannelMode(GptChannelModeType)
	 * @generated
	 */
	boolean isSetChannelMode();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * GPT channel identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType13" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Notification</b></em>' attribute.
	 * The default value is <code>"NULL_PTR"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Function pointer to callback function.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Notification</em>' attribute.
	 * @see #isSetNotification()
	 * @see #unsetNotification()
	 * @see #setNotification(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_Notification()
	 * @model default="NULL_PTR" unsettable="true" dataType="SystemSparcClockMcu.NotificationType"
	 *        extendedMetaData="kind='attribute' name='Notification' namespace='##targetNamespace'"
	 * @generated
	 */
	String getNotification();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getNotification <em>Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Notification</em>' attribute.
	 * @see #isSetNotification()
	 * @see #unsetNotification()
	 * @see #getNotification()
	 * @generated
	 */
	void setNotification(String value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RTCType#getNotification <em>Notification</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetNotification()
	 * @see #getNotification()
	 * @see #setNotification(String)
	 * @generated
	 */
	void unsetNotification();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RTCType#getNotification <em>Notification</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Notification</em>' attribute is set.
	 * @see #unsetNotification()
	 * @see #getNotification()
	 * @see #setNotification(String)
	 * @generated
	 */
	boolean isSetNotification();

	/**
	 * Returns the value of the '<em><b>RTC Channel Prescale</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.RTCChannelPrescaleType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Select desired prescaler for the RTC channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>RTC Channel Prescale</em>' attribute.
	 * @see SystemSparcClockMcu.RTCChannelPrescaleType
	 * @see #isSetRTCChannelPrescale()
	 * @see #unsetRTCChannelPrescale()
	 * @see #setRTCChannelPrescale(RTCChannelPrescaleType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_RTCChannelPrescale()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RTCChannelPrescale' namespace='##targetNamespace'"
	 * @generated
	 */
	RTCChannelPrescaleType getRTCChannelPrescale();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getRTCChannelPrescale <em>RTC Channel Prescale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>RTC Channel Prescale</em>' attribute.
	 * @see SystemSparcClockMcu.RTCChannelPrescaleType
	 * @see #isSetRTCChannelPrescale()
	 * @see #unsetRTCChannelPrescale()
	 * @see #getRTCChannelPrescale()
	 * @generated
	 */
	void setRTCChannelPrescale(RTCChannelPrescaleType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RTCType#getRTCChannelPrescale <em>RTC Channel Prescale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRTCChannelPrescale()
	 * @see #getRTCChannelPrescale()
	 * @see #setRTCChannelPrescale(RTCChannelPrescaleType)
	 * @generated
	 */
	void unsetRTCChannelPrescale();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RTCType#getRTCChannelPrescale <em>RTC Channel Prescale</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>RTC Channel Prescale</em>' attribute is set.
	 * @see #unsetRTCChannelPrescale()
	 * @see #getRTCChannelPrescale()
	 * @see #setRTCChannelPrescale(RTCChannelPrescaleType)
	 * @generated
	 */
	boolean isSetRTCChannelPrescale();

	/**
	 * Returns the value of the '<em><b>RTC Clock Source</b></em>' attribute.
	 * The default value is <code>"Clock_32KHz"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.RTCClockSourceType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Select desired clock source for the RTC channel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>RTC Clock Source</em>' attribute.
	 * @see SystemSparcClockMcu.RTCClockSourceType
	 * @see #isSetRTCClockSource()
	 * @see #unsetRTCClockSource()
	 * @see #setRTCClockSource(RTCClockSourceType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_RTCClockSource()
	 * @model default="Clock_32KHz" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RTCClockSource' namespace='##targetNamespace'"
	 * @generated
	 */
	RTCClockSourceType getRTCClockSource();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getRTCClockSource <em>RTC Clock Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>RTC Clock Source</em>' attribute.
	 * @see SystemSparcClockMcu.RTCClockSourceType
	 * @see #isSetRTCClockSource()
	 * @see #unsetRTCClockSource()
	 * @see #getRTCClockSource()
	 * @generated
	 */
	void setRTCClockSource(RTCClockSourceType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RTCType#getRTCClockSource <em>RTC Clock Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRTCClockSource()
	 * @see #getRTCClockSource()
	 * @see #setRTCClockSource(RTCClockSourceType)
	 * @generated
	 */
	void unsetRTCClockSource();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RTCType#getRTCClockSource <em>RTC Clock Source</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>RTC Clock Source</em>' attribute is set.
	 * @see #unsetRTCClockSource()
	 * @see #getRTCClockSource()
	 * @see #setRTCClockSource(RTCClockSourceType)
	 * @generated
	 */
	boolean isSetRTCClockSource();

	/**
	 * Returns the value of the '<em><b>Wakeup Ref</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Enables wakeup capability of CPU for a channel when timeout period expires.
	 * 
	 * If any value is set GptEnableWakeup is set to TRUE. If the wakeup capability is not needed for the respective channel leave the attribute empty.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Wakeup Ref</em>' attribute.
	 * @see #isSetWakeupRef()
	 * @see #unsetWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRTCType_WakeupRef()
	 * @model default="0" unsettable="true" dataType="SystemSparcClockMcu.WakeupRefType"
	 *        extendedMetaData="kind='attribute' name='WakeupRef' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getWakeupRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.RTCType#getWakeupRef <em>Wakeup Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Wakeup Ref</em>' attribute.
	 * @see #isSetWakeupRef()
	 * @see #unsetWakeupRef()
	 * @see #getWakeupRef()
	 * @generated
	 */
	void setWakeupRef(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.RTCType#getWakeupRef <em>Wakeup Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetWakeupRef()
	 * @see #getWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @generated
	 */
	void unsetWakeupRef();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.RTCType#getWakeupRef <em>Wakeup Ref</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Wakeup Ref</em>' attribute is set.
	 * @see #unsetWakeupRef()
	 * @see #getWakeupRef()
	 * @see #setWakeupRef(BigInteger)
	 * @generated
	 */
	boolean isSetWakeupRef();

} // RTCType
