/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Recovery Mode Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getRecoveryModeType()
 * @model extendedMetaData="name='RecoveryMode_._type'"
 * @generated
 */
public enum RecoveryModeType implements Enumerator {
	/**
	 * The '<em><b>Immediate Recovery</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #IMMEDIATE_RECOVERY_VALUE
	 * @generated
	 * @ordered
	 */
	IMMEDIATE_RECOVERY(0, "ImmediateRecovery", "Immediate_Recovery"),

	/**
	 * The '<em><b>Time Based Recovery</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_BASED_RECOVERY_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_BASED_RECOVERY(1, "TimeBasedRecovery", "Time_Based_Recovery");

	/**
	 * The '<em><b>Immediate Recovery</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Immediate Recovery</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #IMMEDIATE_RECOVERY
	 * @model name="ImmediateRecovery" literal="Immediate_Recovery"
	 * @generated
	 * @ordered
	 */
	public static final int IMMEDIATE_RECOVERY_VALUE = 0;

	/**
	 * The '<em><b>Time Based Recovery</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time Based Recovery</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_BASED_RECOVERY
	 * @model name="TimeBasedRecovery" literal="Time_Based_Recovery"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_BASED_RECOVERY_VALUE = 1;

	/**
	 * An array of all the '<em><b>Recovery Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RecoveryModeType[] VALUES_ARRAY =
		new RecoveryModeType[] {
			IMMEDIATE_RECOVERY,
			TIME_BASED_RECOVERY,
		};

	/**
	 * A public read-only list of all the '<em><b>Recovery Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<RecoveryModeType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Recovery Mode Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RecoveryModeType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RecoveryModeType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Recovery Mode Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RecoveryModeType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RecoveryModeType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Recovery Mode Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RecoveryModeType get(int value) {
		switch (value) {
			case IMMEDIATE_RECOVERY_VALUE: return IMMEDIATE_RECOVERY;
			case TIME_BASED_RECOVERY_VALUE: return TIME_BASED_RECOVERY;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RecoveryModeType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //RecoveryModeType
