/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SBCTLE82 6x Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getBaudRate <em>Baud Rate</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getCANTransceiver1Used <em>CAN Transceiver1 Used</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelect <em>Chip Select</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelectPin <em>Chip Select Pin</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getFailureCallback <em>Failure Callback</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getIcuChannel <em>Icu Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getLimpHomeStateAfterInit <em>Limp Home State After Init</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver1Used <em>LIN Transceiver1 Used</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver2Used <em>LIN Transceiver2 Used</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver3Used <em>LIN Transceiver3 Used</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getResetReasonCallback <em>Reset Reason Callback</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSbcFailSafeMode <em>Sbc Fail Safe Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSbcLinSlope <em>Sbc Lin Slope</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetDelay <em>Sbc Reset Delay</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetThreshold <em>Sbc Reset Threshold</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSbcWAKEInputAcquisition <em>Sbc WAKE Input Acquisition</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getSPIHWChannel <em>SPIHW Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SBCTLE826xType#getTransceiverFailureCallback <em>Transceiver Failure Callback</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType()
 * @model extendedMetaData="name='SBC_TLE826x_._type' kind='empty'"
 * @generated
 */
public interface SBCTLE826xType extends EObject {
	/**
	 * Returns the value of the '<em><b>Baud Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Desired SPI communication speed in kbaud.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Baud Rate</em>' attribute.
	 * @see #setBaudRate(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_BaudRate()
	 * @model dataType="SystemSparcClockMcu.BaudRateType1" required="true"
	 *        extendedMetaData="kind='attribute' name='BaudRate' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getBaudRate();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getBaudRate <em>Baud Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Baud Rate</em>' attribute.
	 * @see #getBaudRate()
	 * @generated
	 */
	void setBaudRate(BigInteger value);

	/**
	 * Returns the value of the '<em><b>CAN Transceiver1 Used</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Generates a preprocessor macro which defines whether the CAN transceiver of the SBC is used or not.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CAN Transceiver1 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCANTransceiver1Used()
	 * @see #unsetCANTransceiver1Used()
	 * @see #setCANTransceiver1Used(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_CANTransceiver1Used()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='CANTransceiver1Used' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getCANTransceiver1Used();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getCANTransceiver1Used <em>CAN Transceiver1 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CAN Transceiver1 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetCANTransceiver1Used()
	 * @see #unsetCANTransceiver1Used()
	 * @see #getCANTransceiver1Used()
	 * @generated
	 */
	void setCANTransceiver1Used(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getCANTransceiver1Used <em>CAN Transceiver1 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetCANTransceiver1Used()
	 * @see #getCANTransceiver1Used()
	 * @see #setCANTransceiver1Used(TypeBoolean)
	 * @generated
	 */
	void unsetCANTransceiver1Used();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getCANTransceiver1Used <em>CAN Transceiver1 Used</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>CAN Transceiver1 Used</em>' attribute is set.
	 * @see #unsetCANTransceiver1Used()
	 * @see #getCANTransceiver1Used()
	 * @see #setCANTransceiver1Used(TypeBoolean)
	 * @generated
	 */
	boolean isSetCANTransceiver1Used();

	/**
	 * Returns the value of the '<em><b>Chip Select</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.ChipSelectType1}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI chip select used by the SPI device.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Chip Select</em>' attribute.
	 * @see SystemSparcClockMcu.ChipSelectType1
	 * @see #isSetChipSelect()
	 * @see #unsetChipSelect()
	 * @see #setChipSelect(ChipSelectType1)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_ChipSelect()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='ChipSelect' namespace='##targetNamespace'"
	 * @generated
	 */
	ChipSelectType1 getChipSelect();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelect <em>Chip Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chip Select</em>' attribute.
	 * @see SystemSparcClockMcu.ChipSelectType1
	 * @see #isSetChipSelect()
	 * @see #unsetChipSelect()
	 * @see #getChipSelect()
	 * @generated
	 */
	void setChipSelect(ChipSelectType1 value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelect <em>Chip Select</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetChipSelect()
	 * @see #getChipSelect()
	 * @see #setChipSelect(ChipSelectType1)
	 * @generated
	 */
	void unsetChipSelect();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelect <em>Chip Select</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Chip Select</em>' attribute is set.
	 * @see #unsetChipSelect()
	 * @see #getChipSelect()
	 * @see #setChipSelect(ChipSelectType1)
	 * @generated
	 */
	boolean isSetChipSelect();

	/**
	 * Returns the value of the '<em><b>Chip Select Pin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI chip select used by the SPI device if it's handled by the device via a DIO channel.
	 * Only available if @ChipSelect = SWP_OUT_CS.
	 * 
	 * It shall be a reference to:
	 * IO/DIRECT_PORTS/*/*/SWP_OUT/@Name
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Chip Select Pin</em>' attribute.
	 * @see #setChipSelectPin(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_ChipSelectPin()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='ChipSelectPin' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getChipSelectPin();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getChipSelectPin <em>Chip Select Pin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chip Select Pin</em>' attribute.
	 * @see #getChipSelectPin()
	 * @generated
	 */
	void setChipSelectPin(Object value);

	/**
	 * Returns the value of the '<em><b>Failure Callback</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Failure Callback</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Failure Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetFailureCallback()
	 * @see #unsetFailureCallback()
	 * @see #setFailureCallback(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_FailureCallback()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='FailureCallback' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getFailureCallback();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getFailureCallback <em>Failure Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Failure Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetFailureCallback()
	 * @see #unsetFailureCallback()
	 * @see #getFailureCallback()
	 * @generated
	 */
	void setFailureCallback(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getFailureCallback <em>Failure Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetFailureCallback()
	 * @see #getFailureCallback()
	 * @see #setFailureCallback(TypeBoolean)
	 * @generated
	 */
	void unsetFailureCallback();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getFailureCallback <em>Failure Callback</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Failure Callback</em>' attribute is set.
	 * @see #unsetFailureCallback()
	 * @see #getFailureCallback()
	 * @see #setFailureCallback(TypeBoolean)
	 * @generated
	 */
	boolean isSetFailureCallback();

	/**
	 * Returns the value of the '<em><b>Icu Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reference to the ICU channel used by the SBC.
	 * 
	 * It shall be a reference to:
	 * IO/DIRECT_PORTS/*/*/WAKEUP_INPUT/@Name
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Icu Channel</em>' attribute.
	 * @see #setIcuChannel(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_IcuChannel()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='IcuChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getIcuChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getIcuChannel <em>Icu Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Icu Channel</em>' attribute.
	 * @see #getIcuChannel()
	 * @generated
	 */
	void setIcuChannel(Object value);

	/**
	 * Returns the value of the '<em><b>Limp Home State After Init</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Generates a preprocessor macro which defines whether the Limp Home outputs will be activated or deactivated after initialization.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Limp Home State After Init</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLimpHomeStateAfterInit()
	 * @see #unsetLimpHomeStateAfterInit()
	 * @see #setLimpHomeStateAfterInit(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_LimpHomeStateAfterInit()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='LimpHomeStateAfterInit' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getLimpHomeStateAfterInit();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLimpHomeStateAfterInit <em>Limp Home State After Init</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Limp Home State After Init</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLimpHomeStateAfterInit()
	 * @see #unsetLimpHomeStateAfterInit()
	 * @see #getLimpHomeStateAfterInit()
	 * @generated
	 */
	void setLimpHomeStateAfterInit(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLimpHomeStateAfterInit <em>Limp Home State After Init</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLimpHomeStateAfterInit()
	 * @see #getLimpHomeStateAfterInit()
	 * @see #setLimpHomeStateAfterInit(TypeBoolean)
	 * @generated
	 */
	void unsetLimpHomeStateAfterInit();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLimpHomeStateAfterInit <em>Limp Home State After Init</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Limp Home State After Init</em>' attribute is set.
	 * @see #unsetLimpHomeStateAfterInit()
	 * @see #getLimpHomeStateAfterInit()
	 * @see #setLimpHomeStateAfterInit(TypeBoolean)
	 * @generated
	 */
	boolean isSetLimpHomeStateAfterInit();

	/**
	 * Returns the value of the '<em><b>LIN Transceiver1 Used</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Generates a preprocessor macro which defines whether the LIN1 transceiver of the SBC is used or not.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>LIN Transceiver1 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver1Used()
	 * @see #unsetLINTransceiver1Used()
	 * @see #setLINTransceiver1Used(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_LINTransceiver1Used()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='LINTransceiver1Used' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getLINTransceiver1Used();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver1Used <em>LIN Transceiver1 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>LIN Transceiver1 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver1Used()
	 * @see #unsetLINTransceiver1Used()
	 * @see #getLINTransceiver1Used()
	 * @generated
	 */
	void setLINTransceiver1Used(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver1Used <em>LIN Transceiver1 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLINTransceiver1Used()
	 * @see #getLINTransceiver1Used()
	 * @see #setLINTransceiver1Used(TypeBoolean)
	 * @generated
	 */
	void unsetLINTransceiver1Used();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver1Used <em>LIN Transceiver1 Used</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>LIN Transceiver1 Used</em>' attribute is set.
	 * @see #unsetLINTransceiver1Used()
	 * @see #getLINTransceiver1Used()
	 * @see #setLINTransceiver1Used(TypeBoolean)
	 * @generated
	 */
	boolean isSetLINTransceiver1Used();

	/**
	 * Returns the value of the '<em><b>LIN Transceiver2 Used</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Generates a preprocessor macro which defines whether the LIN2 transceiver of the SBC is used or not.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>LIN Transceiver2 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver2Used()
	 * @see #unsetLINTransceiver2Used()
	 * @see #setLINTransceiver2Used(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_LINTransceiver2Used()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='LINTransceiver2Used' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getLINTransceiver2Used();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver2Used <em>LIN Transceiver2 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>LIN Transceiver2 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver2Used()
	 * @see #unsetLINTransceiver2Used()
	 * @see #getLINTransceiver2Used()
	 * @generated
	 */
	void setLINTransceiver2Used(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver2Used <em>LIN Transceiver2 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLINTransceiver2Used()
	 * @see #getLINTransceiver2Used()
	 * @see #setLINTransceiver2Used(TypeBoolean)
	 * @generated
	 */
	void unsetLINTransceiver2Used();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver2Used <em>LIN Transceiver2 Used</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>LIN Transceiver2 Used</em>' attribute is set.
	 * @see #unsetLINTransceiver2Used()
	 * @see #getLINTransceiver2Used()
	 * @see #setLINTransceiver2Used(TypeBoolean)
	 * @generated
	 */
	boolean isSetLINTransceiver2Used();

	/**
	 * Returns the value of the '<em><b>LIN Transceiver3 Used</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Generates a preprocessor macro which defines whether the LIN3 transceiver of the SBC is used or not.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>LIN Transceiver3 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver3Used()
	 * @see #unsetLINTransceiver3Used()
	 * @see #setLINTransceiver3Used(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_LINTransceiver3Used()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='LINTransceiver3Used' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getLINTransceiver3Used();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver3Used <em>LIN Transceiver3 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>LIN Transceiver3 Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetLINTransceiver3Used()
	 * @see #unsetLINTransceiver3Used()
	 * @see #getLINTransceiver3Used()
	 * @generated
	 */
	void setLINTransceiver3Used(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver3Used <em>LIN Transceiver3 Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLINTransceiver3Used()
	 * @see #getLINTransceiver3Used()
	 * @see #setLINTransceiver3Used(TypeBoolean)
	 * @generated
	 */
	void unsetLINTransceiver3Used();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getLINTransceiver3Used <em>LIN Transceiver3 Used</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>LIN Transceiver3 Used</em>' attribute is set.
	 * @see #unsetLINTransceiver3Used()
	 * @see #getLINTransceiver3Used()
	 * @see #setLINTransceiver3Used(TypeBoolean)
	 * @generated
	 */
	boolean isSetLINTransceiver3Used();

	/**
	 * Returns the value of the '<em><b>Reset Reason Callback</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reset Reason Callback</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reset Reason Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetResetReasonCallback()
	 * @see #unsetResetReasonCallback()
	 * @see #setResetReasonCallback(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_ResetReasonCallback()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='ResetReasonCallback' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getResetReasonCallback();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getResetReasonCallback <em>Reset Reason Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reset Reason Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetResetReasonCallback()
	 * @see #unsetResetReasonCallback()
	 * @see #getResetReasonCallback()
	 * @generated
	 */
	void setResetReasonCallback(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getResetReasonCallback <em>Reset Reason Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetResetReasonCallback()
	 * @see #getResetReasonCallback()
	 * @see #setResetReasonCallback(TypeBoolean)
	 * @generated
	 */
	void unsetResetReasonCallback();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getResetReasonCallback <em>Reset Reason Callback</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Reset Reason Callback</em>' attribute is set.
	 * @see #unsetResetReasonCallback()
	 * @see #getResetReasonCallback()
	 * @see #setResetReasonCallback(TypeBoolean)
	 * @generated
	 */
	boolean isSetResetReasonCallback();

	/**
	 * Returns the value of the '<em><b>Sbc Fail Safe Mode</b></em>' attribute.
	 * The default value is <code>"SBC_FAIL_SAFE_ONE_WD_TRIGGER"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SbcFailSafeModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Preprocessor macro that defines the duration of the reset.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sbc Fail Safe Mode</em>' attribute.
	 * @see SystemSparcClockMcu.SbcFailSafeModeType
	 * @see #isSetSbcFailSafeMode()
	 * @see #unsetSbcFailSafeMode()
	 * @see #setSbcFailSafeMode(SbcFailSafeModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SbcFailSafeMode()
	 * @model default="SBC_FAIL_SAFE_ONE_WD_TRIGGER" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SbcFailSafeMode' namespace='##targetNamespace'"
	 * @generated
	 */
	SbcFailSafeModeType getSbcFailSafeMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcFailSafeMode <em>Sbc Fail Safe Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sbc Fail Safe Mode</em>' attribute.
	 * @see SystemSparcClockMcu.SbcFailSafeModeType
	 * @see #isSetSbcFailSafeMode()
	 * @see #unsetSbcFailSafeMode()
	 * @see #getSbcFailSafeMode()
	 * @generated
	 */
	void setSbcFailSafeMode(SbcFailSafeModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcFailSafeMode <em>Sbc Fail Safe Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSbcFailSafeMode()
	 * @see #getSbcFailSafeMode()
	 * @see #setSbcFailSafeMode(SbcFailSafeModeType)
	 * @generated
	 */
	void unsetSbcFailSafeMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcFailSafeMode <em>Sbc Fail Safe Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Sbc Fail Safe Mode</em>' attribute is set.
	 * @see #unsetSbcFailSafeMode()
	 * @see #getSbcFailSafeMode()
	 * @see #setSbcFailSafeMode(SbcFailSafeModeType)
	 * @generated
	 */
	boolean isSetSbcFailSafeMode();

	/**
	 * Returns the value of the '<em><b>Sbc Lin Slope</b></em>' attribute.
	 * The default value is <code>"SBC_LIN_NORMAL_SLOPE_MODE"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SbcLinSlopeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Preprocessor macro that defines the LIN slope configuration.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sbc Lin Slope</em>' attribute.
	 * @see SystemSparcClockMcu.SbcLinSlopeType
	 * @see #isSetSbcLinSlope()
	 * @see #unsetSbcLinSlope()
	 * @see #setSbcLinSlope(SbcLinSlopeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SbcLinSlope()
	 * @model default="SBC_LIN_NORMAL_SLOPE_MODE" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SbcLinSlope' namespace='##targetNamespace'"
	 * @generated
	 */
	SbcLinSlopeType getSbcLinSlope();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcLinSlope <em>Sbc Lin Slope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sbc Lin Slope</em>' attribute.
	 * @see SystemSparcClockMcu.SbcLinSlopeType
	 * @see #isSetSbcLinSlope()
	 * @see #unsetSbcLinSlope()
	 * @see #getSbcLinSlope()
	 * @generated
	 */
	void setSbcLinSlope(SbcLinSlopeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcLinSlope <em>Sbc Lin Slope</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSbcLinSlope()
	 * @see #getSbcLinSlope()
	 * @see #setSbcLinSlope(SbcLinSlopeType)
	 * @generated
	 */
	void unsetSbcLinSlope();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcLinSlope <em>Sbc Lin Slope</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Sbc Lin Slope</em>' attribute is set.
	 * @see #unsetSbcLinSlope()
	 * @see #getSbcLinSlope()
	 * @see #setSbcLinSlope(SbcLinSlopeType)
	 * @generated
	 */
	boolean isSetSbcLinSlope();

	/**
	 * Returns the value of the '<em><b>Sbc Reset Delay</b></em>' attribute.
	 * The default value is <code>"SBC_SHORT_RESET"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SbcResetDelayType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Preprocessor macro that defines the duration of the reset.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sbc Reset Delay</em>' attribute.
	 * @see SystemSparcClockMcu.SbcResetDelayType
	 * @see #isSetSbcResetDelay()
	 * @see #unsetSbcResetDelay()
	 * @see #setSbcResetDelay(SbcResetDelayType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SbcResetDelay()
	 * @model default="SBC_SHORT_RESET" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SbcResetDelay' namespace='##targetNamespace'"
	 * @generated
	 */
	SbcResetDelayType getSbcResetDelay();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetDelay <em>Sbc Reset Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sbc Reset Delay</em>' attribute.
	 * @see SystemSparcClockMcu.SbcResetDelayType
	 * @see #isSetSbcResetDelay()
	 * @see #unsetSbcResetDelay()
	 * @see #getSbcResetDelay()
	 * @generated
	 */
	void setSbcResetDelay(SbcResetDelayType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetDelay <em>Sbc Reset Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSbcResetDelay()
	 * @see #getSbcResetDelay()
	 * @see #setSbcResetDelay(SbcResetDelayType)
	 * @generated
	 */
	void unsetSbcResetDelay();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetDelay <em>Sbc Reset Delay</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Sbc Reset Delay</em>' attribute is set.
	 * @see #unsetSbcResetDelay()
	 * @see #getSbcResetDelay()
	 * @see #setSbcResetDelay(SbcResetDelayType)
	 * @generated
	 */
	boolean isSetSbcResetDelay();

	/**
	 * Returns the value of the '<em><b>Sbc Reset Threshold</b></em>' attribute.
	 * The default value is <code>"SBC_VRT1"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SbcResetThresholdType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Preprocessor macro that defines the undervoltage reset threshold.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sbc Reset Threshold</em>' attribute.
	 * @see SystemSparcClockMcu.SbcResetThresholdType
	 * @see #isSetSbcResetThreshold()
	 * @see #unsetSbcResetThreshold()
	 * @see #setSbcResetThreshold(SbcResetThresholdType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SbcResetThreshold()
	 * @model default="SBC_VRT1" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SbcResetThreshold' namespace='##targetNamespace'"
	 * @generated
	 */
	SbcResetThresholdType getSbcResetThreshold();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetThreshold <em>Sbc Reset Threshold</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sbc Reset Threshold</em>' attribute.
	 * @see SystemSparcClockMcu.SbcResetThresholdType
	 * @see #isSetSbcResetThreshold()
	 * @see #unsetSbcResetThreshold()
	 * @see #getSbcResetThreshold()
	 * @generated
	 */
	void setSbcResetThreshold(SbcResetThresholdType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetThreshold <em>Sbc Reset Threshold</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSbcResetThreshold()
	 * @see #getSbcResetThreshold()
	 * @see #setSbcResetThreshold(SbcResetThresholdType)
	 * @generated
	 */
	void unsetSbcResetThreshold();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcResetThreshold <em>Sbc Reset Threshold</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Sbc Reset Threshold</em>' attribute is set.
	 * @see #unsetSbcResetThreshold()
	 * @see #getSbcResetThreshold()
	 * @see #setSbcResetThreshold(SbcResetThresholdType)
	 * @generated
	 */
	boolean isSetSbcResetThreshold();

	/**
	 * Returns the value of the '<em><b>Sbc WAKE Input Acquisition</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Gnerates a preprocessor macro which defines whether the WAKE input acquisition is done by the IO Hardware Abstraction or not.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Sbc WAKE Input Acquisition</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetSbcWAKEInputAcquisition()
	 * @see #unsetSbcWAKEInputAcquisition()
	 * @see #setSbcWAKEInputAcquisition(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SbcWAKEInputAcquisition()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SbcWAKEInputAcquisition' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getSbcWAKEInputAcquisition();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcWAKEInputAcquisition <em>Sbc WAKE Input Acquisition</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sbc WAKE Input Acquisition</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetSbcWAKEInputAcquisition()
	 * @see #unsetSbcWAKEInputAcquisition()
	 * @see #getSbcWAKEInputAcquisition()
	 * @generated
	 */
	void setSbcWAKEInputAcquisition(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcWAKEInputAcquisition <em>Sbc WAKE Input Acquisition</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSbcWAKEInputAcquisition()
	 * @see #getSbcWAKEInputAcquisition()
	 * @see #setSbcWAKEInputAcquisition(TypeBoolean)
	 * @generated
	 */
	void unsetSbcWAKEInputAcquisition();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSbcWAKEInputAcquisition <em>Sbc WAKE Input Acquisition</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Sbc WAKE Input Acquisition</em>' attribute is set.
	 * @see #unsetSbcWAKEInputAcquisition()
	 * @see #getSbcWAKEInputAcquisition()
	 * @see #setSbcWAKEInputAcquisition(TypeBoolean)
	 * @generated
	 */
	boolean isSetSbcWAKEInputAcquisition();

	/**
	 * Returns the value of the '<em><b>SPIHW Channel</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.SPIHWChannelType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * SPI peripheral used by the SPI device.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SPIHW Channel</em>' attribute.
	 * @see SystemSparcClockMcu.SPIHWChannelType
	 * @see #isSetSPIHWChannel()
	 * @see #unsetSPIHWChannel()
	 * @see #setSPIHWChannel(SPIHWChannelType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_SPIHWChannel()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='SPI_HW_Channel' namespace='##targetNamespace'"
	 * @generated
	 */
	SPIHWChannelType getSPIHWChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSPIHWChannel <em>SPIHW Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SPIHW Channel</em>' attribute.
	 * @see SystemSparcClockMcu.SPIHWChannelType
	 * @see #isSetSPIHWChannel()
	 * @see #unsetSPIHWChannel()
	 * @see #getSPIHWChannel()
	 * @generated
	 */
	void setSPIHWChannel(SPIHWChannelType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSPIHWChannel <em>SPIHW Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSPIHWChannel()
	 * @see #getSPIHWChannel()
	 * @see #setSPIHWChannel(SPIHWChannelType)
	 * @generated
	 */
	void unsetSPIHWChannel();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getSPIHWChannel <em>SPIHW Channel</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>SPIHW Channel</em>' attribute is set.
	 * @see #unsetSPIHWChannel()
	 * @see #getSPIHWChannel()
	 * @see #setSPIHWChannel(SPIHWChannelType)
	 * @generated
	 */
	boolean isSetSPIHWChannel();

	/**
	 * Returns the value of the '<em><b>Transceiver Failure Callback</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transceiver Failure Callback</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transceiver Failure Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetTransceiverFailureCallback()
	 * @see #unsetTransceiverFailureCallback()
	 * @see #setTransceiverFailureCallback(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSBCTLE826xType_TransceiverFailureCallback()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='TransceiverFailureCallback' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getTransceiverFailureCallback();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getTransceiverFailureCallback <em>Transceiver Failure Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Transceiver Failure Callback</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetTransceiverFailureCallback()
	 * @see #unsetTransceiverFailureCallback()
	 * @see #getTransceiverFailureCallback()
	 * @generated
	 */
	void setTransceiverFailureCallback(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getTransceiverFailureCallback <em>Transceiver Failure Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTransceiverFailureCallback()
	 * @see #getTransceiverFailureCallback()
	 * @see #setTransceiverFailureCallback(TypeBoolean)
	 * @generated
	 */
	void unsetTransceiverFailureCallback();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SBCTLE826xType#getTransceiverFailureCallback <em>Transceiver Failure Callback</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Transceiver Failure Callback</em>' attribute is set.
	 * @see #unsetTransceiverFailureCallback()
	 * @see #getTransceiverFailureCallback()
	 * @see #setTransceiverFailureCallback(TypeBoolean)
	 * @generated
	 */
	boolean isSetTransceiverFailureCallback();

} // SBCTLE826xType
