/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SMHFREQUENCYMONITORING Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getRecoveryMode <em>Recovery Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhFmTimerChannel <em>Smh Fm Timer Channel</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhFmTimerChannelPeriod <em>Smh Fm Timer Channel Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhLowPowerFrequencyMonitoring <em>Smh Low Power Frequency Monitoring</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhNumberOfRetriesInHighPower <em>Smh Number Of Retries In High Power</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhNumberOfRetriesInLowPower <em>Smh Number Of Retries In Low Power</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType()
 * @model extendedMetaData="name='SMH_FREQUENCY_MONITORING_._type' kind='empty'"
 * @generated
 */
public interface SMHFREQUENCYMONITORINGType extends EObject {
	/**
	 * Returns the value of the '<em><b>Recovery Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.RecoveryModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Selects the recovery mode.
	 * If Time Based Recovery is selected the follwing paramters have to be configured: SmhFmTimerChannelPeriod and SmhFmTimerChannel.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Recovery Mode</em>' attribute.
	 * @see SystemSparcClockMcu.RecoveryModeType
	 * @see #isSetRecoveryMode()
	 * @see #unsetRecoveryMode()
	 * @see #setRecoveryMode(RecoveryModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_RecoveryMode()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='RecoveryMode' namespace='##targetNamespace'"
	 * @generated
	 */
	RecoveryModeType getRecoveryMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getRecoveryMode <em>Recovery Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Recovery Mode</em>' attribute.
	 * @see SystemSparcClockMcu.RecoveryModeType
	 * @see #isSetRecoveryMode()
	 * @see #unsetRecoveryMode()
	 * @see #getRecoveryMode()
	 * @generated
	 */
	void setRecoveryMode(RecoveryModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getRecoveryMode <em>Recovery Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRecoveryMode()
	 * @see #getRecoveryMode()
	 * @see #setRecoveryMode(RecoveryModeType)
	 * @generated
	 */
	void unsetRecoveryMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getRecoveryMode <em>Recovery Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Recovery Mode</em>' attribute is set.
	 * @see #unsetRecoveryMode()
	 * @see #getRecoveryMode()
	 * @see #setRecoveryMode(RecoveryModeType)
	 * @generated
	 */
	boolean isSetRecoveryMode();

	/**
	 * Returns the value of the '<em><b>Smh Fm Timer Channel</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reference to a Gpt timer channel used by the Time Based recovery option.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Smh Fm Timer Channel</em>' attribute.
	 * @see #setSmhFmTimerChannel(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_SmhFmTimerChannel()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='SmhFmTimerChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getSmhFmTimerChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhFmTimerChannel <em>Smh Fm Timer Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Smh Fm Timer Channel</em>' attribute.
	 * @see #getSmhFmTimerChannel()
	 * @generated
	 */
	void setSmhFmTimerChannel(Object value);

	/**
	 * Returns the value of the '<em><b>Smh Fm Timer Channel Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Gpt channel period (in time ticks) used to configure the timer at run-time after a failure is detected by the FM.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Smh Fm Timer Channel Period</em>' attribute.
	 * @see #setSmhFmTimerChannelPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_SmhFmTimerChannelPeriod()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='SmhFmTimerChannelPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSmhFmTimerChannelPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhFmTimerChannelPeriod <em>Smh Fm Timer Channel Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Smh Fm Timer Channel Period</em>' attribute.
	 * @see #getSmhFmTimerChannelPeriod()
	 * @generated
	 */
	void setSmhFmTimerChannelPeriod(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Smh Low Power Frequency Monitoring</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines whether the FM feature will attempt to recover from a failure state in low power, or invoke the System Error Manager directly.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Smh Low Power Frequency Monitoring</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetSmhLowPowerFrequencyMonitoring()
	 * @see #unsetSmhLowPowerFrequencyMonitoring()
	 * @see #setSmhLowPowerFrequencyMonitoring(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_SmhLowPowerFrequencyMonitoring()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='SmhLowPowerFrequencyMonitoring' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getSmhLowPowerFrequencyMonitoring();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhLowPowerFrequencyMonitoring <em>Smh Low Power Frequency Monitoring</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Smh Low Power Frequency Monitoring</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetSmhLowPowerFrequencyMonitoring()
	 * @see #unsetSmhLowPowerFrequencyMonitoring()
	 * @see #getSmhLowPowerFrequencyMonitoring()
	 * @generated
	 */
	void setSmhLowPowerFrequencyMonitoring(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhLowPowerFrequencyMonitoring <em>Smh Low Power Frequency Monitoring</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSmhLowPowerFrequencyMonitoring()
	 * @see #getSmhLowPowerFrequencyMonitoring()
	 * @see #setSmhLowPowerFrequencyMonitoring(TypeBoolean)
	 * @generated
	 */
	void unsetSmhLowPowerFrequencyMonitoring();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhLowPowerFrequencyMonitoring <em>Smh Low Power Frequency Monitoring</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Smh Low Power Frequency Monitoring</em>' attribute is set.
	 * @see #unsetSmhLowPowerFrequencyMonitoring()
	 * @see #getSmhLowPowerFrequencyMonitoring()
	 * @see #setSmhLowPowerFrequencyMonitoring(TypeBoolean)
	 * @generated
	 */
	boolean isSetSmhLowPowerFrequencyMonitoring();

	/**
	 * Returns the value of the '<em><b>Smh Number Of Retries In High Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Number of consecutive retries enforced by the FM in case of a clock failure detected in high power.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Smh Number Of Retries In High Power</em>' attribute.
	 * @see #setSmhNumberOfRetriesInHighPower(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_SmhNumberOfRetriesInHighPower()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='SmhNumberOfRetriesInHighPower' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSmhNumberOfRetriesInHighPower();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhNumberOfRetriesInHighPower <em>Smh Number Of Retries In High Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Smh Number Of Retries In High Power</em>' attribute.
	 * @see #getSmhNumberOfRetriesInHighPower()
	 * @generated
	 */
	void setSmhNumberOfRetriesInHighPower(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Smh Number Of Retries In Low Power</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Number of consecutive retries enforced by the FM in case of a clock failure detected in low power.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Smh Number Of Retries In Low Power</em>' attribute.
	 * @see #setSmhNumberOfRetriesInLowPower(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSMHFREQUENCYMONITORINGType_SmhNumberOfRetriesInLowPower()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='SmhNumberOfRetriesInLowPower' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSmhNumberOfRetriesInLowPower();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SMHFREQUENCYMONITORINGType#getSmhNumberOfRetriesInLowPower <em>Smh Number Of Retries In Low Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Smh Number Of Retries In Low Power</em>' attribute.
	 * @see #getSmhNumberOfRetriesInLowPower()
	 * @generated
	 */
	void setSmhNumberOfRetriesInLowPower(BigInteger value);

} // SMHFREQUENCYMONITORINGType
