/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>SSIZE Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSSIZEType()
 * @model extendedMetaData="name='SSIZE_._type'"
 * @generated
 */
public enum SSIZEType implements Enumerator {
	/**
	 * The '<em><b>Size8 Bit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SIZE8_BIT_VALUE
	 * @generated
	 * @ordered
	 */
	SIZE8_BIT(0, "Size8Bit", "Size_8_bit"),

	/**
	 * The '<em><b>Size16 Bit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SIZE16_BIT_VALUE
	 * @generated
	 * @ordered
	 */
	SIZE16_BIT(1, "Size16Bit", "Size_16_bit"),

	/**
	 * The '<em><b>Size32 Bit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SIZE32_BIT_VALUE
	 * @generated
	 * @ordered
	 */
	SIZE32_BIT(2, "Size32Bit", "Size_32_bit"),

	/**
	 * The '<em><b>Size16 Byte</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SIZE16_BYTE_VALUE
	 * @generated
	 * @ordered
	 */
	SIZE16_BYTE(3, "Size16Byte", "Size_16_byte"),

	/**
	 * The '<em><b>Size32 Byte</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SIZE32_BYTE_VALUE
	 * @generated
	 * @ordered
	 */
	SIZE32_BYTE(4, "Size32Byte", "Size_32_byte");

	/**
	 * The '<em><b>Size8 Bit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Size8 Bit</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SIZE8_BIT
	 * @model name="Size8Bit" literal="Size_8_bit"
	 * @generated
	 * @ordered
	 */
	public static final int SIZE8_BIT_VALUE = 0;

	/**
	 * The '<em><b>Size16 Bit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Size16 Bit</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SIZE16_BIT
	 * @model name="Size16Bit" literal="Size_16_bit"
	 * @generated
	 * @ordered
	 */
	public static final int SIZE16_BIT_VALUE = 1;

	/**
	 * The '<em><b>Size32 Bit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Size32 Bit</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SIZE32_BIT
	 * @model name="Size32Bit" literal="Size_32_bit"
	 * @generated
	 * @ordered
	 */
	public static final int SIZE32_BIT_VALUE = 2;

	/**
	 * The '<em><b>Size16 Byte</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Size16 Byte</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SIZE16_BYTE
	 * @model name="Size16Byte" literal="Size_16_byte"
	 * @generated
	 * @ordered
	 */
	public static final int SIZE16_BYTE_VALUE = 3;

	/**
	 * The '<em><b>Size32 Byte</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Size32 Byte</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SIZE32_BYTE
	 * @model name="Size32Byte" literal="Size_32_byte"
	 * @generated
	 * @ordered
	 */
	public static final int SIZE32_BYTE_VALUE = 4;

	/**
	 * An array of all the '<em><b>SSIZE Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final SSIZEType[] VALUES_ARRAY =
		new SSIZEType[] {
			SIZE8_BIT,
			SIZE16_BIT,
			SIZE32_BIT,
			SIZE16_BYTE,
			SIZE32_BYTE,
		};

	/**
	 * A public read-only list of all the '<em><b>SSIZE Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<SSIZEType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>SSIZE Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SSIZEType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SSIZEType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>SSIZE Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SSIZEType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SSIZEType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>SSIZE Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SSIZEType get(int value) {
		switch (value) {
			case SIZE8_BIT_VALUE: return SIZE8_BIT;
			case SIZE16_BIT_VALUE: return SIZE16_BIT;
			case SIZE32_BIT_VALUE: return SIZE32_BIT;
			case SIZE16_BYTE_VALUE: return SIZE16_BYTE;
			case SIZE32_BYTE_VALUE: return SIZE32_BYTE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private SSIZEType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //SSIZEType
