/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>STM Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.STMType#getCHANNEL <em>CHANNEL</em>}</li>
 *   <li>{@link SystemSparcClockMcu.STMType#getGptSTMChannelPrescale1 <em>Gpt STM Channel Prescale1</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType()
 * @model extendedMetaData="name='STM_._type' kind='elementOnly'"
 * @generated
 */
public interface STMType extends EObject {
	/**
	 * Returns the value of the '<em><b>CHANNEL</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.CHANNELType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>CHANNEL</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>CHANNEL</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType_CHANNEL()
	 * @model containment="true" required="true" upper="4"
	 *        extendedMetaData="kind='element' name='CHANNEL' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<CHANNELType> getCHANNEL();

	/**
	 * Returns the value of the '<em><b>Gpt STM Channel Prescale1</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Selects the clock divide value for the prescaler (1-256).
	 * 
	 * This is the secondary STMChannelPrescale.This is used for cases where the timeout needs to be maintained constant at a different frequency.
	 * 
	 * This parameter would not be used if GptConfigurationOfOptApiServices/GptSelectPrescalerApi is false.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Gpt STM Channel Prescale1</em>' attribute.
	 * @see #isSetGptSTMChannelPrescale1()
	 * @see #unsetGptSTMChannelPrescale1()
	 * @see #setGptSTMChannelPrescale1(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType_GptSTMChannelPrescale1()
	 * @model default="1" unsettable="true" dataType="SystemSparcClockMcu.GptSTMChannelPrescale1Type"
	 *        extendedMetaData="kind='attribute' name='GptSTMChannelPrescale1' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getGptSTMChannelPrescale1();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.STMType#getGptSTMChannelPrescale1 <em>Gpt STM Channel Prescale1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gpt STM Channel Prescale1</em>' attribute.
	 * @see #isSetGptSTMChannelPrescale1()
	 * @see #unsetGptSTMChannelPrescale1()
	 * @see #getGptSTMChannelPrescale1()
	 * @generated
	 */
	void setGptSTMChannelPrescale1(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.STMType#getGptSTMChannelPrescale1 <em>Gpt STM Channel Prescale1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetGptSTMChannelPrescale1()
	 * @see #getGptSTMChannelPrescale1()
	 * @see #setGptSTMChannelPrescale1(BigInteger)
	 * @generated
	 */
	void unsetGptSTMChannelPrescale1();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.STMType#getGptSTMChannelPrescale1 <em>Gpt STM Channel Prescale1</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Gpt STM Channel Prescale1</em>' attribute is set.
	 * @see #unsetGptSTMChannelPrescale1()
	 * @see #getGptSTMChannelPrescale1()
	 * @see #setGptSTMChannelPrescale1(BigInteger)
	 * @generated
	 */
	boolean isSetGptSTMChannelPrescale1();

} // STMType
