/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>STM Type1</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.STMType1#getOsFreeze <em>Os Freeze</em>}</li>
 *   <li>{@link SystemSparcClockMcu.STMType1#getOsPrescaler <em>Os Prescaler</em>}</li>
 *   <li>{@link SystemSparcClockMcu.STMType1#getStmChannel <em>Stm Channel</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType1()
 * @model extendedMetaData="name='STM_._1_._type' kind='empty'"
 * @generated
 */
public interface STMType1 extends EObject {
	/**
	 * Returns the value of the '<em><b>Os Freeze</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies timer freeze bit value (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/STM/Freeze).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Freeze</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsFreeze()
	 * @see #unsetOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType1_OsFreeze()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='OsFreeze' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getOsFreeze();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.STMType1#getOsFreeze <em>Os Freeze</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Freeze</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetOsFreeze()
	 * @see #unsetOsFreeze()
	 * @see #getOsFreeze()
	 * @generated
	 */
	void setOsFreeze(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.STMType1#getOsFreeze <em>Os Freeze</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOsFreeze()
	 * @see #getOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @generated
	 */
	void unsetOsFreeze();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.STMType1#getOsFreeze <em>Os Freeze</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Os Freeze</em>' attribute is set.
	 * @see #unsetOsFreeze()
	 * @see #getOsFreeze()
	 * @see #setOsFreeze(TypeBoolean)
	 * @generated
	 */
	boolean isSetOsFreeze();

	/**
	 * Returns the value of the '<em><b>Os Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies either USER or OS prescaler shall be initialized during OS startup (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/STM/Prescaler).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Os Prescaler</em>' attribute.
	 * @see #setOsPrescaler(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType1_OsPrescaler()
	 * @model dataType="SystemSparcClockMcu.OsPrescalerType" required="true"
	 *        extendedMetaData="kind='attribute' name='OsPrescaler' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getOsPrescaler();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.STMType1#getOsPrescaler <em>Os Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Prescaler</em>' attribute.
	 * @see #getOsPrescaler()
	 * @generated
	 */
	void setOsPrescaler(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Stm Channel</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.StmHWChannelType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Specifies which channel is used (/OS/TargetMCU/MPC5607B/SysTimer/HWCOUNTER/TimerHardware/STM/Channel).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Stm Channel</em>' attribute.
	 * @see SystemSparcClockMcu.StmHWChannelType
	 * @see #isSetStmChannel()
	 * @see #unsetStmChannel()
	 * @see #setStmChannel(StmHWChannelType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSTMType1_StmChannel()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='StmChannel' namespace='##targetNamespace'"
	 * @generated
	 */
	StmHWChannelType getStmChannel();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.STMType1#getStmChannel <em>Stm Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stm Channel</em>' attribute.
	 * @see SystemSparcClockMcu.StmHWChannelType
	 * @see #isSetStmChannel()
	 * @see #unsetStmChannel()
	 * @see #getStmChannel()
	 * @generated
	 */
	void setStmChannel(StmHWChannelType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.STMType1#getStmChannel <em>Stm Channel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStmChannel()
	 * @see #getStmChannel()
	 * @see #setStmChannel(StmHWChannelType)
	 * @generated
	 */
	void unsetStmChannel();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.STMType1#getStmChannel <em>Stm Channel</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Stm Channel</em>' attribute is set.
	 * @see #unsetStmChannel()
	 * @see #getStmChannel()
	 * @see #setStmChannel(StmHWChannelType)
	 * @generated
	 */
	boolean isSetStmChannel();

} // STMType1
