/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SYSERRMAN Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.SYSERRMANType#getMODULE <em>MODULE</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSERRMANType#getSystemErrorBufferSize <em>System Error Buffer Size</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSERRMANType()
 * @model extendedMetaData="name='SYSERRMAN_._type' kind='elementOnly'"
 * @generated
 */
public interface SYSERRMANType extends EObject {
	/**
	 * Returns the value of the '<em><b>MODULE</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.MODULEType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MODULE</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MODULE</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSERRMANType_MODULE()
	 * @model containment="true" required="true" upper="65535"
	 *        extendedMetaData="kind='element' name='MODULE' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<MODULEType> getMODULE();

	/**
	 * Returns the value of the '<em><b>System Error Buffer Size</b></em>' attribute.
	 * The default value is <code>"8"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the size of the buffer used to store system error messages. 
	 * This represents  the last consecutive 'N' errors that can be stored into the system error buffer. 
	 * E.g. If a value of 1 is specified the error buffer will have 1 entry, so only the last error shall be present every time in the error buffer. 
	 * If a value of 8 is specified the error buffer will have 8 entries, so the last 8 errors shall be present ever time in the buffer.  
	 * Minimum value is 1, maximum is 256. 
	 *  
	 * VERY IMPORTANT: Be aware that the execution time of the API function that reads the system error information's ( SysErrMan_GetErrorInfo() ) should not exceed 30us. 
	 * This because the API is interrupt protected and the time limit to leave the system with interrupts disabled is 30us. 
	 * So no more than 'N' error entries should be read with the execution of this API function. 
	 * For instance this time limit with a 40 MHz frequency configuration (8 MHZ core * 5x PLL) is reached when 38 entries are read with that API. 
	 * So in this particular case no more than 38 entries should be read. This also means that the 'SystemErrorBufferSize' is recommended to be configured to a maximum size of 38 (for this particular case).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>System Error Buffer Size</em>' attribute.
	 * @see #isSetSystemErrorBufferSize()
	 * @see #unsetSystemErrorBufferSize()
	 * @see #setSystemErrorBufferSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSERRMANType_SystemErrorBufferSize()
	 * @model default="8" unsettable="true" dataType="SystemSparcClockMcu.SystemErrorBufferSizeType"
	 *        extendedMetaData="kind='attribute' name='SystemErrorBufferSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getSystemErrorBufferSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSERRMANType#getSystemErrorBufferSize <em>System Error Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>System Error Buffer Size</em>' attribute.
	 * @see #isSetSystemErrorBufferSize()
	 * @see #unsetSystemErrorBufferSize()
	 * @see #getSystemErrorBufferSize()
	 * @generated
	 */
	void setSystemErrorBufferSize(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SYSERRMANType#getSystemErrorBufferSize <em>System Error Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetSystemErrorBufferSize()
	 * @see #getSystemErrorBufferSize()
	 * @see #setSystemErrorBufferSize(BigInteger)
	 * @generated
	 */
	void unsetSystemErrorBufferSize();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SYSERRMANType#getSystemErrorBufferSize <em>System Error Buffer Size</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>System Error Buffer Size</em>' attribute is set.
	 * @see #unsetSystemErrorBufferSize()
	 * @see #getSystemErrorBufferSize()
	 * @see #setSystemErrorBufferSize(BigInteger)
	 * @generated
	 */
	boolean isSetSystemErrorBufferSize();

} // SYSERRMANType
