/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SYSTEM Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getCLOCK <em>CLOCK</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getMCU <em>MCU</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getOS <em>OS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getECUM <em>ECUM</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getSCHM <em>SCHM</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getWATCHDOG <em>WATCHDOG</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getTIMERS <em>TIMERS</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getDMA <em>DMA</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getLPM <em>LPM</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getUTILITIES <em>UTILITIES</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getSWSEC <em>SWSEC</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getSPI <em>SPI</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getSTD <em>STD</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getDerivative <em>Derivative</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getDetEnabled <em>Det Enabled</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getDetRamBufferSize <em>Det Ram Buffer Size</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getEvtManResourceRef <em>Evt Man Resource Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getEvtManTaskPriority <em>Evt Man Task Priority</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getIsEvtManUsed <em>Is Evt Man Used</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SYSTEMType#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType()
 * @model extendedMetaData="name='SYSTEM_._type' kind='elementOnly'"
 * @generated
 */
public interface SYSTEMType extends EObject {
	/**
	 * Returns the value of the '<em><b>CLOCK</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is the configuration for the running clock in HP.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CLOCK</em>' containment reference.
	 * @see #setCLOCK(CLOCKType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_CLOCK()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='CLOCK' namespace='##targetNamespace'"
	 * @generated
	 */
	CLOCKType getCLOCK();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getCLOCK <em>CLOCK</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CLOCK</em>' containment reference.
	 * @see #getCLOCK()
	 * @generated
	 */
	void setCLOCK(CLOCKType value);

	/**
	 * Returns the value of the '<em><b>MCU</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>MCU</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>MCU</em>' containment reference.
	 * @see #setMCU(MCUType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_MCU()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='MCU' namespace='##targetNamespace'"
	 * @generated
	 */
	MCUType getMCU();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getMCU <em>MCU</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>MCU</em>' containment reference.
	 * @see #getMCU()
	 * @generated
	 */
	void setMCU(MCUType value);

	/**
	 * Returns the value of the '<em><b>OS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>OS</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>OS</em>' containment reference.
	 * @see #setOS(OSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_OS()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='OS' namespace='##targetNamespace'"
	 * @generated
	 */
	OSType getOS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getOS <em>OS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>OS</em>' containment reference.
	 * @see #getOS()
	 * @generated
	 */
	void setOS(OSType value);

	/**
	 * Returns the value of the '<em><b>ECUM</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>ECUM</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>ECUM</em>' containment reference.
	 * @see #setECUM(ECUMType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_ECUM()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='ECUM' namespace='##targetNamespace'"
	 * @generated
	 */
	ECUMType getECUM();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getECUM <em>ECUM</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>ECUM</em>' containment reference.
	 * @see #getECUM()
	 * @generated
	 */
	void setECUM(ECUMType value);

	/**
	 * Returns the value of the '<em><b>SCHM</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>SCHM</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>SCHM</em>' containment reference.
	 * @see #setSCHM(SCHMType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_SCHM()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='SCHM' namespace='##targetNamespace'"
	 * @generated
	 */
	SCHMType getSCHM();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getSCHM <em>SCHM</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SCHM</em>' containment reference.
	 * @see #getSCHM()
	 * @generated
	 */
	void setSCHM(SCHMType value);

	/**
	 * Returns the value of the '<em><b>WATCHDOG</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>WATCHDOG</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>WATCHDOG</em>' containment reference.
	 * @see #setWATCHDOG(WATCHDOGType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_WATCHDOG()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='WATCHDOG' namespace='##targetNamespace'"
	 * @generated
	 */
	WATCHDOGType getWATCHDOG();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getWATCHDOG <em>WATCHDOG</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>WATCHDOG</em>' containment reference.
	 * @see #getWATCHDOG()
	 * @generated
	 */
	void setWATCHDOG(WATCHDOGType value);

	/**
	 * Returns the value of the '<em><b>TIMERS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>TIMERS</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>TIMERS</em>' containment reference.
	 * @see #setTIMERS(TIMERSType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_TIMERS()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='TIMERS' namespace='##targetNamespace'"
	 * @generated
	 */
	TIMERSType getTIMERS();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getTIMERS <em>TIMERS</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>TIMERS</em>' containment reference.
	 * @see #getTIMERS()
	 * @generated
	 */
	void setTIMERS(TIMERSType value);

	/**
	 * Returns the value of the '<em><b>DMA</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DMA</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DMA</em>' containment reference.
	 * @see #setDMA(DMAType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_DMA()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='DMA' namespace='##targetNamespace'"
	 * @generated
	 */
	DMAType getDMA();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDMA <em>DMA</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DMA</em>' containment reference.
	 * @see #getDMA()
	 * @generated
	 */
	void setDMA(DMAType value);

	/**
	 * Returns the value of the '<em><b>LPM</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>LPM</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>LPM</em>' containment reference.
	 * @see #setLPM(LPMType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_LPM()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='LPM' namespace='##targetNamespace'"
	 * @generated
	 */
	LPMType getLPM();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getLPM <em>LPM</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>LPM</em>' containment reference.
	 * @see #getLPM()
	 * @generated
	 */
	void setLPM(LPMType value);

	/**
	 * Returns the value of the '<em><b>UTILITIES</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>UTILITIES</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>UTILITIES</em>' containment reference.
	 * @see #setUTILITIES(UTILITIESType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_UTILITIES()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='UTILITIES' namespace='##targetNamespace'"
	 * @generated
	 */
	UTILITIESType getUTILITIES();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getUTILITIES <em>UTILITIES</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>UTILITIES</em>' containment reference.
	 * @see #getUTILITIES()
	 * @generated
	 */
	void setUTILITIES(UTILITIESType value);

	/**
	 * Returns the value of the '<em><b>SWSEC</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>SWSEC</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>SWSEC</em>' containment reference.
	 * @see #setSWSEC(SWSECType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_SWSEC()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='SWSEC' namespace='##targetNamespace'"
	 * @generated
	 */
	SWSECType getSWSEC();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getSWSEC <em>SWSEC</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SWSEC</em>' containment reference.
	 * @see #getSWSEC()
	 * @generated
	 */
	void setSWSEC(SWSECType value);

	/**
	 * Returns the value of the '<em><b>SPI</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Complete Autosar Spi configuration.
	 * 
	 * This shall be used only to configure new and unsupported SPI devices.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>SPI</em>' containment reference.
	 * @see #setSPI(SPIType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_SPI()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='SPI' namespace='##targetNamespace'"
	 * @generated
	 */
	SPIType getSPI();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getSPI <em>SPI</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>SPI</em>' containment reference.
	 * @see #getSPI()
	 * @generated
	 */
	void setSPI(SPIType value);

	/**
	 * Returns the value of the '<em><b>STD</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Standard files configuration.
	 * MemMap and Compile files are handled by this module.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>STD</em>' containment reference.
	 * @see #setSTD(STDType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_STD()
	 * @model containment="true" required="true"
	 *        extendedMetaData="kind='element' name='STD' namespace='##targetNamespace'"
	 * @generated
	 */
	STDType getSTD();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getSTD <em>STD</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>STD</em>' containment reference.
	 * @see #getSTD()
	 * @generated
	 */
	void setSTD(STDType value);

	/**
	 * Returns the value of the '<em><b>Derivative</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.DerivativeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Subderivative selector. This is used to specify the project's package.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Derivative</em>' attribute.
	 * @see SystemSparcClockMcu.DerivativeType
	 * @see #isSetDerivative()
	 * @see #unsetDerivative()
	 * @see #setDerivative(DerivativeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_Derivative()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='Derivative' namespace='##targetNamespace'"
	 * @generated
	 */
	DerivativeType getDerivative();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDerivative <em>Derivative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Derivative</em>' attribute.
	 * @see SystemSparcClockMcu.DerivativeType
	 * @see #isSetDerivative()
	 * @see #unsetDerivative()
	 * @see #getDerivative()
	 * @generated
	 */
	void setDerivative(DerivativeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDerivative <em>Derivative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDerivative()
	 * @see #getDerivative()
	 * @see #setDerivative(DerivativeType)
	 * @generated
	 */
	void unsetDerivative();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDerivative <em>Derivative</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Derivative</em>' attribute is set.
	 * @see #unsetDerivative()
	 * @see #getDerivative()
	 * @see #setDerivative(DerivativeType)
	 * @generated
	 */
	boolean isSetDerivative();

	/**
	 * Returns the value of the '<em><b>Det Enabled</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Switch to global enable / disable the Development Error Tracer.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Det Enabled</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetDetEnabled()
	 * @see #unsetDetEnabled()
	 * @see #setDetEnabled(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_DetEnabled()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='DetEnabled' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getDetEnabled();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDetEnabled <em>Det Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Det Enabled</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetDetEnabled()
	 * @see #unsetDetEnabled()
	 * @see #getDetEnabled()
	 * @generated
	 */
	void setDetEnabled(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDetEnabled <em>Det Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDetEnabled()
	 * @see #getDetEnabled()
	 * @see #setDetEnabled(TypeBoolean)
	 * @generated
	 */
	void unsetDetEnabled();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDetEnabled <em>Det Enabled</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Det Enabled</em>' attribute is set.
	 * @see #unsetDetEnabled()
	 * @see #getDetEnabled()
	 * @see #setDetEnabled(TypeBoolean)
	 * @generated
	 */
	boolean isSetDetEnabled();

	/**
	 * Returns the value of the '<em><b>Det Ram Buffer Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The size of the DET buffer.
	 * 
	 * The actual size in bytes is DetRamBufferSize * 5.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Det Ram Buffer Size</em>' attribute.
	 * @see #setDetRamBufferSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_DetRamBufferSize()
	 * @model dataType="SystemSparcClockMcu.DetRamBufferSizeType" required="true"
	 *        extendedMetaData="kind='attribute' name='DetRamBufferSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDetRamBufferSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getDetRamBufferSize <em>Det Ram Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Det Ram Buffer Size</em>' attribute.
	 * @see #getDetRamBufferSize()
	 * @generated
	 */
	void setDetRamBufferSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Evt Man Resource Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reference to the OS Resource used by the Event Manager's task.
	 * 
	 * It shall be SWP's FG1 resource.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Evt Man Resource Ref</em>' attribute.
	 * @see #setEvtManResourceRef(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_EvtManResourceRef()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='EvtMan_Resource_Ref' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getEvtManResourceRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getEvtManResourceRef <em>Evt Man Resource Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evt Man Resource Ref</em>' attribute.
	 * @see #getEvtManResourceRef()
	 * @generated
	 */
	void setEvtManResourceRef(Object value);

	/**
	 * Returns the value of the '<em><b>Evt Man Task Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The priority of the Event Manger's task is defined by the value of this attribute. This value has to be understood as a relative value, i.e. the values show only the relative ordering of the tasks.
	 * 
	 * The Event Manager's task must have the priority bigger then the 5ms and 10ms SWP tasks and lower then the others FG1 tasks.
	 * 
	 * OSEK OS defines the lowest priority as zero (0); larger values correspond to higher priorities.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Evt Man Task Priority</em>' attribute.
	 * @see #setEvtManTaskPriority(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_EvtManTaskPriority()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='EvtMan_Task_Priority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getEvtManTaskPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getEvtManTaskPriority <em>Evt Man Task Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evt Man Task Priority</em>' attribute.
	 * @see #getEvtManTaskPriority()
	 * @generated
	 */
	void setEvtManTaskPriority(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Is Evt Man Used</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Used to specify if the Event Managed is used in the system.
	 * 
	 * If configured to Yes, the associated OsEvent and OsTask will be automatically generated and configured.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Is Evt Man Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIsEvtManUsed()
	 * @see #unsetIsEvtManUsed()
	 * @see #setIsEvtManUsed(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_IsEvtManUsed()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='Is_EvtMan_Used' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getIsEvtManUsed();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getIsEvtManUsed <em>Is Evt Man Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Evt Man Used</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetIsEvtManUsed()
	 * @see #unsetIsEvtManUsed()
	 * @see #getIsEvtManUsed()
	 * @generated
	 */
	void setIsEvtManUsed(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getIsEvtManUsed <em>Is Evt Man Used</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIsEvtManUsed()
	 * @see #getIsEvtManUsed()
	 * @see #setIsEvtManUsed(TypeBoolean)
	 * @generated
	 */
	void unsetIsEvtManUsed();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SYSTEMType#getIsEvtManUsed <em>Is Evt Man Used</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Is Evt Man Used</em>' attribute is set.
	 * @see #unsetIsEvtManUsed()
	 * @see #getIsEvtManUsed()
	 * @see #setIsEvtManUsed(TypeBoolean)
	 * @generated
	 */
	boolean isSetIsEvtManUsed();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>"SYSTEM_SPARC"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #isSetName()
	 * @see #unsetName()
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSYSTEMType_Name()
	 * @model default="SYSTEM_SPARC" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.NCName" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #isSetName()
	 * @see #unsetName()
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.SYSTEMType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetName()
	 * @see #getName()
	 * @see #setName(String)
	 * @generated
	 */
	void unsetName();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.SYSTEMType#getName <em>Name</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Name</em>' attribute is set.
	 * @see #unsetName()
	 * @see #getName()
	 * @see #setName(String)
	 * @generated
	 */
	boolean isSetName();

} // SYSTEMType
