/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sporadic Event Conf Attr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.SporadicEventConfAttr#getACTIVATIONPOINTCONF <em>ACTIVATIONPOINTCONF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SporadicEventConfAttr#getCANCELATIONPOINTCONF <em>CANCELATIONPOINTCONF</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SporadicEventConfAttr#getAlarmOrTask <em>Alarm Or Task</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SporadicEventConfAttr#getDelayTime <em>Delay Time</em>}</li>
 *   <li>{@link SystemSparcClockMcu.SporadicEventConfAttr#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr()
 * @model extendedMetaData="name='SporadicEventConf_Attr' kind='elementOnly'"
 * @generated
 */
public interface SporadicEventConfAttr extends EObject {
	/**
	 * Returns the value of the '<em><b>ACTIVATIONPOINTCONF</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.ACTIVATIONPOINTCONFType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains configuration items of ActivationPoints in the context of a BSW module.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>ACTIVATIONPOINTCONF</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr_ACTIVATIONPOINTCONF()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='ACTIVATION_POINT_CONF' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<ACTIVATIONPOINTCONFType> getACTIVATIONPOINTCONF();

	/**
	 * Returns the value of the '<em><b>CANCELATIONPOINTCONF</b></em>' containment reference list.
	 * The list contents are of type {@link SystemSparcClockMcu.CANCELATIONPOINTCONFType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains configuration items of CancelationPoints in the context of a BSW module.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>CANCELATIONPOINTCONF</em>' containment reference list.
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr_CANCELATIONPOINTCONF()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='CANCELATION_POINT_CONF' namespace='##targetNamespace'"
	 * @generated
	 */
	EList<CANCELATIONPOINTCONFType> getCANCELATIONPOINTCONF();

	/**
	 * Returns the value of the '<em><b>Alarm Or Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reference to an alarm or task that will be activated / cancelled sporadically.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Alarm Or Task</em>' attribute.
	 * @see #setAlarmOrTask(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr_AlarmOrTask()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='AlarmOrTask' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getAlarmOrTask();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SporadicEventConfAttr#getAlarmOrTask <em>Alarm Or Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alarm Or Task</em>' attribute.
	 * @see #getAlarmOrTask()
	 * @generated
	 */
	void setAlarmOrTask(Object value);

	/**
	 * Returns the value of the '<em><b>Delay Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The parameter depicts the minimum delay time until a main processing functions shall be activated.
	 * This configuration parameter is an input for integration. It represents the base for the real, implementation specific values.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Delay Time</em>' attribute.
	 * @see #setDelayTime(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr_DelayTime()
	 * @model dataType="SystemSparcClockMcu.DelayTimeType" required="true"
	 *        extendedMetaData="kind='attribute' name='DelayTime' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDelayTime();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SporadicEventConfAttr#getDelayTime <em>Delay Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay Time</em>' attribute.
	 * @see #getDelayTime()
	 * @generated
	 */
	void setDelayTime(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The parameter depicts a symbolic name for the unambiguous identification of a sporadiv event.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSporadicEventConfAttr_Name()
	 * @model dataType="SystemSparcClockMcu.NameType30" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.SporadicEventConfAttr#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

} // SporadicEventConfAttr
