/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>System Clock Select Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getSystemClockSelectType()
 * @model extendedMetaData="name='SystemClockSelect_Type'"
 * @generated
 */
public enum SystemClockSelectType implements Enumerator {
	/**
	 * The '<em><b>Mcu Int Osc RC16M Hz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_INT_OSC_RC16M_HZ_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_INT_OSC_RC16M_HZ(0, "McuIntOscRC16MHz", "McuIntOscRC16MHz"),

	/**
	 * The '<em><b>Mcu Div Int Osc RC16M Hz</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_DIV_INT_OSC_RC16M_HZ_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_DIV_INT_OSC_RC16M_HZ(1, "McuDivIntOscRC16MHz", "McuDivIntOscRC16MHz"),

	/**
	 * The '<em><b>Mcu Ext Quartz Osc</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_EXT_QUARTZ_OSC_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_EXT_QUARTZ_OSC(2, "McuExtQuartzOsc", "McuExtQuartzOsc"),

	/**
	 * The '<em><b>Mcu Div Ext Quartz Osc</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_DIV_EXT_QUARTZ_OSC_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_DIV_EXT_QUARTZ_OSC(3, "McuDivExtQuartzOsc", "McuDivExtQuartzOsc"),

	/**
	 * The '<em><b>Mcu PLL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_PLL_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_PLL(4, "McuPLL", "McuPLL"),

	/**
	 * The '<em><b>Mcu System Clock Disabled</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MCU_SYSTEM_CLOCK_DISABLED_VALUE
	 * @generated
	 * @ordered
	 */
	MCU_SYSTEM_CLOCK_DISABLED(5, "McuSystemClockDisabled", "McuSystemClockDisabled");

	/**
	 * The '<em><b>Mcu Int Osc RC16M Hz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Int Osc RC16M Hz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_INT_OSC_RC16M_HZ
	 * @model name="McuIntOscRC16MHz"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_INT_OSC_RC16M_HZ_VALUE = 0;

	/**
	 * The '<em><b>Mcu Div Int Osc RC16M Hz</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Div Int Osc RC16M Hz</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_DIV_INT_OSC_RC16M_HZ
	 * @model name="McuDivIntOscRC16MHz"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_DIV_INT_OSC_RC16M_HZ_VALUE = 1;

	/**
	 * The '<em><b>Mcu Ext Quartz Osc</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Ext Quartz Osc</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_EXT_QUARTZ_OSC
	 * @model name="McuExtQuartzOsc"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_EXT_QUARTZ_OSC_VALUE = 2;

	/**
	 * The '<em><b>Mcu Div Ext Quartz Osc</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu Div Ext Quartz Osc</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_DIV_EXT_QUARTZ_OSC
	 * @model name="McuDivExtQuartzOsc"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_DIV_EXT_QUARTZ_OSC_VALUE = 3;

	/**
	 * The '<em><b>Mcu PLL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu PLL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_PLL
	 * @model name="McuPLL"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_PLL_VALUE = 4;

	/**
	 * The '<em><b>Mcu System Clock Disabled</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Mcu System Clock Disabled</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MCU_SYSTEM_CLOCK_DISABLED
	 * @model name="McuSystemClockDisabled"
	 * @generated
	 * @ordered
	 */
	public static final int MCU_SYSTEM_CLOCK_DISABLED_VALUE = 5;

	/**
	 * An array of all the '<em><b>System Clock Select Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final SystemClockSelectType[] VALUES_ARRAY =
		new SystemClockSelectType[] {
			MCU_INT_OSC_RC16M_HZ,
			MCU_DIV_INT_OSC_RC16M_HZ,
			MCU_EXT_QUARTZ_OSC,
			MCU_DIV_EXT_QUARTZ_OSC,
			MCU_PLL,
			MCU_SYSTEM_CLOCK_DISABLED,
		};

	/**
	 * A public read-only list of all the '<em><b>System Clock Select Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<SystemClockSelectType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>System Clock Select Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SystemClockSelectType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SystemClockSelectType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>System Clock Select Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SystemClockSelectType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SystemClockSelectType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>System Clock Select Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SystemClockSelectType get(int value) {
		switch (value) {
			case MCU_INT_OSC_RC16M_HZ_VALUE: return MCU_INT_OSC_RC16M_HZ;
			case MCU_DIV_INT_OSC_RC16M_HZ_VALUE: return MCU_DIV_INT_OSC_RC16M_HZ;
			case MCU_EXT_QUARTZ_OSC_VALUE: return MCU_EXT_QUARTZ_OSC;
			case MCU_DIV_EXT_QUARTZ_OSC_VALUE: return MCU_DIV_EXT_QUARTZ_OSC;
			case MCU_PLL_VALUE: return MCU_PLL;
			case MCU_SYSTEM_CLOCK_DISABLED_VALUE: return MCU_SYSTEM_CLOCK_DISABLED;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private SystemClockSelectType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //SystemClockSelectType
