/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TASK Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.TASKType#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType#getTaskFirstActivation <em>Task First Activation</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType#getTaskPeriod <em>Task Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType#getTaskPriority <em>Task Priority</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType()
 * @model extendedMetaData="name='TASK_._type' kind='empty'"
 * @generated
 */
public interface TASKType extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Task identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType_Name()
	 * @model dataType="SystemSparcClockMcu.NameType3" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Task First Activation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the number of 'logical' timer ticks after which this task is activated the first time after low power is entered. 
	 * It can be used for both periodic or non-periodic tasks. For periodic tasks, after the first activation, they will run according to the configured
	 * period. The duration of one 'logical' tick is the equivalent of 32 hardware timer ticks (i.e. 250 us).
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task First Activation</em>' attribute.
	 * @see #setTaskFirstActivation(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType_TaskFirstActivation()
	 * @model dataType="SystemSparcClockMcu.TaskFirstActivationType"
	 *        extendedMetaData="kind='attribute' name='TaskFirstActivation' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskFirstActivation();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType#getTaskFirstActivation <em>Task First Activation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task First Activation</em>' attribute.
	 * @see #getTaskFirstActivation()
	 * @generated
	 */
	void setTaskFirstActivation(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Task Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the period of this task in 'logical' timer ticks. One such tick corresponds to 32 hardware timer ticks (i.e. 250us, since if the STANDARD scheduler
	 * is used, the undivided 128KHz SIRC is always clocking the RTC/API timer).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Period</em>' attribute.
	 * @see #setTaskPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType_TaskPeriod()
	 * @model dataType="SystemSparcClockMcu.TaskPeriodType"
	 *        extendedMetaData="kind='attribute' name='TaskPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType#getTaskPeriod <em>Task Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Period</em>' attribute.
	 * @see #getTaskPeriod()
	 * @generated
	 */
	void setTaskPeriod(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Task Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the priority of the task. Each defined task must have a unique assigned priority. This parameter is meaningful if more
	 * than one task needs to be executed at once. The order of execution depends on the task priority. 0 = highest. 7 = lowest.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Priority</em>' attribute.
	 * @see #setTaskPriority(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType_TaskPriority()
	 * @model dataType="SystemSparcClockMcu.TaskPriorityType"
	 *        extendedMetaData="kind='attribute' name='TaskPriority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType#getTaskPriority <em>Task Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Priority</em>' attribute.
	 * @see #getTaskPriority()
	 * @generated
	 */
	void setTaskPriority(BigInteger value);

} // TASKType
