/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TASK Type1</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getMAINFUNCTIONMAPPING <em>MAINFUNCTIONMAPPING</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getStackSize <em>Stack Size</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskAutostart <em>Task Autostart</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskCycle <em>Task Cycle</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskDelay <em>Task Delay</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskPriority <em>Task Priority</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskResourceRef <em>Task Resource Ref</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType1#getTaskSchedule <em>Task Schedule</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1()
 * @model extendedMetaData="name='TASK_._1_._type' kind='elementOnly'"
 * @generated
 */
public interface TASKType1 extends EObject {
	/**
	 * Returns the value of the '<em><b>MAINFUNCTIONMAPPING</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Configures the functions mapped to this task.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>MAINFUNCTIONMAPPING</em>' containment reference.
	 * @see #setMAINFUNCTIONMAPPING(MAINFUNCTIONMAPPINGType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_MAINFUNCTIONMAPPING()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='MAIN_FUNCTION_MAPPING' namespace='##targetNamespace'"
	 * @generated
	 */
	MAINFUNCTIONMAPPINGType getMAINFUNCTIONMAPPING();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getMAINFUNCTIONMAPPING <em>MAINFUNCTIONMAPPING</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>MAINFUNCTIONMAPPING</em>' containment reference.
	 * @see #getMAINFUNCTIONMAPPING()
	 * @generated
	 */
	void setMAINFUNCTIONMAPPING(MAINFUNCTIONMAPPINGType value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Task name
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_Name()
	 * @model dataType="SystemSparcClockMcu.NameType4" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Stack Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Freescale vendor specific: Defines the size of the task's stack in bytes; Freescale AUTOSAR OS specific attribute (/TASK/STACKSIZE).
	 * 
	 * TBD. Only for extended task. If no event configured, no stack size information needed. Add on on the fly cc.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Stack Size</em>' attribute.
	 * @see #setStackSize(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_StackSize()
	 * @model dataType="SystemSparcClockMcu.StackSizeType"
	 *        extendedMetaData="kind='attribute' name='StackSize' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getStackSize();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getStackSize <em>Stack Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stack Size</em>' attribute.
	 * @see #getStackSize()
	 * @generated
	 */
	void setStackSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Task Autostart</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This determines whether the task is activated during the system start-up procedure or not for some specific application modes.
	 * 
	 * If TaskAutostart is not enabled, the TaskDelay and TaskCycle parameters can be used to automaticaly create an alarm and start it via SchM after OS start.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Autostart</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetTaskAutostart()
	 * @see #unsetTaskAutostart()
	 * @see #setTaskAutostart(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskAutostart()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='TaskAutostart' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getTaskAutostart();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskAutostart <em>Task Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Autostart</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetTaskAutostart()
	 * @see #unsetTaskAutostart()
	 * @see #getTaskAutostart()
	 * @generated
	 */
	void setTaskAutostart(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskAutostart <em>Task Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTaskAutostart()
	 * @see #getTaskAutostart()
	 * @see #setTaskAutostart(TypeBoolean)
	 * @generated
	 */
	void unsetTaskAutostart();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskAutostart <em>Task Autostart</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Task Autostart</em>' attribute is set.
	 * @see #unsetTaskAutostart()
	 * @see #getTaskAutostart()
	 * @see #setTaskAutostart(TypeBoolean)
	 * @generated
	 */
	boolean isSetTaskAutostart();

	/**
	 * Returns the value of the '<em><b>Task Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Task recurence period. The value is given as multiple of main recurence cycles.
	 * 
	 * If TaskAutostart is enabled, this parameter is not used and can be left blank.
	 * 
	 * If left blank, no OS Alarm will be automaticaly defined.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Cycle</em>' attribute.
	 * @see #isSetTaskCycle()
	 * @see #unsetTaskCycle()
	 * @see #setTaskCycle(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskCycle()
	 * @model unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Float"
	 *        extendedMetaData="kind='attribute' name='TaskCycle' namespace='##targetNamespace'"
	 * @generated
	 */
	float getTaskCycle();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskCycle <em>Task Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Cycle</em>' attribute.
	 * @see #isSetTaskCycle()
	 * @see #unsetTaskCycle()
	 * @see #getTaskCycle()
	 * @generated
	 */
	void setTaskCycle(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskCycle <em>Task Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTaskCycle()
	 * @see #getTaskCycle()
	 * @see #setTaskCycle(float)
	 * @generated
	 */
	void unsetTaskCycle();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskCycle <em>Task Cycle</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Task Cycle</em>' attribute is set.
	 * @see #unsetTaskCycle()
	 * @see #getTaskCycle()
	 * @see #setTaskCycle(float)
	 * @generated
	 */
	boolean isSetTaskCycle();

	/**
	 * Returns the value of the '<em><b>Task Delay</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Task starting delay. The value is given as multiple of main recurence cycles.
	 * 
	 * If TaskAutostart is enabled, this parameter is not used and can be left blank.
	 * 
	 * If left blank, no OS Alarm will be automaticaly defined.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Delay</em>' attribute.
	 * @see #isSetTaskDelay()
	 * @see #unsetTaskDelay()
	 * @see #setTaskDelay(float)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskDelay()
	 * @model unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Float"
	 *        extendedMetaData="kind='attribute' name='TaskDelay' namespace='##targetNamespace'"
	 * @generated
	 */
	float getTaskDelay();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskDelay <em>Task Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Delay</em>' attribute.
	 * @see #isSetTaskDelay()
	 * @see #unsetTaskDelay()
	 * @see #getTaskDelay()
	 * @generated
	 */
	void setTaskDelay(float value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskDelay <em>Task Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTaskDelay()
	 * @see #getTaskDelay()
	 * @see #setTaskDelay(float)
	 * @generated
	 */
	void unsetTaskDelay();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskDelay <em>Task Delay</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Task Delay</em>' attribute is set.
	 * @see #unsetTaskDelay()
	 * @see #getTaskDelay()
	 * @see #setTaskDelay(float)
	 * @generated
	 */
	boolean isSetTaskDelay();

	/**
	 * Returns the value of the '<em><b>Task Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The priority of a task is defined by the value of this attribute. This value has to be understood as a relative value, i.e. the values show only the relative ordering of the tasks.
	 * 
	 * OSEK OS defines the lowest priority as zero (0); larger values correspond to higher priorities.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Priority</em>' attribute.
	 * @see #setTaskPriority(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskPriority()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Integer" required="true"
	 *        extendedMetaData="kind='attribute' name='TaskPriority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskPriority <em>Task Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Priority</em>' attribute.
	 * @see #getTaskPriority()
	 * @generated
	 */
	void setTaskPriority(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Task Resource Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This reference defines a list of resources accessed by this task.
	 * 
	 * Limitation:
	 * Only one resource can be used in the current implementation.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Resource Ref</em>' attribute.
	 * @see #setTaskResourceRef(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskResourceRef()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType"
	 *        extendedMetaData="kind='attribute' name='TaskResourceRef' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getTaskResourceRef();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskResourceRef <em>Task Resource Ref</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Resource Ref</em>' attribute.
	 * @see #getTaskResourceRef()
	 * @generated
	 */
	void setTaskResourceRef(Object value);

	/**
	 * Returns the value of the '<em><b>Task Schedule</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TaskScheduleType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The OsTaskSchedule attribute defines the preemptability of the task.
	 * 
	 * If this attribute is set to NON, no internal resources may be assigned to this task.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Schedule</em>' attribute.
	 * @see SystemSparcClockMcu.TaskScheduleType
	 * @see #isSetTaskSchedule()
	 * @see #unsetTaskSchedule()
	 * @see #setTaskSchedule(TaskScheduleType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType1_TaskSchedule()
	 * @model unsettable="true" required="true"
	 *        extendedMetaData="kind='attribute' name='TaskSchedule' namespace='##targetNamespace'"
	 * @generated
	 */
	TaskScheduleType getTaskSchedule();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskSchedule <em>Task Schedule</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Schedule</em>' attribute.
	 * @see SystemSparcClockMcu.TaskScheduleType
	 * @see #isSetTaskSchedule()
	 * @see #unsetTaskSchedule()
	 * @see #getTaskSchedule()
	 * @generated
	 */
	void setTaskSchedule(TaskScheduleType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskSchedule <em>Task Schedule</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTaskSchedule()
	 * @see #getTaskSchedule()
	 * @see #setTaskSchedule(TaskScheduleType)
	 * @generated
	 */
	void unsetTaskSchedule();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.TASKType1#getTaskSchedule <em>Task Schedule</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Task Schedule</em>' attribute is set.
	 * @see #unsetTaskSchedule()
	 * @see #getTaskSchedule()
	 * @see #setTaskSchedule(TaskScheduleType)
	 * @generated
	 */
	boolean isSetTaskSchedule();

} // TASKType1
