/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TASK Type2</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.TASKType2#getName <em>Name</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType2#getTaskPeriod <em>Task Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TASKType2#getTaskPriority <em>Task Priority</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType2()
 * @model extendedMetaData="name='TASK_._2_._type' kind='empty'"
 * @generated
 */
public interface TASKType2 extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Task identification name.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType2_Name()
	 * @model dataType="SystemSparcClockMcu.NameType16" required="true"
	 *        extendedMetaData="kind='attribute' name='Name' namespace='##targetNamespace'"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType2#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Task Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines the number of ticks loaded in the API timer to obtain the periodic wakeup in low power.
	 * If the value of this parameter is 0, no periodic wakeup shall occur while in low power.
	 * If this parameter is different than 0, the LpmTimerConfiguration container shall be used to define the tick duration.
	 * 
	 * This value is expressed in hardware timer ticks.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Period</em>' attribute.
	 * @see #setTaskPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType2_TaskPeriod()
	 * @model dataType="SystemSparcClockMcu.TaskPeriodType1"
	 *        extendedMetaData="kind='attribute' name='TaskPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType2#getTaskPeriod <em>Task Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Period</em>' attribute.
	 * @see #getTaskPeriod()
	 * @generated
	 */
	void setTaskPeriod(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Task Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the priority of the task. Each defined task must have a unique assigned priority. This parameter is meaningful if more
	 * than one task needs to be executed at once. The order of execution depends on the task priority. 0 = highest. 7 = lowest.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Task Priority</em>' attribute.
	 * @see #setTaskPriority(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTASKType2_TaskPriority()
	 * @model dataType="SystemSparcClockMcu.TaskPriorityType1"
	 *        extendedMetaData="kind='attribute' name='TaskPriority' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTaskPriority();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TASKType2#getTaskPriority <em>Task Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task Priority</em>' attribute.
	 * @see #getTaskPriority()
	 * @generated
	 */
	void setTaskPriority(BigInteger value);

} // TASKType2
