/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TIMEOFDAY Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.TIMEOFDAYType#getCalibrationDuration <em>Calibration Duration</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TIMEOFDAYType#getCalibrationPeriod <em>Calibration Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TIMEOFDAYType#getDFAddress <em>DF Address</em>}</li>
 *   <li>{@link SystemSparcClockMcu.TIMEOFDAYType#getGptTimerReference <em>Gpt Timer Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTIMEOFDAYType()
 * @model extendedMetaData="name='TIME_OF_DAY_._type' kind='empty'"
 * @generated
 */
public interface TIMEOFDAYType extends EObject {
	/**
	 * Returns the value of the '<em><b>Calibration Duration</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The calibration duration in LP time units. This parameter specifies the duration of the calibration process that will start each "CalibrationPeriod"
	 * elapses. The longer the calibration, the better the precision.The shorter the calibration, the lower the current consumption. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Calibration Duration</em>' attribute.
	 * @see #setCalibrationDuration(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTIMEOFDAYType_CalibrationDuration()
	 * @model dataType="SystemSparcClockMcu.CalibrationDurationType" required="true"
	 *        extendedMetaData="kind='attribute' name='CalibrationDuration' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getCalibrationDuration();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TIMEOFDAYType#getCalibrationDuration <em>Calibration Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Calibration Duration</em>' attribute.
	 * @see #getCalibrationDuration()
	 * @generated
	 */
	void setCalibrationDuration(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Calibration Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The calibration period in LP time units.  Every 'CalibrationPeriod' time units, the calibration process will be started while the system is in low power.
	 *  If the period is longer, current consumption is lowered, but the precision decreases. If the period is shorter, the precision is better, but the current
	 * consumption is increased.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Calibration Period</em>' attribute.
	 * @see #setCalibrationPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTIMEOFDAYType_CalibrationPeriod()
	 * @model dataType="SystemSparcClockMcu.CalibrationPeriodType" required="true"
	 *        extendedMetaData="kind='attribute' name='CalibrationPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getCalibrationPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TIMEOFDAYType#getCalibrationPeriod <em>Calibration Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Calibration Period</em>' attribute.
	 * @see #getCalibrationPeriod()
	 * @generated
	 */
	void setCalibrationPeriod(BigInteger value);

	/**
	 * Returns the value of the '<em><b>DF Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter defines a physical flash address that will contain a constant value. This value represents the difference in frequency (Hz)
	 * between the expected value and the measured value of the main oscillator after the manufacturing calibration. The configuration of this
	 * parameter is OPTIONAL. Leave it blank if it does not need to be configured.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>DF Address</em>' attribute.
	 * @see #setDFAddress(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTIMEOFDAYType_DFAddress()
	 * @model dataType="SystemSparcClockMcu.DFAddressType"
	 *        extendedMetaData="kind='attribute' name='DFAddress' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getDFAddress();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TIMEOFDAYType#getDFAddress <em>DF Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DF Address</em>' attribute.
	 * @see #getDFAddress()
	 * @generated
	 */
	void setDFAddress(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Gpt Timer Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reference to the PIT timer configured for HP notification.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Gpt Timer Reference</em>' attribute.
	 * @see #setGptTimerReference(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTIMEOFDAYType_GptTimerReference()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType" required="true"
	 *        extendedMetaData="kind='attribute' name='Gpt_Timer_Reference' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getGptTimerReference();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.TIMEOFDAYType#getGptTimerReference <em>Gpt Timer Reference</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gpt Timer Reference</em>' attribute.
	 * @see #getGptTimerReference()
	 * @generated
	 */
	void setGptTimerReference(Object value);

} // TIMEOFDAYType
