/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Timer Clock Configuration Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getTimerClockConfigurationType()
 * @model extendedMetaData="name='TimerClockConfiguration_._type'"
 * @generated
 */
public enum TimerClockConfigurationType implements Enumerator {
	/**
	 * The '<em><b>CLOCK16MHZIRC</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK16MHZIRC_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK16MHZIRC(0, "CLOCK16MHZIRC", "CLOCK_16MHZ_IRC"),

	/**
	 * The '<em><b>CLOCK128KHZIRC</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK128KHZIRC_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK128KHZIRC(1, "CLOCK128KHZIRC", "CLOCK_128KHZ_IRC"),

	/**
	 * The '<em><b>CLOCK32KHZOSC</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CLOCK32KHZOSC_VALUE
	 * @generated
	 * @ordered
	 */
	CLOCK32KHZOSC(2, "CLOCK32KHZOSC", "CLOCK_32KHZ_OSC");

	/**
	 * The '<em><b>CLOCK16MHZIRC</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CLOCK16MHZIRC</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK16MHZIRC
	 * @model literal="CLOCK_16MHZ_IRC"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK16MHZIRC_VALUE = 0;

	/**
	 * The '<em><b>CLOCK128KHZIRC</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CLOCK128KHZIRC</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK128KHZIRC
	 * @model literal="CLOCK_128KHZ_IRC"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK128KHZIRC_VALUE = 1;

	/**
	 * The '<em><b>CLOCK32KHZOSC</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CLOCK32KHZOSC</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CLOCK32KHZOSC
	 * @model literal="CLOCK_32KHZ_OSC"
	 * @generated
	 * @ordered
	 */
	public static final int CLOCK32KHZOSC_VALUE = 2;

	/**
	 * An array of all the '<em><b>Timer Clock Configuration Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TimerClockConfigurationType[] VALUES_ARRAY =
		new TimerClockConfigurationType[] {
			CLOCK16MHZIRC,
			CLOCK128KHZIRC,
			CLOCK32KHZOSC,
		};

	/**
	 * A public read-only list of all the '<em><b>Timer Clock Configuration Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<TimerClockConfigurationType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Timer Clock Configuration Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TimerClockConfigurationType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TimerClockConfigurationType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Timer Clock Configuration Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TimerClockConfigurationType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TimerClockConfigurationType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Timer Clock Configuration Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TimerClockConfigurationType get(int value) {
		switch (value) {
			case CLOCK16MHZIRC_VALUE: return CLOCK16MHZIRC;
			case CLOCK128KHZIRC_VALUE: return CLOCK128KHZIRC;
			case CLOCK32KHZOSC_VALUE: return CLOCK32KHZOSC;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TimerClockConfigurationType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //TimerClockConfigurationType
