/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>WATCHDOGMANAGER Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getALIVESUPERVISION <em>ALIVESUPERVISION</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getDemAliveSupervisionReport <em>Dem Alive Supervision Report</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getImmediateReset <em>Immediate Reset</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getMode <em>Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getSlowTriggerPeriod <em>Slow Trigger Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getUsesRTE <em>Uses RTE</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType()
 * @model extendedMetaData="name='WATCHDOG_MANAGER_._type' kind='elementOnly'"
 * @generated
 */
public interface WATCHDOGMANAGERType extends EObject {
	/**
	 * Returns the value of the '<em><b>ALIVESUPERVISION</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Container for a management structure to configure the alive-supervision of the Watchdog Manager.
	 * 
	 * Creating this container enables the Alive Supervision feature.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>ALIVESUPERVISION</em>' containment reference.
	 * @see #setALIVESUPERVISION(ALIVESUPERVISIONType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_ALIVESUPERVISION()
	 * @model containment="true"
	 *        extendedMetaData="kind='element' name='ALIVE_SUPERVISION' namespace='##targetNamespace'"
	 * @generated
	 */
	ALIVESUPERVISIONType getALIVESUPERVISION();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getALIVESUPERVISION <em>ALIVESUPERVISION</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>ALIVESUPERVISION</em>' containment reference.
	 * @see #getALIVESUPERVISION()
	 * @generated
	 */
	void setALIVESUPERVISION(ALIVESUPERVISIONType value);

	/**
	 * Returns the value of the '<em><b>Dem Alive Supervision Report</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Parameter to enable/disable alive-supervision error reporting to DEM.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dem Alive Supervision Report</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetDemAliveSupervisionReport()
	 * @see #unsetDemAliveSupervisionReport()
	 * @see #setDemAliveSupervisionReport(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_DemAliveSupervisionReport()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='DemAliveSupervisionReport' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getDemAliveSupervisionReport();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getDemAliveSupervisionReport <em>Dem Alive Supervision Report</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dem Alive Supervision Report</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetDemAliveSupervisionReport()
	 * @see #unsetDemAliveSupervisionReport()
	 * @see #getDemAliveSupervisionReport()
	 * @generated
	 */
	void setDemAliveSupervisionReport(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getDemAliveSupervisionReport <em>Dem Alive Supervision Report</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDemAliveSupervisionReport()
	 * @see #getDemAliveSupervisionReport()
	 * @see #setDemAliveSupervisionReport(TypeBoolean)
	 * @generated
	 */
	void unsetDemAliveSupervisionReport();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getDemAliveSupervisionReport <em>Dem Alive Supervision Report</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dem Alive Supervision Report</em>' attribute is set.
	 * @see #unsetDemAliveSupervisionReport()
	 * @see #getDemAliveSupervisionReport()
	 * @see #setDemAliveSupervisionReport(TypeBoolean)
	 * @generated
	 */
	boolean isSetDemAliveSupervisionReport();

	/**
	 * Returns the value of the '<em><b>Immediate Reset</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter enables/disablse the immediate reset feature in case of alive-supervision failure.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Immediate Reset</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetImmediateReset()
	 * @see #unsetImmediateReset()
	 * @see #setImmediateReset(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_ImmediateReset()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='ImmediateReset' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getImmediateReset();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getImmediateReset <em>Immediate Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Immediate Reset</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetImmediateReset()
	 * @see #unsetImmediateReset()
	 * @see #getImmediateReset()
	 * @generated
	 */
	void setImmediateReset(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getImmediateReset <em>Immediate Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetImmediateReset()
	 * @see #getImmediateReset()
	 * @see #setImmediateReset(TypeBoolean)
	 * @generated
	 */
	void unsetImmediateReset();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getImmediateReset <em>Immediate Reset</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Immediate Reset</em>' attribute is set.
	 * @see #unsetImmediateReset()
	 * @see #getImmediateReset()
	 * @see #setImmediateReset(TypeBoolean)
	 * @generated
	 */
	boolean isSetImmediateReset();

	/**
	 * Returns the value of the '<em><b>Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.ModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The parameter sets the initial-mode of the Watchdog Manager.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mode</em>' attribute.
	 * @see SystemSparcClockMcu.ModeType
	 * @see #isSetMode()
	 * @see #unsetMode()
	 * @see #setMode(ModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_Mode()
	 * @model unsettable="true"
	 *        extendedMetaData="kind='attribute' name='Mode' namespace='##targetNamespace'"
	 * @generated
	 */
	ModeType getMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getMode <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mode</em>' attribute.
	 * @see SystemSparcClockMcu.ModeType
	 * @see #isSetMode()
	 * @see #unsetMode()
	 * @see #getMode()
	 * @generated
	 */
	void setMode(ModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getMode <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetMode()
	 * @see #getMode()
	 * @see #setMode(ModeType)
	 * @generated
	 */
	void unsetMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getMode <em>Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Mode</em>' attribute is set.
	 * @see #unsetMode()
	 * @see #getMode()
	 * @see #setMode(ModeType)
	 * @generated
	 */
	boolean isSetMode();

	/**
	 * Returns the value of the '<em><b>Slow Trigger Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specifies the recurence of the Wathcdog Manager Trigger function in SLOW mode.
	 * 
	 * This is used to calculate the needed slow reference cycle for the configured watchdogs.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Slow Trigger Period</em>' attribute.
	 * @see #setSlowTriggerPeriod(Object)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_SlowTriggerPeriod()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.AnySimpleType"
	 *        extendedMetaData="kind='attribute' name='SlowTriggerPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	Object getSlowTriggerPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getSlowTriggerPeriod <em>Slow Trigger Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Slow Trigger Period</em>' attribute.
	 * @see #getSlowTriggerPeriod()
	 * @generated
	 */
	void setSlowTriggerPeriod(Object value);

	/**
	 * Returns the value of the '<em><b>Uses RTE</b></em>' attribute.
	 * The default value is <code>"Yes"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This parameter specifies if the WdgM uses the RTE interface at module level, not at supervised entity level.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Uses RTE</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetUsesRTE()
	 * @see #unsetUsesRTE()
	 * @see #setUsesRTE(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWATCHDOGMANAGERType_UsesRTE()
	 * @model default="Yes" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='UsesRTE' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getUsesRTE();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getUsesRTE <em>Uses RTE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Uses RTE</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetUsesRTE()
	 * @see #unsetUsesRTE()
	 * @see #getUsesRTE()
	 * @generated
	 */
	void setUsesRTE(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getUsesRTE <em>Uses RTE</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetUsesRTE()
	 * @see #getUsesRTE()
	 * @see #setUsesRTE(TypeBoolean)
	 * @generated
	 */
	void unsetUsesRTE();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WATCHDOGMANAGERType#getUsesRTE <em>Uses RTE</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Uses RTE</em>' attribute is set.
	 * @see #unsetUsesRTE()
	 * @see #getUsesRTE()
	 * @see #setUsesRTE(TypeBoolean)
	 * @generated
	 */
	boolean isSetUsesRTE();

} // WATCHDOGMANAGERType
