/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Wdg Mode Settings Attr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SystemSparcClockMcu.WdgModeSettingsAttr#getOperationMode <em>Operation Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WdgModeSettingsAttr#getResetOnInvalidAccess <em>Reset On Invalid Access</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WdgModeSettingsAttr#getRunInStopMode <em>Run In Stop Mode</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WdgModeSettingsAttr#getTimeoutPeriod <em>Timeout Period</em>}</li>
 *   <li>{@link SystemSparcClockMcu.WdgModeSettingsAttr#getWindowMode <em>Window Mode</em>}</li>
 * </ul>
 * </p>
 *
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr()
 * @model extendedMetaData="name='WdgModeSettings_Attr' kind='empty'"
 * @generated
 */
public interface WdgModeSettingsAttr extends EObject {
	/**
	 * Returns the value of the '<em><b>Operation Mode</b></em>' attribute.
	 * The default value is <code>"ResetOnTimeOut"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.WdgOperationType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * WdgOperationMode.This is the Implementation Specific parameter.
	 * ResetOnTimeOut:      If a time out occurs, the SWT generates a system reset
	 * Interrupt:          The first time out generates an interrupt to the processor, and if not serviced, then a second time out generates a system reset.
	 * Note: While in STOP0 mode, if the SWT is configured to generate an interrupt and the system clock is disabled
	 * (ME_STOP0_MC[SYSCLK] = 0xF), a SWT interrupt event will not trigger an exit from STOP0 mode.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Operation Mode</em>' attribute.
	 * @see SystemSparcClockMcu.WdgOperationType
	 * @see #isSetOperationMode()
	 * @see #unsetOperationMode()
	 * @see #setOperationMode(WdgOperationType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr_OperationMode()
	 * @model default="ResetOnTimeOut" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='OperationMode' namespace='##targetNamespace'"
	 * @generated
	 */
	WdgOperationType getOperationMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getOperationMode <em>Operation Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operation Mode</em>' attribute.
	 * @see SystemSparcClockMcu.WdgOperationType
	 * @see #isSetOperationMode()
	 * @see #unsetOperationMode()
	 * @see #getOperationMode()
	 * @generated
	 */
	void setOperationMode(WdgOperationType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getOperationMode <em>Operation Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOperationMode()
	 * @see #getOperationMode()
	 * @see #setOperationMode(WdgOperationType)
	 * @generated
	 */
	void unsetOperationMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getOperationMode <em>Operation Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Operation Mode</em>' attribute is set.
	 * @see #unsetOperationMode()
	 * @see #getOperationMode()
	 * @see #setOperationMode(WdgOperationType)
	 * @generated
	 */
	boolean isSetOperationMode();

	/**
	 * Returns the value of the '<em><b>Reset On Invalid Access</b></em>' attribute.
	 * The default value is <code>"SystemReset"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.WdgResetOnInvalidAccessType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reset On InvalidAccess. If window mode is enabled, the service sequence must be 
	 * performed in the last part of the window time out period. The window is open when
	 * the down counter is less than the value in the SWT_WN register. Outside of this window, 
	 * service sequence writes are invalid access and generate:
	 * BUS error:      Invalid access to the SWT generated a bus error
	 * System Reset:   Invalid access to the SWT causes a system reset (if wathdog is enabled)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Reset On Invalid Access</em>' attribute.
	 * @see SystemSparcClockMcu.WdgResetOnInvalidAccessType
	 * @see #isSetResetOnInvalidAccess()
	 * @see #unsetResetOnInvalidAccess()
	 * @see #setResetOnInvalidAccess(WdgResetOnInvalidAccessType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr_ResetOnInvalidAccess()
	 * @model default="SystemReset" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='ResetOnInvalidAccess' namespace='##targetNamespace'"
	 * @generated
	 */
	WdgResetOnInvalidAccessType getResetOnInvalidAccess();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getResetOnInvalidAccess <em>Reset On Invalid Access</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reset On Invalid Access</em>' attribute.
	 * @see SystemSparcClockMcu.WdgResetOnInvalidAccessType
	 * @see #isSetResetOnInvalidAccess()
	 * @see #unsetResetOnInvalidAccess()
	 * @see #getResetOnInvalidAccess()
	 * @generated
	 */
	void setResetOnInvalidAccess(WdgResetOnInvalidAccessType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getResetOnInvalidAccess <em>Reset On Invalid Access</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetResetOnInvalidAccess()
	 * @see #getResetOnInvalidAccess()
	 * @see #setResetOnInvalidAccess(WdgResetOnInvalidAccessType)
	 * @generated
	 */
	void unsetResetOnInvalidAccess();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getResetOnInvalidAccess <em>Reset On Invalid Access</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Reset On Invalid Access</em>' attribute is set.
	 * @see #unsetResetOnInvalidAccess()
	 * @see #getResetOnInvalidAccess()
	 * @see #setResetOnInvalidAccess(WdgResetOnInvalidAccessType)
	 * @generated
	 */
	boolean isSetResetOnInvalidAccess();

	/**
	 * Returns the value of the '<em><b>Run In Stop Mode</b></em>' attribute.
	 * The default value is <code>"No"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.TypeBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * WdgRunWhileHalted.This is the Implementation Specific parameter.
	 * Enabled:       SWT continues to count even while the processor core is in stop mode.
	 * Disabled:      SWT stops counting if the processor core is in stop mode.
	 * Note:  the 'WdgRunWhileHalted' parameter specifies if the watchdog timer should run or not while the clock to the core is halted. 
	 * This is true only for the STOP0 mode of the controller. It will always run while the controller is in the HALT0 mode.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Run In Stop Mode</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRunInStopMode()
	 * @see #unsetRunInStopMode()
	 * @see #setRunInStopMode(TypeBoolean)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr_RunInStopMode()
	 * @model default="No" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='RunInStopMode' namespace='##targetNamespace'"
	 * @generated
	 */
	TypeBoolean getRunInStopMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getRunInStopMode <em>Run In Stop Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Run In Stop Mode</em>' attribute.
	 * @see SystemSparcClockMcu.TypeBoolean
	 * @see #isSetRunInStopMode()
	 * @see #unsetRunInStopMode()
	 * @see #getRunInStopMode()
	 * @generated
	 */
	void setRunInStopMode(TypeBoolean value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getRunInStopMode <em>Run In Stop Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRunInStopMode()
	 * @see #getRunInStopMode()
	 * @see #setRunInStopMode(TypeBoolean)
	 * @generated
	 */
	void unsetRunInStopMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getRunInStopMode <em>Run In Stop Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Run In Stop Mode</em>' attribute is set.
	 * @see #unsetRunInStopMode()
	 * @see #getRunInStopMode()
	 * @see #setRunInStopMode(TypeBoolean)
	 * @generated
	 */
	boolean isSetRunInStopMode();

	/**
	 * Returns the value of the '<em><b>Timeout Period</b></em>' attribute.
	 * The default value is <code>"1280"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * WdgTimeoutPeriod.This is the Implementation Specific parameter.
	 * Software Watchdog Time-Out Period in clock cycles. An internal 32-bit down counter is loaded with this value or 0x100 which
	 * ever is greater when the service sequence is written or when the SWT is enabled.Selects the time-out period for the SWT.
	 * 
	 * The timout is in ms (runs @128kHz).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Timeout Period</em>' attribute.
	 * @see #isSetTimeoutPeriod()
	 * @see #unsetTimeoutPeriod()
	 * @see #setTimeoutPeriod(BigInteger)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr_TimeoutPeriod()
	 * @model default="1280" unsettable="true" dataType="SystemSparcClockMcu.TimeoutPeriodType"
	 *        extendedMetaData="kind='attribute' name='TimeoutPeriod' namespace='##targetNamespace'"
	 * @generated
	 */
	BigInteger getTimeoutPeriod();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getTimeoutPeriod <em>Timeout Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timeout Period</em>' attribute.
	 * @see #isSetTimeoutPeriod()
	 * @see #unsetTimeoutPeriod()
	 * @see #getTimeoutPeriod()
	 * @generated
	 */
	void setTimeoutPeriod(BigInteger value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getTimeoutPeriod <em>Timeout Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTimeoutPeriod()
	 * @see #getTimeoutPeriod()
	 * @see #setTimeoutPeriod(BigInteger)
	 * @generated
	 */
	void unsetTimeoutPeriod();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getTimeoutPeriod <em>Timeout Period</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Timeout Period</em>' attribute is set.
	 * @see #unsetTimeoutPeriod()
	 * @see #getTimeoutPeriod()
	 * @see #setTimeoutPeriod(BigInteger)
	 * @generated
	 */
	boolean isSetTimeoutPeriod();

	/**
	 * Returns the value of the '<em><b>Window Mode</b></em>' attribute.
	 * The default value is <code>"WindowMode_Disabled"</code>.
	 * The literals are from the enumeration {@link SystemSparcClockMcu.WindowModeType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Wdg WindowMode. 
	 * Disabled:   SWTWND Regular mode, service sequence can be done at any time
	 * Enabled:  SWTWND Windowed mode, the service sequence is only valid when the down counter is less than value in the SWTWN register.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Window Mode</em>' attribute.
	 * @see SystemSparcClockMcu.WindowModeType
	 * @see #isSetWindowMode()
	 * @see #unsetWindowMode()
	 * @see #setWindowMode(WindowModeType)
	 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWdgModeSettingsAttr_WindowMode()
	 * @model default="WindowMode_Disabled" unsettable="true"
	 *        extendedMetaData="kind='attribute' name='WindowMode' namespace='##targetNamespace'"
	 * @generated
	 */
	WindowModeType getWindowMode();

	/**
	 * Sets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getWindowMode <em>Window Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Window Mode</em>' attribute.
	 * @see SystemSparcClockMcu.WindowModeType
	 * @see #isSetWindowMode()
	 * @see #unsetWindowMode()
	 * @see #getWindowMode()
	 * @generated
	 */
	void setWindowMode(WindowModeType value);

	/**
	 * Unsets the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getWindowMode <em>Window Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetWindowMode()
	 * @see #getWindowMode()
	 * @see #setWindowMode(WindowModeType)
	 * @generated
	 */
	void unsetWindowMode();

	/**
	 * Returns whether the value of the '{@link SystemSparcClockMcu.WdgModeSettingsAttr#getWindowMode <em>Window Mode</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Window Mode</em>' attribute is set.
	 * @see #unsetWindowMode()
	 * @see #getWindowMode()
	 * @see #setWindowMode(WindowModeType)
	 * @generated
	 */
	boolean isSetWindowMode();

} // WdgModeSettingsAttr
