/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SystemSparcClockMcu;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Window Mode Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see SystemSparcClockMcu.SystemSparcClockMcuPackage#getWindowModeType()
 * @model extendedMetaData="name='WindowMode_._type'"
 * @generated
 */
public enum WindowModeType implements Enumerator {
	/**
	 * The '<em><b>Window Mode Disabled</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE_DISABLED_VALUE
	 * @generated
	 * @ordered
	 */
	WINDOW_MODE_DISABLED(0, "WindowModeDisabled", "WindowMode_Disabled"),

	/**
	 * The '<em><b>Window Mode50</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE50_VALUE
	 * @generated
	 * @ordered
	 */
	WINDOW_MODE50(1, "WindowMode50", "WindowMode_50%"),

	/**
	 * The '<em><b>Window Mode75</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE75_VALUE
	 * @generated
	 * @ordered
	 */
	WINDOW_MODE75(2, "WindowMode75", "WindowMode_75%");

	/**
	 * The '<em><b>Window Mode Disabled</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Window Mode Disabled</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE_DISABLED
	 * @model name="WindowModeDisabled" literal="WindowMode_Disabled"
	 * @generated
	 * @ordered
	 */
	public static final int WINDOW_MODE_DISABLED_VALUE = 0;

	/**
	 * The '<em><b>Window Mode50</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Window Mode50</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE50
	 * @model name="WindowMode50" literal="WindowMode_50%"
	 * @generated
	 * @ordered
	 */
	public static final int WINDOW_MODE50_VALUE = 1;

	/**
	 * The '<em><b>Window Mode75</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Window Mode75</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #WINDOW_MODE75
	 * @model name="WindowMode75" literal="WindowMode_75%"
	 * @generated
	 * @ordered
	 */
	public static final int WINDOW_MODE75_VALUE = 2;

	/**
	 * An array of all the '<em><b>Window Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final WindowModeType[] VALUES_ARRAY =
		new WindowModeType[] {
			WINDOW_MODE_DISABLED,
			WINDOW_MODE50,
			WINDOW_MODE75,
		};

	/**
	 * A public read-only list of all the '<em><b>Window Mode Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<WindowModeType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Window Mode Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static WindowModeType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			WindowModeType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Window Mode Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static WindowModeType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			WindowModeType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Window Mode Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static WindowModeType get(int value) {
		switch (value) {
			case WINDOW_MODE_DISABLED_VALUE: return WINDOW_MODE_DISABLED;
			case WINDOW_MODE50_VALUE: return WINDOW_MODE50;
			case WINDOW_MODE75_VALUE: return WINDOW_MODE75;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private WindowModeType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //WindowModeType
